use32
;//cpu 686

;// DLL - compile into DLL ?
%define DLL

;// Debug version - stop on most errors...
;// When the thread or main thread stops on error, it consumes max cpu...
;// it can be inspected by TaskView from ThreadView or MemView...
;// to release the stopped program and continue running, open memory editor
;// (from ThreadView on right side on EIP register, right click select View memory)
;// and replace bytes EB FE with bytes 90 90 using F4 , edit..., then commit changes by F2 ...
;//%define Debug

;// In Release version, avoid debugging stops:
%ifndef Debug
  %define ReleaseVer
%endif

;// MINIMM_PAGEALIGNED - alloc page-aligned sizes at page-aligned addresses?
%define MINIMM_PAGEALIGNED

;// USE_IMalloc - IMalloc interface on pool -- problem with code offsets
;//%define USE_IMalloc

;// USE_IMemPool - IMemPool interface on pool -- problem with code offsets
;//%define USE_IMemPool

%ifdef USE_IMalloc
  %define USE_Interface
%endif

%ifdef USE_IMemPool
  %define USE_Interface
%endif

;// Start_TEST - test some allocation at DLL startup
%define Start_TEST

;// Link_MOZGLUE - revector mozglue.dll malloc functions
%define Link_MOZGLUE
%define Palemoon

;// Link_MSVCRT - revector heap functions in old msvcrt.dll , used by some system modules and old dlls...
%define Link_MSVCRT

;// Link_AltD5 - set TMemoryManager in AltD5.bpl - used for testing...
%define Link_AltD5

;// Poison_Free - as in original mozglue.dll , fill free memory with E5 byte beside allocator links
;// (now it rather fills FE EE FE EE pattern, and in first dword there is displaced low word of address)
;// also notice, that memory manager has links to next-prev free block inside free memory
;// but to avoid having direct pointers, they are relative offsets in mid-blocks or in-page byte index for small blocks
%define Poison_Free

;// AllocTag - tag middle and large blocks by address of caller of malloc() ...
;// requires SSE2 and does not check if it is available -- this is only for controlled debugging...
;//%define AllocTag

;// ArenaPool - allocate 8kb pages separately... (used by PL_Arena in PaleMoon)
%define ArenaPool

;// MidLinear - use linear free-list for MidTypes... //New240315 since v20 , older code was removed...
%define MidLinear

;// MicroAlloc - different allocation for very small items //New240318 since v21
%define MicroAlloc

;// Use ONLY page-aligned allocations for large blocks
%ifdef Link_MOZGLUE
  %define LargeOnlyPA
  %define MINIMM_PAGEALIGNED
%endif

;// ErrHalt - halt on various errors...
%define ErrHalt

;// Halt_Except - halt on exceptions (for debugging)
%define Halt_Except

%ifdef ReleaseVer
  %undef ErrHalt
  %undef Halt_Except
  ;//%undef AllocTag  ;// AllocTag is only for debugging...?
%endif ;//ReleaseVer

;// MicroAlloc requires MidLinear
%ifndef MidLinear
  ;//%undef MicroAlloc
  %define MidLinear
%endif

%define pe_ImageBase 0FB50000h
%define def_InitPool 0FB10000h
%define def_InitMvp  0FB20000h
%define def_VSpace_Size 400000h ;// 4Mb
%define def_PgMap    0FA40000h

%ifdef ArenaPool
;//%define def_ArenaPoolSize 100000h ;// 1Mb, 128*8kb arenas, 16-byte bitmap
%define def_ArenaPoolSize 80000h ;// 512kb, 64*8kb arenas, 8-byte bitmap
%define def_ArenaPoolBase 0FB30000h
%endif ;ArenaPool

;// Log allocator operations in cyclic 8Mb buffer at 0F000000h, with write pointer at 0FB5803Ch
;//%define LogAlloc

%ifdef LogAlloc
  ;// sector-round additional code reserve for logging...
  %define Size_Log 400h
%else
  %ifdef AllocTag
    %define Size_Log 0  ;// at some versions AllocTag version also overflows code reserve
  %else
    %define Size_Log 0
  %endif
%endif

%ifdef MicroAlloc
  %define Size_Micro 200h
%else
  %define Size_Micro 0
%endif

%define Size_Temp 0

;//not possible: end_Code equ (__end_Code - start_Code)
end_Code equ 3C00h + Size_Log + Size_Micro + Size_Temp


%ifdef DLL
%include "MozMem_dllHeader.inc"
%endif ;DLL

;// start of CODE segment:
;//seg_Code  equ 0FB51000h
;// pe_ImageBase defined in MozMem_dllHeader
seg_Code  equ pe_ImageBase + 1000h
start_Code equ $

%ifdef DLL
;// rva_Bss defined in MozMem_dllHeader.inc
seg_Data  equ pe_ImageBase + rva_Bss
%else ;!DLL
seg_Data  equ pe_ImageBase + 8000h
%endif ;!DLL

%ifdef Link_MOZGLUE
%define C_MEM_Handlers
%endif ;Link_MOZGLUE

%ifdef Link_MSVCRT
%define C_MEM_Handlers
%endif ;Link_MSVCRT

;// offset from start_Code to rva in CODE segment:
code_ToRva equ 1000h

;// Code segment entry:
;// dll entry:

%ifdef DLL
jmp dll_Entry
%endif ;DLL

;// or opaque block returns main Pool on entry:
;// in DLL it is at offset 1005h
;// void* __stdcall MozMem(HANDLE hKernel)
jmp MmEntryMainPool

%ifdef DLL
;// in DLL there may be GetModuleHandleA function supplied by imports:
imp_GetModuleHandle equ (seg_Code+ ($-start_Code))
dd 0
%endif

;//--------------------------------------------------------------------
;// type TMmVirtPager
vp_AllocRawPage    equ 0
vp_ReleaseRawPage  equ 4
vp_Arg             equ 8
vp_ReInit          equ 12
vp_Shutdown        equ 16
vp__sizeOf         equ 20

;// type TMmPage - 32 byte page header:
mp_Signature       equ 0   ;// = cMmPageSign = 0A96750B5h
   cMmPageSign equ 0A96750B5h
mp_NextFreePage    equ 4   ;// Pointer or nil
mp_Typ             equ 8   ;// PMmType
mp_ItemSize        equ 12  ;// Byte ItemSize shr 4
mp_FreeCount       equ 13  ;// Byte
mp_FreeList        equ 14  ;// Byte
mp_MaxFreeCount    equ 15  ;// Byte
mp_FreeLink        equ 16  ;// TListEntry
  mp_FreeLink_Next   equ 16
  mp_FreeLink_Prev   equ 20
mp_SmallPageLink   equ 24  ;// TListEntry
  mp_SmallPage_Next  equ 24
  mp_SmallPage_Prev  equ 28

;// type TMmType
mt_Signature       equ 0   ;// = cMmTypeSign = 0A970DEB5h
   cMmTypeSign equ 0A970DEB5h
mt_FreePages       equ 4   ;// Pointer
mt_CheckAligned    equ 8   ;// TCheckAlignedProc = function(P): Pointer // eax=Item, edx=Page, ecx=Typ
mt_Pool            equ 12  ;// PMmPool
mt_ItemSize        equ 16  ;// Byte ItemSize shr 4
mt_DefFreeCount    equ 17  ;// Byte
mt_DefFreeList     equ 18  ;// Byte
mt_MaxFreeCount    equ 19  ;//
mt__sizeOf         equ 20

;// type TMmLargePage
%ifndef LargeOnlyPA
mlp_Signature      equ 0   ;// = cMmLargePageSign = 0A950BBB5h
   cMmLargePageSign equ 0A950BBB5h
mlp_Size           equ 4   ;// DWORD
mlp_Capacity       equ 8   ;// DWORD
mlp_Pool           equ 12  ;// PMmPool
mlp_Data           equ 16  ;// here starts data...
%endif

;// type TMmMidType
mmt_OffsNext       equ 0   ;// Longint
mmt_OffsPrior      equ 4   ;// Longint
mmt_MinSize        equ 8   ;// Longint
mmt_Pad            equ 12  ;// Longint
mmt__sizeShift     equ 4
mmt__sizeOf        equ (1 << mmt__sizeShift) ;//16

;// TMmMidTypeTable array[8] of TMmMidType

;// type TMmPool
mpool_Signature    equ 0    ;// = cMmPoolSign = 0A970AAB5h
   cMmPoolSign equ 0A970AAB5h
mpool_VirtPool     equ 4    ;// TMmVirtPager
mpool_SmallTypes   equ 24   ;// array[17] of PMmType
mpool_MidLock      equ 92   ;// TRtlCriticalSection = 6 dwords...
mpool_AllocProc    equ 116  ;// either MmAlloc or MmAllocStartup
mpool_MidPage      equ 120  ;// Pointer
%ifdef MidLinear
mpool_MidFreeList  equ  124
  %ifdef MicroAlloc
  mpool_MicroPool  equ  144 ;// ^TMmMicroPool
  %endif ;MicroAlloc
%else ;//old x20
mpool_MidTypes     equ 124  ;// PMmMidTypeTable
mpool_MidTypeCount equ 128  ;// integer
mpool_MidTypeMin   equ 132  ;// integer MidTypes_MinSize
mpool_Mmx_MinSize  equ 136  ;// integer MidMax_MinSize
mpool_Mmx_OffsNext equ 140  ;// integer MidMax_OffsNext
mpool_Mmx_OffsPrev equ 144  ;// integer MidMax_OffsPrior
%endif ;old
;//mpool_AlignedList  equ 148  ;// Pointer - unused since v17
mpool_AlignedCount equ 152  ;// integer
;//x240216: mpool_Owner        equ 156  ;// Pointer, opaque
mpool_AlignedCapa  equ 156  ;// integer //New240216
mpool_iColNeed     equ 160  ;// integer iCollectNeeded
mpool_Vmt          equ 164  ;// IMemPool vmt
mpool_RefCount     equ 168  ;// integer IMemPool (interface) RefCount
mpool_FreeSchedCnt equ 172  ;// integer FreeSchedCount
mpool_FreePageList equ 176  ;// TListEntry
  mpool_FreePage_Next equ mpool_FreePageList
  mpool_FreePage_Prev equ mpool_FreePageList+4
mpool_SmallPageList equ 184 ;// TListEntry
  mpool_SmallPg_Next   equ mpool_SmallPageList
  mpool_SmallPg_Prev   equ mpool_SmallPageList+4
mpool_hColThread   equ 192  ;// HThread hCollectThread
mpool_idColThread  equ 196  ;// DWORD idCollectThread
mpool_Vmt_IMalloc  equ 200  ;// IMalloc vmt
mpool_DivTables    equ 204  ;// Pointer //New240214
mpool_IsMain       equ 208  ;// Byte
mpool_DbgPending   equ 209  ;// Byte
mpool_Owner        equ 212  ;// Pointer, opaque
mpool_HugeVPool    equ 216  ;// separate TMmVirtPager for huge blocks //New240221
mpool_AlignedMap   equ 220  ;// ^PageMap instead of AlignedList, since v17 //New240304
mpool_SmallClears  equ 224  ;// ^array[16] of ClearProc //New240314
mpool_Arena8kPool  equ 228  ;// ^TMmArena8kPool //New240314
mpool__sizeOf      equ 232  ;//224  ;//220  ;//216 ;// 204

;// type TMmMiddlePrefix
mid_PriorSizeFlags   equ 0  ;// Word or two bytes
  mid_PriorSizeLo    equ 0  ;// Byte
  mid_PriorFlags     equ 1  ;// Byte
mid_NextSizeFlags    equ 2  ;// Word or two bytes
  mid_NextSizeLo     equ 2  ;// Byte
  mid_NextFlags      equ 3  ;// Byte
mid_dwTag            equ 4  ;// for 8-byte alignment
mid_Data             equ 8  ;// here starts user data

;// type TMmMiddlePageHdr
mpg_Zero             equ 0  ;// Zero word at start
mpg_NextSizeFlags    equ 2  ;// Word or two bytes
mpg_Signature        equ 4  ;// = cMmMiddlePageSign = 0A970B1B5h
;//%ifndef AllocTag ;//Original:
   cMmMiddlePageSign equ 0A970B1B5h
;//%endif

;// type TMmMiddlePageTail - at FF8
mpt_PriorSizeFlags   equ 0  ;// Word or two bytes
mpt_Zero             equ 2  ;// Word
mpt_Pool             equ 4  ;// PMmPool
  cMmMidPageTailOffset equ 0FF8h

;// type TMmMiddleFree
mmf_dwPad            equ 0  ;// DWORD
mmf_OffsNext         equ 4  ;// Longint
mmf_OffsPrior        equ 8  ;// Longint
mmf_Signature        equ 12 ;// = cMmMiddleFreeSign = 00000AB01h
   cMmMiddleFreeSign equ 00000AB01h
   cMmxMaxSearch equ 20  ;// max search distance for new cur

;// type TMmFreeItem
mfi_Pad0             equ 0  ;// DWORD
mfi_Pad1             equ 4  ;// DWORD
mfi_bPad2            equ 8  ;// Byte
mfi_NextFree         equ 9  ;// Byte
mfi_wSign            equ 10 ;// Word = 00AB (AB in third byte of third dword)
   cMmFreeSign        equ 00ABh
   cMmFreeSign_DW     equ cMmFreeSign << 16
   cMmNextFreeMask_DW equ 00000FF00h
mfi_Pad3             equ 12 ;// DWORD
mfi__sizeOf          equ 16

;// type TMmVirtPool
mvp_Signature        equ 0   ;// = cMmVirtPoolSign = 84E0D36Fh
   cMmVirtPoolSign equ 84E0D36Fh
mvp_Lock             equ 4   ;// PRtlCriticalSection
mvp_Spaces           equ 8   ;// TListEntry
mvp_DefSpaceSize     equ 16  ;// integer
mvp_MemPool          equ 20  ;// Pointer
mvp_PrepSpace__        equ 24  ;// Pointer (now unused)
mvp_TotalReserve     equ 28  ;// DWORD //New240217
mvp_TotalCommit      equ 32  ;// DWORD //New240217
mvp_SpaceCount       equ 36  ;// DWORD (could be word) //New240220
mvp_OwPool           equ 40  ;// POwPool
mvp__sizeOf          equ 48

;// type TMmVirtSpace
mvs_Entry            equ 0   ;// TListEntry
  mvs_Next  equ mvs_Entry
  mvs_Prev  equ mvs_Entry+4
mvs_Base             equ 8   ;// Pointer
mvs_Capacity         equ 12  ;// Cardinal
mvs_PageCount        equ 16  ;// Word
mvs_FreePageCount    equ 18  ;// Word
mvs_LoMap            equ 20  ;// Pointer
mvs_HiMap            equ 24  ;// Pointer
mvs_Signature        equ 28  ;// Word = cMmVirtSpaceSign = 0BA85h
mvs_wMinFree         equ 30  ;// Word , lowest free page index...
mvs__sizeOf          equ 32
   cMmVirtSpaceSign equ 0BA85h

cMmInitVirtPool equ 0D457A8E3h

hvp_Signature        equ 0   ;// = cMmHugeVPoolSign
  cMmHugeVPoolSign equ 84E0D34Fh
hvp_Lock             equ 4   ;// PRtlCriticalSection
hvp_MPool            equ 8   ;// PMmPool
hvp_BlockList        equ 12  ;// ^PointerList
hvp_BlockCount       equ 16  ;// dword
hvp_BlockCapa        equ 20  ;// dword
hvp_VirtPager        equ 24  ;// TMmVirtPager (20 bytes)
hvp_TotalReserve     equ 44
hvp_TotalCommit      equ 48
hvp__sizeOf          equ 52

owp_Signature        equ 0   ;// = cMmOwPoolSign POwPool
  cMmOwPoolSign equ 0A970774Fh
owp_TopPage          equ 4   ;// Pointer POwPage
owp_Cur              equ 8   ;// Pointer
owp_CEnd             equ 12  ;// Pointer - commit end
;//owp_Pages            equ 16  ;// Pointer
owp_Free             equ 20  ;// Pointer POwFree
owp_NextSpace        equ 24  ;// Pointer - hint next v-space address
owp_MinSize          equ 28  ;// dword (or word?) minimum item size...
owp__sizeOf          equ 32

owpg_Signature       equ 0   ;// = cMmOwPageSign
  cMmOwPgSign equ 0A967774Fh
owpg_Next            equ 4
owpg_VBase           equ 8
owpg_CStart          equ 12
owpg_CEnd            equ 16
owpg_VEnd            equ 20
owpg_Pool            equ 24  ;// POwPool
owpg__sizeOf         equ 32

owf_Next             equ 0
owf_Size             equ 4
owf_Signature        equ 8   ;// = cMmOwFreeSign
  cMmOwFreeSign equ 0A966774Fh

;//type TMmArena8kPool
m8k_Signature        equ 0   ;// = cMmA8kSign
  cMmA8kSign equ 0A96B3841h
m8k_OwPool           equ 4   ;// POwPool
m8k_SpaceList        equ 8   ;// TListEntry
m8k_Lock             equ 16  ;// ^MmPool.Lock
m8k_CacheCount       equ 20  ;// dword, count of cached arenas
m8k_TotalReserve     equ 24  ;// dword - total reserve
m8k_TotalCommit      equ 28  ;// dword - total commit
m8k_Vmt              equ 32  ;// TMmVirtPager vmt (20 bytes)
m8k_CacheList        equ 64  ;// array[8] of Pointer
  m8k_CacheCapa equ 8 ;// cache 8 8kb arenas...
m8k__sizeOf          equ (m8k_CacheList + 8 + m8k_CacheCapa*4+15) & -10h

;//type TMmArena8kSpace
m8x_Entry            equ 0   ;// TListEntry
m8x_wSign            equ 8   ;// = cM8xSign
m8x_wMinFree         equ 10  ;// word, lowest free bit
m8x_Base             equ 12  ;// Pointer
m8x_ArenaCount       equ 16  ;// word, count of 8k arenas
m8x_FreeArenaCount   equ 18  ;// word, count of free 8k spaces
m8x_Capacity         equ 20  ;// dword = def_ArenaPoolSize
m8x_Bitmap           equ 24  ;// var-sized...
  cM8xSign equ 038C1h
  m8x_sizeBitmap equ def_ArenaPoolSize/8192/8  ;// 16 bytes for 1Mb space, 8 bytes for 512kb space...
  m8x__sizeOf equ ((m8x_Bitmap + m8x_sizeBitmap)+15) & -10h

;//type TMmAlignedDesc
ma_Mem               equ 0   ;// Pointer
ma_Size              equ 4   ;// Longint
;//ma__sizeOf           equ 8
;// only with HugeVPool:
ma_VPool             equ 8   ;// ^VirtPool
ma_ATag              equ 12  ;// dword Tag

;//type TPageMap
pgm_Signature        equ 0   ;// = cPgMapSign
  cPgMapSign equ 0A94DABB5h
pgm_Root             equ 4
pgm_OwPool           equ 8
pgm_FreeDesc         equ 12
pgm__sizeOf          equ 16

pgfd_Next            equ 0
pgfd_Sign            equ 4
  cbPgmFreeDescSign equ -122

;//type TMmMicroPool
mmi_Signature        equ 0   ;// = cMmiSignature
  cMmiSignature equ 0A9E769B5h
mmi_FreeItems        equ 4
;//mmi_Pages            equ 8
mmi_TopPage          equ 12
mmi_Lock             equ 16
mmi_MPool            equ 20
mmi_TotalReserve     equ 24
mmi_TotalCommit      equ 28
mmi__sizeOf          equ 32

;//type TMmiPageHdr
mip_Signature        equ 0   ;// = cMipgSign
  cMipgSign equ 0A9E7EEB5h
mip_NextPage         equ 4   ;// Pointer
mip_Pool             equ 8   ;// ^TMmMicroPool
mip_Cursor           equ 12  ;// dword

mif_FreeSign4        equ 87D7EEFEh

cMmMaxSmallSize  equ 256
cMinHugeSize     equ 524288  ;// 512kb

  cMmCurAllocSign equ 0000BB03h
  
  cMmMaxFreeSmallPages equ 32 ;// maximum count of small free pages before releasing them...


;//--------------------------------------------------------------------
;// in DATA (BSS) segment:
bnMmWasInit          equ seg_Data + 4   ;// BOOL (Boolean byte)  - now unused...
g_MainMmPool         equ seg_Data + 16  ;// PMmPool

g_Mm_BadPtr          equ seg_Data + 32 ;// for debugging - pointer, that is failing FreeMem...

g_LogInfo            equ seg_Data + 48
  off_LogEnabled     equ 0  ;// Boolean
  g_LogEnabled       equ g_LogInfo + off_LogEnabled
  off_LogBase        equ 4  ;// Pointer
  off_LogEnd         equ 8  ;// Pointer
  off_LogWrite       equ 12 ;// Pointer
  off_LogWrap        equ 16 ;// dword

;// either of these attempts to avoid virt-space fragmentation problem:
;//%define SinglePageScan
%define HugeVPool

;// Align_v2 - put Div*Table into Pool.DivTables , avoid fixed pointers...
%define Align_v2

%ifndef Align_v2
%define Align_v1

g_Div3Table          equ seg_Data + 64  ;// 32 bytes
g_Div5Table          equ seg_Data + 96  ;// 32 bytes
g_Div7Table          equ seg_Data + 128 ;// 32 bytes
g_Div9Table          equ seg_Data + 160 ;// 32 bytes
g_Div11Table         equ seg_Data + 192 ;// 32 bytes
g_Div13Table         equ seg_Data + 224 ;// 32 bytes
g_Div15Table         equ seg_Data + 256 ;// 32 bytes

%else ;Align_v2

;// allocated div-tables: //New240214
off_Div3Table  equ 0
off_Div5Table  equ 32
off_Div7Table  equ 64
off_Div9Table  equ 96
off_Div11Table equ 128
off_Div13Table equ 160
off_Div15Table equ 192
sizeof_DivTables equ 224

%endif ;Align_v2

off_Kernel equ 320
g_Kernel             equ seg_Data + off_Kernel  ;// 64 bytes kernel function pointers...
  off_GetModuleHandle             equ 4 ;// for GetProcAddress
  off_EnterCriticalSection        equ 8
  off_LeaveCriticalSection        equ 12
  off_InitializeCriticalSection   equ 16
  off_DeleteCriticalSection       equ 20
  off_RtlUnwind                   equ 24
  off_VirtualAlloc                equ 28
  off_VirtualFree                 equ 32
  off_VirtualProtect              equ 36  ;// for mozglue patching
  off_GetCurrentThreadId          equ 40  ;// for collect thread
  off_GetExitCodeThread           equ 44
  off_CloseHandle                 equ 48
  off_CreateThread                equ 52
  off_IsBadWritePtr               equ 56
  off_Sleep                       equ 60
n_Kernel_Funcs equ 15
  

  MEM_DECOMMIT equ 4000h
  MEM_RELEASE  equ 8000h
  MEM_RESERVE  equ 2000h
  PAGE_NOACCESS  equ 1
  PAGE_READWRITE equ 4
  PAGE_EXECUTE_READWRITE equ 40h
  MEM_COMMIT equ 1000h

  E_NOINTERFACE equ 80004002h
  STILL_ACTIVE equ 103h

;//--------------------------------------------------------------------
;// MmAlloc for small types should be thread-safe even without locking...

;// Note: all internal functions use Delphi/Pascal calling convention, unless noted:
;// parameters are passed in EAX,EDX,ECX, then on stack pushed left-to-right (ie. right-most param at lowest stack address - not used here...)
;// in comments, pascal syntax ^any is as C syntax any*

align 4
;// function MmAlloc(Pool, Size): Pointer
MmAlloc:
  test edx,edx
  jle  short .fail0
  cmp  edx,cMmMaxSmallSize
  ja   near MmAllocMiddle
  ;//
  add  edx,byte 0Fh
  ;// get the "type"
  shr  edx,4
  ;//mov  ecx,dword ptr [eax].TMmPool.SmallTypes[edx*4]
  mov  ecx,[eax+mpool_SmallTypes+edx*4]
  ;// get the free page:
.retry_type:
  mov  edx,ecx
  mov  ecx,[ecx+mt_FreePages]
  test ecx,ecx
  jz   short .nd_page2 ;//near .need_page
  ;//New240215 - if there is pointer to MtType, it's not a free page !
  cmp  ecx,edx
  je   short .nd_page2 ;//near .need_page
  ;//
  ;// alloc block:
.retry_page:
  movzx eax,byte [ecx+mp_FreeList]
  test eax,eax
  jz   .no_free
  ;//
  mov  edx,eax
  shl  edx,4
  add  edx,ecx
  mov  ah,[edx+mfi_NextFree]
  lock cmpxchg byte [ecx+mp_FreeList],ah
  jne  .thread_problem
  dec  byte [ecx+mp_FreeCount]
  mov  eax,edx
  ;//
          ;//x240215:
          ;//cmp  word [eax+mfi_wSign],cMmFreeSign
          ;//jne  near .check_free
          ;//xor  edx,edx
          ;//mov  [eax+8],edx ;// clear free-sign, next-free
          ;//ret
          ;//New240215 - additional measure - extract the free-sign thread-safe:
  ;//mov  edx,eax
  xor  ecx,ecx
  mov  ax,cMmFreeSign
  lock cmpxchg word [edx+mfi_wSign],cx
  jne  .free_problem
  and  word [edx+8],byte 0 ;// also clear next-free
  mov  eax,edx
  ;//
  %ifdef LogAlloc
    jmp short .log_Small_Alloc
  %else
    ret
  %endif
  ;//
.nd_page2:
  jmp short .need_page
  ;//
.no_free:
    ;//zmena240218:
    push  edi
    mov   edx,[ecx+mp_Typ]
    mov   edi,[ecx+mp_NextFreePage]
    xor   eax,eax
    cmp   edi,edx
    cmovz edi,eax
    mov   eax,ecx
    lock cmpxchg [edx+mt_FreePages],edi
    jne   .pd_restart
    xor   eax,eax
    mov   [ecx+mp_NextFreePage],eax
  .pd_restart:
    pop  edi
    mov  ecx,edx
    jmp short .retry_type
  ;//
.fail:
  %ifdef ErrHalt
    jmp short $ ;//halt
  %endif
.fail0:
  xor  eax,eax
  ret
  ;//
.thread_problem:
  db 0F3h
  nop
  jmp short .retry_page
  ;//
.free_problem:
  mov  eax,edx
  jmp short .check_free
  ;//
.need_page:
  ;// need a new free page:  EDX=Type, ECX=0
  push edx
  mov  eax,[edx+mt_Pool]
  call MmAcquirePage
  pop  ecx
  test eax,eax
  jnz  .retry_type
  ;// Out of memory?
  xor  eax,eax
  mov  edx,ecx
  call MmOutOfMemoryError
  ret
  ;//
.check_free:
  ;// item is either not free, or its free-sign was damaged... Item=EAX
    %ifdef LogAlloc
    push eax
    push 2145h  ;// E!
    push byte 8
    call LogWrite
    %endif ;LogAlloc
  call MmVerifySmallPage
  test eax,eax
  jz   short .fail
  and  eax,0FFFFF000h
  mov  ecx,[eax+mp_Typ]
  jmp near .retry_type
  ;//
  %ifdef LogAlloc
    .log_Small_Alloc:
      ;//mov  edx,eax
      and  edx,0FFFFF000h
      movzx edx,byte [edx+mp_ItemSize]
      shl  edx,4+16
      mov  dx,'a:'
      push eax
      push edx
      push byte 8
      call LogWrite
      ret
  %endif ;LogAlloc

%ifdef C_MEM_Handlers
;// function MmAlloc0(Pool, Size): Pointer - zero-init...
MmAlloc0:
  %ifdef MicroAlloc
  cmp  edx,byte 8
  jle  .go_Micro
  %endif ;Micro
  push edi
  push edx
  call MmAlloc
  ;//
  %ifdef AllocTag
  pxor xmm7,xmm7
  %endif ;AllocTag
  ;//
  test eax,eax
  mov  [esp],eax
  mov  edi,eax
  jz   .fail
  ;// rather clear allocated size, not only requested size, because of realloc0:
  call MmQuerySizeFast
    ;//
    %ifdef LogAlloc__xx
      pushad
      or  eax,0FF000000h
      push eax
      push edi
      push byte 8
      call LogWrite
      popad
    %endif ;LogAlloc - old
  mov  ecx,eax
  ;//
  xor  eax,eax
  add  ecx,byte 3
  shr  ecx,2 ;// all is dword-round...
  ;//New240314 - clearing large faster...
  cmp  ecx,16 ;// 64 bytes...
  ja   .clear_large
  ;//
  cld
  rep stosd
.ok:
.fail:
  pop  eax
  pop  edi
  ret
  ;//
  %ifdef MicroAlloc
.go_Micro:
  jmp near MmMicroAlloc
  %endif ;Micro
  ;//New240314
.clear_large: ;// edi space to clear, ecx count of dwords...
  pxor xmm0,xmm0
.cyl1:
  test edi,0Fh
  jz   .aligned
  stosd
  dec  ecx
  jnz  .cyl1
.out2:
  pop  eax
  pop  edi
  ret
.aligned:
  sub  ecx,byte 32
  jl   .break128
.cy128:
  movaps [edi],xmm0
  movaps [edi+16],xmm0
  movaps [edi+16*2],xmm0
  movaps [edi+16*3],xmm0
  movaps [edi+16*4],xmm0
  movaps [edi+16*5],xmm0
  movaps [edi+16*6],xmm0
  movaps [edi+16*7],xmm0
  add  edi,128
  sub  ecx,byte 32
  jge  .cy128
.break128:
  add  ecx,byte (32-16)
  jl   .break64
.cy64:
  movaps [edi],xmm0
  movaps [edi+16],xmm0
  movaps [edi+16*2],xmm0
  movaps [edi+16*3],xmm0
  add  edi,byte 64
  ;//sub  ecx,byte 16
  ;//jge cy64
  ;//add  ecx,byte 16
  ;//jz  .done
  sub  ecx,byte 4
.go_cy16:
  jl   .last
.cy16:
  movaps [edi],xmm0
  add  edi,byte 16
  sub  ecx,byte 4
  jge  .cy16
.last:
  add  ecx,byte 4
  ;//jz   .out3
.last_fill:
  rep  stosd
  mfence
.out3:
  pop  eax
  pop  edi
  ret
.break64:
  add  ecx,16-4
  jmp  short .go_cy16

%endif ;C_MEM_Handlers

align 4
;// function MmInternalVerifySmallPage(Page: PMmPage): Pointer
;// (called only in case of error...)
MmInternalVerifySmallPage:             ; c> 004061E6   ; 00406054
       push   ebx                              ; 00406054      53
       push   esi                              ; 00406055      56
       push   edi                              ; 00406056      57
       mov    ecx,eax        ;// Page          ; 00406057      8B C8
       cmp    dword [ecx],cMmPageSign ;//0A96750B5h           ; 00406059      81 39 B5 50 67 A9
       jne    near .loc_00406108_fail                     ; 0040605F      0F 85 A3 00 00 00
       ;//
       xor    ebx,ebx                          ; 00406065      33 DB
       mov    bl,byte [ecx+mp_ItemSize]                ; 00406067      8A 59 0C
       shl    ebx,4 ;//x240212: 3 !                           ; 0040606A      C1 E3 03
       test   ebx,ebx                          ; 0040606D      85 DB
       jle    near .loc_00406108_fail                     ; 0040606F      0F 8E 93 00 00 00
       ;//
       mov    eax,1000h                        ; 00406075      B8 00 10 00 00
       cdq                                     ; 0040607A      99
       idiv   ebx                              ; 0040607B      F7 FB
       dec    eax                              ; 0040607D      48
       ;//New240212
       xor   edx,edx
       cmp   ebx,byte 32
       setl  dl
       sub   eax,edx
       ;//
       mov    byte [ecx+mp_MaxFreeCount],al            ; 0040607E      88 41 0F
       ;//
.loc_00406081_Retry:          ; j> 004060ED           ; 00406081
       xor    esi,esi                          ; 00406081      33 F6
       lea    edi,[ecx+mp_FreeList]                    ; 00406083      8D 79 0E
       xor    eax,eax                          ; 00406086      33 C0
       ;//mov    al,byte [ecx+mp_FreeList]            ; 00406088      8A 41 0E
       mov  al,[edi]
       shl    eax,4                            ; 0040608B      C1 E0 04
       test   eax,eax                          ; 0040608E      85 C0
       jz     .loc_004060FF_break                     ; 00406090      74 6D
.loc_00406092:          ; j> 004060FD           ; 00406092
       ;//cmp    byte [ecx+eax+0Ah],0ABh      ; 00406092      80 7C 01 0A AB
       cmp    word [ecx+eax+mfi_wSign],cMmFreeSign ;//0ABh      ; 00406092      80 7C 01 0A AB
       ;//jne    .loc_004060A0                     ; 00406097      75 07
       ;//cmp    byte [ecx+eax+0Bh],0         ; 00406099      80 7C 01 0B 00
       je     .loc_004060D4                     ; 0040609E      74 34
.loc_004060A0:          ; j< 00406097           ; 004060A0
       ;// bad item suspected:
       xor    edx,edx                          ; 004060A0      33 D2
       mov    dl,byte [ecx+eax+mfi_NextFree]          ; 004060A2      8A 54 01 09
       shl    edx,4                            ; 004060A6      C1 E2 04
       test   edx,edx                          ; 004060A9      85 D2
       jz     .loc_004060C0                     ; 004060AB      74 13
       ;//cmp    byte [ecx+edx+0Ah],0ABh      ; 004060AD      80 7C 11 0A AB
       cmp    word [ecx+edx+mfi_wSign],cMmFreeSign ;//0ABh      ; 004060AD      80 7C 11 0A AB
       ;//jnz    .loc_004060C0                     ; 004060B2      75 0C
       ;//cmp    byte [ecx+edx+0Bh],0         ; 004060B4      80 7C 11 0B 00
       jnz    .loc_004060C0                     ; 004060B9      75 05
       shr    edx,4                            ; 004060BB      C1 EA 04
       jmp short .loc_004060C2                     ; 004060BE      EB 02
       ;//
.loc_004060C0:          ; j< 004060AB           ; 004060C0
                       ; j< 004060B2                           ; 004060C0
                       ; j< 004060B9                           ; 004060C0
       xor    edx,edx                          ; 004060C0      33 D2
.loc_004060C2:          ; j< 004060BE           ; 004060C2
       shr    eax,4                            ; 004060C2      C1 E8 04
       cmp    al,byte [edi]                ; 004060C5      3A 07
       jnz    .loc_004060CB                     ; 004060C7      75 02
       mov    byte [edi],dl                ; 004060C9      88 17
.loc_004060CB:          ; j< 004060C7           ; 004060CB
       xor    eax,eax                          ; 004060CB      33 C0
       mov    al,dl                            ; 004060CD      8A C2
       shl    eax,4                            ; 004060CF      C1 E0 04
       jmp short   .loc_004060FB_continue                     ; 004060D2      EB 27
       ;//
.loc_004060D4:          ; j< 0040609E           ; 004060D4
       inc    esi                              ; 004060D4      46
       cmp    esi,0FFh                         ; 004060D5      81 FE FF 00 00 00
       jl     .loc_004060EF                     ; 004060DB      7C 12
       ;// circular free-list...
       cmp    byte [edi],0                 ; 004060DD      80 3F 00
       jz     .loc_004060FF_break                     ; 004060E0      74 1D
       mov    eax,edi                          ; 004060E2      8B C7
       inc    eax                              ; 004060E4      40
       cmp    byte [eax],cMmFreeSign ;//0ABh              ; 004060E5      80 38 AB
       jnz    .loc_004060FF_break                     ; 004060E8      75 15
       mov    byte [edi],0                 ; 004060EA      C6 07 00
       jmp short .loc_00406081_Retry                     ; 004060ED      EB 92
;-----------------------------------------------------------   ; 004060ED
.loc_004060EF:          ; j< 004060DB           ; 004060EF
       lea    edi,[ecx+eax+mfi_NextFree]                  ; 004060EF      8D 7C 01 09
       ;//movzx  eax,byte [ecx+eax+mfi_NextFree]          ; 004060F3      0F B6 44 01 09
       movzx eax,byte [edi]
       shl    eax,4                            ; 004060F8      C1 E0 04
.loc_004060FB_continue:          ; j< 004060D2           ; 004060FB
       test   eax,eax                          ; 004060FB      85 C0
       jnz    .loc_00406092                     ; 004060FD      75 93
.loc_004060FF_break:          ; j< 00406090           ; 004060FF
                       ; j< 004060E0                           ; 004060FF
                       ; j< 004060E8                           ; 004060FF
       mov    eax,esi                          ; 004060FF      8B C6
       mov    byte [ecx+mp_FreeCount],al            ; 00406101      88 41 0D
       ;// return Page
       mov    eax,ecx                          ; 00406104      8B C1
       jmp short   .loc_0040610A_out                     ; 00406106      EB 02
;-----------------------------------------------------------   ; 00406106
.loc_00406108_fail:          ; j< 0040605F           ; 00406108
                       ; j< 0040606F                           ; 00406108
       xor    eax,eax                          ; 00406108      33 C0
.loc_0040610A_out:          ; j< 00406106           ; 0040610A
       pop    edi                              ; 0040610A      5F
       pop    esi                              ; 0040610B      5E
       pop    ebx                              ; 0040610C      5B
       ret                                     ; 0040610D      C3


;// function MmRemoveTopSmallPage(Page,Typ): Boolean
MmRemoveTopSmallPage:
  mov  ecx,[eax+mp_NextFreePage]
  lock cmpxchg [edx+mt_FreePages],ecx
  ;//x240215: sete al
  ;//New240215
  jnz  .fail
  and  dword [eax+mp_NextFreePage],byte 0
  mov  al,1
  ret
.fail:
  xor  eax,eax
  ret

;// function MmAddTopSmallPage(Page,Typ): Boolean
MmAddTopSmallPage:
  push ebx
  mov  ebx,eax
  mov  ecx,[edx+mt_FreePages]
  xor  eax,eax
  lock cmpxchg [ebx+mp_NextFreePage],ecx
  jnz  .fail
  mov  eax,ecx
  lock cmpxchg [edx+mt_FreePages],ebx
  jnz  .fail
  ;//mov  eax,1
  push byte 1
  pop  eax
  ;//
  pop  ebx
  ret
.fail:
  xor  eax,eax
  pop  ebx
  ret

;// function MmVerifySmallPage(BadItem: Pointer): Pointer
MmVerifySmallPage:             ; c< 00405FC0           ; 00406140
       push   ebp                              ; 00406140      55
       mov    ebp,esp                          ; 00406141      8B EC
       add    esp,byte -16                     ; 00406143      83 C4 F0
       and    eax,0FFFFF000h                   ; 00406146      25 00 F0 FF FF
       mov    [ebp-8],eax        ;// Page      ; 0040614B      89 45 F8
       ;//mov    eax,dword [ebp-8]                ; 0040614E      8B 45 F8
       cmp    dword [eax],cMmPageSign ;//0A96750B5h           ; 00406151      81 38 B5 50 67 A9
       jne   .fail1 ;//near .loc_0040622B_fail                     ; 00406157      0F 85 CE 00 00 00
       ;//
       ;//mov    eax,dword [ebp-8]                ; 0040615D      8B 45 F8
       mov    eax,[eax+mp_Typ]                 ; 00406160      8B 40 08
       mov    [ebp-10h],eax      ;// Typ       ; 00406163      89 45 F0
       ;//cmp    dword [ebp-10h],byte 0                ; 00406166      83 7D F0 00
       test eax,eax
       jz   .fail1 ;//near  .loc_0040622B_fail           ; 0040616A      0F 84 BB 00 00 00
       ;//
       ;//mov    eax,dword [ebp-10h]              ; 00406170      8B 45 F0
       cmp    dword [eax],cMmTypeSign ;//0A970DEB5h           ; 00406173      81 38 B5 DE 70 A9
       jne  .fail1 ;//near  .loc_0040622B_fail           ; 00406179      0F 85 AC 00 00 00
       ;//
       ;//mov    eax,dword [ebp-10h]              ; 0040617F      8B 45 F0
       mov    eax, [eax+mt_Pool]               ; 00406182      8B 40 0C
       mov    [ebp-0Ch],eax         ;// Pool   ; 00406185      89 45 F4
       ;//cmp    dword [ebp-0Ch],0                ; 00406188      83 7D F4 00
       test eax,eax
       jz   .fail1 ;//near  .loc_0040622B_fail                     ; 0040618C      0F 84 99 00 00 00
       ;//mov    eax,dword [ebp-0Ch]              ; 00406192      8B 45 F4
       cmp    dword [eax],cMmPoolSign ;//0A970AAB5h           ; 00406195      81 38 B5 AA 70 A9
       jne  .fail1 ;//near  .loc_0040622B_fail                     ; 0040619B      0F 85 8A 00 00 00
       ;//
       mov    edx,[ebp-10h]                    ; 004061A1      8B 55 F0
       mov    eax,[ebp-8]                      ; 004061A4      8B 45 F8
       call   MmRemoveTopSmallPage             ; 004061A7      E8 64 FF FF FF
       test   al,al                            ; 004061AC      84 C0
       jnz    .loc_004061B8                    ; 004061AE      75 08
       ;//
       mov    eax,[ebp-8]                      ; 004061B0      8B 45 F8
       mov    [ebp-4],eax        ;// Result    ; 004061B3      89 45 FC
       jmp short  .loc_00406230_out                     ; 004061B6      EB 78
   .fail1:
       jmp short .loc_0040622B_fail
;-----------------------------------------------------------   ; 004061B6
.loc_004061B8:          ; j< 004061AE          ; 004061B8
       ;// if IsMultiThread then Sleep(0) ???
       ;//mov    eax,dword_004206FC               ; 004061B8      A1 FC 06 42 00
       ;//cmp    byte [eax],0                     ; 004061BD      80 38 00
       ;//jz     .loc_004061C9                     ; 004061C0      74 07
       ;//push   0                                ; 004061C2      6A 00
       ;//call   Sleep                            ; 004061C4      E8 7B FC FF FF
.loc_004061C9:          ; j< 004061C0          ; 004061C9
       mov    eax,[ebp-0Ch]       ;// Pool     ; 004061C9      8B 45 F4
       add    eax,byte mpool_MidLock                          ; 004061CC      83 C0 5C
       push   eax                              ; 004061CF      50
       call   EnterCriticalSection             ; 004061D0      E8 C7 FA FF FF
       ;// try
       xor    eax,eax                          ; 004061D5      33 C0
       push   ebp                              ; 004061D7      55
       ;//push   offset .loc_00406208_goFinally              ; 004061D8      68 08 62 40 00
       call .here7
       .here7:
       add dword [esp],byte (.loc_00406208_goFinally - .here7)
       ;//
       db 64h,0ffh,30h ;//push   fs:[eax]                         ; 004061DD      64 FF 30
       db 64h,89h,20h ;//mov    dword fs:[eax],esp               ; 004061E0      64 89 20
       ;//
       mov    eax,[ebp-8]                      ; 004061E3      8B 45 F8
       call   MmInternalVerifySmallPage        ; 004061E6      E8 69 FE FF FF
       ;//
       mov    [ebp-4],eax  ;// Result    ; 004061EB      89 45 FC
       ;//end-try:
       xor    eax,eax                          ; 004061EE      33 C0
       pop    edx                              ; 004061F0      5A
       pop    ecx                              ; 004061F1      59
       pop    ecx                              ; 004061F2      59
       db 64h,89h,10h ;//mov    dword fs:[eax],edx               ; 004061F3      64 89 10
       ;//push   offset .loc_0040620F              ; 004061F6      68 0F 62 40 00
       call .here8
       .here8:
       add dword [esp],byte (.loc_0040620F - .here8)
       ;//
.loc_004061FB_fin:     ; j> 0040620D           ; 004061FB
       mov    eax,dword [ebp-0Ch]              ; 004061FB      8B 45 F4
       add    eax,byte mpool_MidLock                          ; 004061FE      83 C0 5C
       push   eax                              ; 00406201      50
       call   LeaveCriticalSection             ; 00406202      E8 C5 FB FF FF
       ret                                     ; 00406207      C3
;-----------------------------------------------------------   ; 00406207
.loc_00406208_goFinally:          ; p< 004061D8           ; 00406208
       jmp    HandleFinally                    ; 00406208      E9 D7 CE FF FF
;-----------------------------------------------------------   ; 00406208
       jmp  short  .loc_004061FB_fin           ; 0040620D      EB EC
;-----------------------------------------------------------   ; 0040620D
.loc_0040620F:          ; p< 004061F6          ; 0040620F
       ;//
       cmp    dword [ebp-4],byte 0                  ; 0040620F      83 7D FC 00
       ;//jz     .loc_00406230_out                     ; 00406213      74 1B
       jz    .another_page
       mov    eax,[ebp-8]                      ; 00406215      8B 45 F8
       cmp    byte [eax+mp_FreeCount],4        ; 00406218      80 78 0D 04
       jbe    .loc_00406230_out                ; 0040621C      76 12
       ;//
       mov    edx,dword [ebp-10h]              ; 0040621E      8B 55 F0
       mov    eax,dword [ebp-8]                ; 00406221      8B 45 F8
       call   MmAddTopSmallPage                ; 00406224      E8 F3 FE FF FF
       ;//
       jmp  short  .loc_00406230_out                     ; 00406229      EB 05
;-----------------------------------------------------------   ; 00406229
.loc_0040622B_fail:          ; j< 00406157           ; 0040622B
                       ; j< 0040616A                           ; 0040622B
                       ; j< 00406179                           ; 0040622B
       xor    eax,eax                          ; 0040622B      33 C0
       mov    [ebp-4],eax                      ; 0040622D      89 45 FC
.loc_00406230_out:          ; j< 004061B6           ; 00406230
                       ; j< 00406213                           ; 00406230
                       ; j< 0040621C                           ; 00406230
       mov    eax,[ebp-4]                      ; 00406230      8B 45 FC
       mov    esp,ebp                          ; 00406233      8B E5
       pop    ebp                              ; 00406235      5D
       ret                                     ; 00406236      C3
.another_page:
      ;// return another page, if this one failed verify...
      mov  edx,[ebp-10h] ;// Typ
      mov  eax,[edx+mt_FreePages]
      test eax,eax
      jnz  .another_ok
      mov  eax,[edx+mt_Pool] ;//mov  eax,[ebp-0Ch] ;// Pool
      call MmAcquirePage
  .another_ok:
      mov  [ebp-4],eax
      jmp short .loc_00406230_out


%ifdef AllocTag
;// function MmTagMiddle(Ptr): Pointer
;// preserves EAX, discards EDX...
MmTagMiddle:
        ;//push eax
        ;//call MmGetAllocTag
        ;//pop  edx
  mov  edx,eax
  movd eax,xmm7  ;// MmGetAllocTag inline...
  ;//
  mov  ecx,0xbbbbbbbb
  test eax,eax
  cmovz eax,ecx
  ;//
  %ifdef ReleaseVer
    or   eax,80000000h  ;// do not leave "plain" pointer to user functions inside data...
  %endif ;!Debug
  mov  [edx-8+mid_dwTag],eax
  xchg eax,edx
  ;//
  cmp  al,10h
  je   .check_base
  ;//
.ret:
  ret
  ;//
.check_base:
  test  ah,0Fh
  jnz   .ret
  ;// when tagging 010 at 00C, mark also 008
  mov  dword [eax-8],09B9B9B9Bh
  ret

;// function MmGetAllocTag(): DWORD - stored in xmm7 in C_MEM_Handlers ...
MmGetAllocTag:
  movd eax,xmm7
  ret

%else ;//Original, common code:
;// function MmClearMidTag(Ptr): Pointer - clear preceeding Tag unless it is page-start...
;// preserves EAX, discards ECX
MmClearMidTag:
  xor   ecx,ecx
  test  eax,0FF0h
  cmovz ecx,[eax-8+mid_dwTag]
  mov   [eax-8+mid_dwTag],ecx
  ret
%endif ;AllocTag

%ifdef MidLinear
  cMmMaxMiddleSize equ 4096-16-8-64-8
%else ;//old x20
  cMmMaxMiddleSize equ 4096-256-16
%endif ;//old x20

;//----------------------------------------------------------------
;//%ifdef MidLinear ;//New240315 since v20

cMmMaxMidSize     equ (4096-16-8)  ;// = 4072

midfree_MinSize   equ cMmMaxSmallSize ;// = 256  ;// do not keep free-list of smaller items, are never needed...
midfree_MinIndex  equ midfree_MinSize/16
midfree_MaxIndex  equ (cMmMaxMidSize/16) - 1 - midfree_MinIndex   ;// cMmMaxMidSize would rather release whole page than putting to free-list...
midfree_MidIndex  equ (cMmMaxMidSize/32) - midfree_MinIndex

%define midlin_Max_Oversize 3  ;// count of larger 16 byte slots searched for free item...
%define midlin_Ovesteps2    8

cMid_MinSingleInPage_Size  equ (cMmMaxMidSize - midfree_MinSize - 8)  ;// = 3808 = EE0h - larger than this has no rest usable free space in its page...
cMid_MinSingleInPage_Tiles equ (cMid_MinSingleInPage_Size/8)

;// max item size 4072 bytes, (4072-256-8)/16 = 238, + (3+1) oversize = 242 slots, = 1936 bytes for list...

MmInternalAllocMiddle:
;// function MmInternalAllocMiddle(Pool,Size): Pointer
MmInternalAllocMiddle_lin:
  add  edx,byte 7
  and  edx,byte -8
  ;//or   edx,byte 8 ;// odd tile count to align all on 16-byte boundary...
  jz   .zero_alloc
  ;//
  push ebp
  mov  ebp,esp
  push ebx
  push edi
  push esi
  ;//
  push edx         ;// [ebp-16]=Size
  shr  edx,3
  push edx         ;// [ebp-20]=TileCount
  push edx         ;// [ebp-24]=Temp
  mov  ebx,eax     ;// Pool
  ;// From FreeList:
.restart:
  mov  esi,[ebx+mpool_MidFreeList]
  shr  edx,1
  ;//
  sub  edx,byte midfree_MinIndex
  jge  .index_ok
  ;//mov  edx,midfree_MinIndex
  push byte midfree_MinIndex
  pop  edx
  ;//
.index_ok:
  ;//
  lea  eax,[esi+8*edx]
  ;//
  mov  ecx,[eax]
  test ecx,ecx
  ;//jnz  .found_free
  jz   .search_oversize
  ;//
.found_free:
  add  ecx,eax  ;// now ecx points to mmf_OffsNext in free item...
  cmp  dword [ecx-mmf_OffsNext+mmf_Signature],cMmMiddleFreeSign
  jne  .mid_freelist_damaged
  ;// check back-link:
  ;//lea  edx,[ecx-mmf_OffsNext+mmf_OffsPrior]
  ;//add  edx,[edx]
  ;//sub  edx,byte 4
  mov  edx,ecx
  add  edx,[edx+4]
  ;//
  cmp  edx,eax
  jne  .mid_freelist_damaged
  ;// unlink from free-list:
  mov  eax,ecx
  call MmRelUnlinkC12
  test eax,eax
  jz   .mid_freelist_damaged
  sub  eax,byte mmf_OffsNext
  ;//
  mov  edx,[ebp-20]  ;// tile-count
  call MmMidAllocThisExact
  test eax,eax
  jz   .alloc1_failed  ;// not probable... is it damaged there?
.out:
  lea  esp,[ebp-12]
  pop  esi
  pop  edi
  pop  ebx
  pop  ebp
  ret
  ;//
.zero_alloc:
  xor  eax,eax
  ret
  ;//
.search_oversize:
    %rep midlin_Max_Oversize
      add  eax,byte 8
      mov  ecx,[eax]
      test ecx,ecx
      jnz  short .found_free
    %endrep
    ;// then try somehow larger so that there would be notable rest...
          %if 0 ;//???
              add  edx,byte midfree_MinIndex+1
              cmp  edx,byte midfree_MidIndex
              ja   .no_such_free
              lea  eax,[esi+8*edx]
              sub  edx,byte midfree_MinIndex ;// max search distance 
            .over_cy2:
              mov  ecx,[eax]
              test ecx,ecx
              jnz  short .found_free
              add  eax,byte 8
              dec  edx
              jnz  .over_cy2
          %endif
    ;//
    ;//jmp short .no_such_free
.no_such_free:
  ;// may try double size +delta to split into 2 items of this requested size...
  ;// then from MidPage cursor...
.retry_cur:
  lea  eax,[ebx+mpool_MidPage]
  cmp  dword [eax],byte 0
  jz   .no_cur
  mov  edx,[ebp-16]  ;// Size
  call MmMidPageAlloc_lin
  test eax,eax
  jnz  .out
  ;// discard old MidPage cursor into free-list:
  xchg [ebx+mpool_MidPage],eax ;// take former cursor, put nil...
  test eax,eax
  jz   .no_cur
  mov  edx,eax
  xor  ecx,ecx
  mov  eax,cMmCurAllocSign
  lock cmpxchg [edx+mmf_Signature],ecx
  jne  .no_cur
  mov  eax,edx
  mov  edx,ebx
  call MmMidLin_LinkFree
  ;//
.no_cur:
  ;// then steal largest free items for new cursor... at least [ebp-20]/2=TileCount/2 (free-list is in 16-byte increments)
  ;// here esi=FreeList, at mpool_MidPage is nil...
  mov  ecx,midfree_MaxIndex+1 ;// cycle below starts with "dec ecx"
.fcurnext:
  mov  edx,[ebp-20]
  shr  edx,1
  ;//??? add  edx,byte midfree_MinIndex+1 ;// not less than this index...
.fcurcy:
  dec  ecx
  cmp  ecx,edx
  jb   .fcurbreak
  lea  eax,[esi+8*ecx]
  cmp  dword [eax],byte 0
  jz   .fcurcy
  ;//
  mov  [ebp-24],eax
  add  eax,[eax]
  cmp  dword [eax-mmf_OffsNext+mmf_Signature],cMmMiddleFreeSign
  jne  .fcur_damaged
  ;// check back-link:
  mov  edx,eax
  add  edx,[eax+4]
  cmp  edx,[ebp-24]
  ;//
  jne  .fcur_damaged
  ;//
  push ecx
  call MmRelUnlinkC12
  pop  ecx
  ;//inc  ecx ;// repeat this slot?
  test eax,eax
  jz   .fcurnext
  sub  eax,byte mmf_OffsNext
  ;// now eax=new cur...
  call MmMarkCur_eax
  mov  [ebx+mpool_MidPage],eax
  jmp  near .retry_cur
  ;//
.fcurbreak:
  ;// then from new page:
.from_new_page:
  mov  edx,1000h
  mov  eax,[ebx+mpool_VirtPool+vp_Arg]
  call [ebx+mpool_VirtPool+vp_AllocRawPage]
  test eax,eax
  jz   .out_of_memory
  ;//
  mov  edx,ebx
  call MmFormatMidPage_lin
  ;//
  mov  edx,[ebp-16]  ;// Size
  call MmMidNewPageAlloc_lin
  ;// now eax=new item or unprobable nil, edx=rest space or nil
  push eax
  ;//
  test edx,edx
  jz   .no_new_rest
  ;//
  cmp  dword [ebx+mpool_MidPage],byte 0
  jnz  .link_rest_free
  ;// use as new cursor:
  mov  eax,edx
  call MmMarkCur_eax
  mov  [ebx+mpool_MidPage],eax
  ;//
.no_new_rest:
  pop  eax
.go_out:
  jmp  near .out
  ;//
.link_rest_free:
  mov  eax,edx
  mov  edx,ebx
  call MmMidLin_LinkFree
  jmp  short .no_new_rest
  ;//
.out_of_memory:
  mov  eax,[ebp-16]
  mov  edx,ebx
  call MmOutOfMemoryError
  jmp  short .go_out
  ;//
.fcur_damaged:
.mid_freelist_damaged:
.alloc1_failed: ;// check/repair free-lists, retry...
  %ifdef ErrHalt
  jmp short $
  %endif
  call MmMidLin_RepairFreeList
  mov  edx,[ebp-20]
  jmp  near .restart

;// function MmIs008_eax_ecx(eax=Pointer): ecx=1 if at 008, 0 if otherwise, preserves all other
MmIs008_eax_ecx:
  mov  ecx,eax
  and  ecx,0FFFh
  cmp  ecx,byte 8
  sete cl
  and  ecx,byte 1
  ret

;// function MmMidAllocThisExact(Ptr,TileCount): Pointer;
;// item already removed from free-list, keep no rest, Pool in ebx is locked (or ebx=nil) ...
MmMidAllocThisExact:
  push  esi
  ;//
  or    edx,byte 1 ;// odd tiles for aligning all on 16-byte boundary
  ;// if it is at page-start, need 1 more tile...
  call  MmIs008_eax_ecx
  add   edx,ecx
  ;//
  movsx ecx,word [eax-8+mid_NextSizeFlags]
  test  ecx,ecx
  jns   .not_free
  mov   esi,ecx
  and   ecx,1FFh
  cmp   ecx,edx
  jl    .not_enough
  cmp   word [eax+8*ecx+mid_PriorSizeFlags],si
  jne   .damaged
  ;// can alloc this...
  mov   [eax-8+mid_NextSizeFlags],cx
  mov   [eax+8*ecx+mid_PriorSizeFlags],cx
  ;//
  ;// if it is at page-start, give user aligned pointer at +010h ...
  call  MmIs008_eax_ecx
  lea   eax,[eax+8*ecx]
  ;//
  %ifdef AllocTag
    call MmTagMiddle
  %else
    call MmClearMidTag
  %endif ;AllocTag
  ;//
  pop   esi
  ret
.not_enough: ;// not probable, that there was free item not large enough...
  %ifdef ErrHalt
  jmp short $ ;//!!!todo - remove stop...
  %endif
  ;// return to propper free-list:
  test  ebx,ebx
  jz    .skip_relink
  mov   edx,ebx
  call  MmMidLin_LinkFree
.skip_relink:
  ;//
.not_free:
  xor   eax,eax
  pop   esi
  ret
.damaged:
  %ifdef ErrHalt
  jmp short $
  %endif ;Debug
  ;//!!!todo - some repair?
  jmp short .not_free

;// function MmMidLin_Unstep10_08(eax=Ptr): eax=Pointer, edx=8~0 if unstepped, Z-flag if not changed...
MmMidLin_Unstep10_08:
  ;// ending 010 unsteps to 008
  cmp  al,10h
  jne  .other
  test ah,0Fh
  jnz  .other
  mov  edx,8 ;// return edx=8
  sub  eax,edx ;// return eax at 008, z-flag clear
  ret
.other:
  xor  edx,edx    ;// return edx=0, eax=original, z-flag set
  ret

;// function MmMidLin_LinkFree(Ptr,Pool) -- add free item to free-list...
;// if linking item at +010h, go back to +008
;// if linking item at +008, dec 1 TileCount
;// TileIndex is for 16 bytes...
MmMidLin_LinkFree:
  push ebx
  mov  ebx,edx
  ;//
  call MmMidLin_Unstep10_08
  jz   .not_page_start ;// this catches, if we get called with 010, but not if with 008 ... !
  ;//
  ;//and  eax,-1000h
  ;//mov  al,8 ;//add  eax,byte 8
  cmp  word [eax-8+mid_NextSizeFlags],(4096-16)/8 + 8000h ;// 81FEh - whole page free...
  je   .free_page
  ;//
.not_page_start:
  ;//
  movsx edx,word [eax-8+mid_NextSizeFlags]
  test edx,edx
  jns  .not_free
  and  edx,1FFh
  ;//
  call MmIs008_eax_ecx
  sub  edx,ecx
  shr  edx,1
  sub  edx,byte midfree_MinIndex
  cmp  edx,midfree_MaxIndex
  ja   .too_large ;// or too small...
  ;// link to this slot:
.this_slot:
  mov  ecx,[ebx+mpool_MidFreeList]
  lea  edx,[ecx+8*edx]
  ;//
  mov  ecx,[eax+mmf_Signature]
  cmp  cx,cMmCurAllocSign
  je   .fail
  cmp  cx,cMmMiddleFreeSign
  je   .fail
  mov  dword [eax+mmf_Signature],cMmMiddleFreeSign
  ;// link to free-list:
  xchg eax,edx
  add  edx,byte mmf_OffsNext
  call MmRelInsertHeadList
  ;//
.ok:
  mov  al,1
  pop  ebx
  ret
  ;//
.free_page:
  lea  edx,[eax-8]
  mov  eax,[ebx+mpool_VirtPool+vp_Arg]
  call dword [ebx+mpool_VirtPool+vp_ReleaseRawPage]
  ;//
  jmp  short .ok
  ;//
.too_large:
  jl   .not_free ;// was too small...?
  movsx edx,word [eax-8+mid_NextSizeFlags]
  cmp  dx,81feh
  jne  .large_check2
  call MmIs008_eax_ecx
  test ecx,ecx
  jnz  .free_page
  ;//
.large_check2:
  mov  ecx,edx
  and  ecx,1FFh
  cmp  [eax+8*ecx+mid_PriorSizeFlags],dx
  jne  .not_free
  ;//
  %ifdef ErrHalt
  jmp short $
  %endif ;Debug - how can that happen?
  ;//
.not_free:
.fail:
  xor  eax,eax
  pop  ebx
  ret
  

;// function MmMidLin_RepairFreeList(ebx=Pool,esi=FreeList)
;// some links in mpool_MidFreeList are damaged... check & repair few items in each slot...
;// (this may happen for ex. if application corrupts links in "free" memory...)
MmMidLin_RepairFreeList:
  push ebp
  mov  ebp,esp
  push ebx
  push edi
  ;//
  call .pushed_CheckFunc
.CheckFunc: ;// check item entry in eax, edx=minimum tilecount in this slot...
      cmp   dword [eax-mmf_OffsNext+mmf_Signature],cMmMiddleFreeSign
      jne   .bad_item
      movsx ecx,word [eax-mmf_OffsNext-8+mid_NextSizeFlags]
      test  ecx,ecx
      jnl   .bad_item
      and   ecx,1FFh
      cmp   ecx,edx
      jl    .bad_item
      mov   al,1
      ret
    .bad_item:
      xor   eax,eax
      ret
.pushed_CheckFunc:
  pop  ebx
  ;//
  mov  edi,midfree_MaxIndex
.cy1:
  lea  eax,[esi+8*edi]
  xor  ecx,ecx
  cmp  dword [eax],ecx
  je   .flink_empty
  ;//
  mov  edx,ebx
  lea  ecx,[edi*2+1] ;// minimum tilecount in this list slot...
  ;//
  call MmCheckRelListBase
  test al,al
  jnz  .repair_slot
.next1:
  dec  edi
  jnz  .cy1
.done:
  lea  esp,[ebp-8]
  pop  edi
  pop  ebx
  pop  ebp
  ret
  ;//
.flink_empty:
  mov  [eax+4],ecx
  jmp  short .next1
  ;//
.repair_slot: ;// al=1=flink_bad, 2=blink_bad
  lea  edx,[esi+8*edi]
  cmp  al,3
  je   .reset_slot ;// if both flink and blink are bad, just empty the slot...
  ;// walk whole list in either direction and reconnect:
  ;//!!!todo
  
  
.reset_slot:
  xor  ecx,ecx
  mov  [edx],ecx
  mov  [edx+4],ecx
  jmp  short .next1

;// function MmCheckRelListBase(Base,CheckFunc,Arg): Byte 0=ok, 1=flink_bad, 2=blink_bad, 3=both_bad
;// calls CheckFunc(Item,Arg) should return al<>0 if ok
;// checks only few items in each direction...
MmCheckRelListBase:
  push  ebx
  push  edi
  push  esi
  push  byte 0   ;// Result
  ;//
  mov   ebx,eax  ;// Base
  mov   edi,edx  ;// CheckFunc
  mov   esi,ecx  ;// Arg
  ;//
  cmp   dword [ebx],byte 0
  jz    .base_flink_empty
  ;//
  call  MmCheckRelListEntry ;// check base
  cmp   al,3
  je    .base_bad
  ;//
.check_flink:
  mov   eax,ebx
  add   eax,[eax]
  push  eax
  call  MmCheckRelListEntry
  test  al,al
  jnz   .next_bad1
  pop   eax
  test  edi,edi
  jz    .no_check_func1
  mov   edx,esi
  call  edi
  test  al,al
  jz    .next_bad0
.no_check_func1:
  ;//
.check_blink:
  lea   eax,[ebx+4]
  add   eax,[eax]
  push  eax
  call  MmCheckRelListEntry
  test  al,al
  jnz   .prev_bad1
  pop   eax
  test  edi,edi
  jz    .no_check_func2
  mov   edx,esi
  call  edi
  test  al,al
  jz    .prev_bad0
.no_check_func2:
  ;//
.out:
  pop   eax
  pop   esi
  pop   edi
  pop   ebx
  ret
  ;//
.base_bad:
  xor   edx,edx
  mov   [ebx],edx
  mov   [ebx+4],edx
  jmp   short .out
  ;//
.base_flink_empty:
  cmp   dword [ebx+4],byte 0
  jz    .out
  or    byte [esp],1 ;// flink_bad
  jmp   short .check_blink
  ;//
.next_bad1:
  pop   edx
.next_bad0:
  or    byte [esp],1 ;// flink_bad
  jmp   short .check_blink
  ;//
.prev_bad1:
  pop   edx
.prev_bad0:
  or    byte [esp],2 ;// blink_bad
  jmp   short .out

;// function MmCheckRelListEntry(Entry): al Byte 0=ok, 1=flink_bad, 2=blink_bad, 3=both_bad, edx=entry
MmCheckRelListEntry:
  push byte 0 ;// result
  push eax ;// entry
  ;//
  call MmIsBadWrite
  test eax,eax
  jz   .entry_bad
  pop  eax
  push eax
  ;//
  ;// check flink:
  mov  edx,[eax]
  test edx,edx
  jz   .flink_empty
  cmp  dword [eax+4],byte 0
  je   .blink_empty1
.check_flink:
  add  eax,edx
  push eax ;// next
  and  eax,0FFFh
  cmp  eax,0FFCh
  ja   .flink_bad2
  pop  eax
  push eax
  call MmIsBadWrite
  test eax,eax
  pop  edx ;// next
  jnz  .flink_bad1
  pop  eax
  push eax ;//entry
  ;//add  edx,byte 4
  ;//add  edx,[edx]
  ;//sub  edx,byte 4
  add  edx,[edx+4]
  ;//
  cmp  eax,edx
  jne  .flink_bad1
  ;// check blink:
.check_blink:
  ;//add  eax,byte 4
  ;//add  eax,[eax]
  ;//sub  eax,byte 4
  add  eax,[eax+4]
  ;//
  push eax ;// prev
  and  eax,0FFFh
  cmp  eax,0FFCh
  ja   .blink_bad2
  pop  eax
  push eax
  call MmIsBadWrite
  test eax,eax
  pop  edx ;// prev
  jnz  .blink_bad1
  pop  eax
  push eax ;// entry
  add  edx,[edx]
  cmp  edx,eax
  jne  .blink_bad1
  ;//
.out:
  pop  edx
  pop  eax ;// result
  ret
.entry_bad:
  pop  edx ;// entry
  pop  eax
  mov  al,3
  ret
.flink_empty: ;// if flink is empty, blink should be also...
  mov  [eax+4],edx
  jmp  short .out
.blink_bad2:
  pop  edx
.blink_bad1:
.blink_empty1:
  or   byte [esp+4],2 ;// return blink_bad
  jmp  short .check_flink
  ;//
.flink_bad2:
  pop  edx
.flink_bad1:
  or   byte [esp+4],1 ;// return flink_bad
  jmp  short .check_blink


;// function MmRelInsertHeadList(Base,Entry): Entry
MmRelInsertHeadList:
  push esi
  mov  esi,eax
  add  esi,[eax] ;// next entry from base or same as eax
  ;// check back-link:
  ;//lea  ecx,[esi+4]
  ;//add  ecx,[ecx]
  ;//sub  ecx,byte 4
  mov  ecx,esi
  add  ecx,[esi+4]
  ;//
  cmp  ecx,eax
  jne  .damaged
  ;//
  mov  ecx,esi
  sub  ecx,edx
  mov  [edx],ecx
  neg  ecx
  mov  [esi+4],ecx
  ;//
  mov  ecx,edx
  sub  ecx,eax
  mov  [eax],ecx
  neg  ecx
  mov  [edx+4],ecx
  ;//
  mov  eax,edx ;// return Entry
  pop  esi
  ret
.damaged:
  xor  eax,eax
  pop  esi
  ret

;// function MmFormatMidPage_lin(Page,Pool): Pointer -- returns Page+8
MmFormatMidPage:
MmFormatMidPage_lin:
  test eax,07FFF0000h
  jz   .bad_page
  cmp  dword [eax],byte 0
  jnz  .bad_page
  test eax,0FFFh
  jnz  .not_aligned
  ;//
  lea  ecx,[eax+cMmMidPageTailOffset]
  mov  [ecx+mpt_Pool],edx
  mov  edx,((4096-16)/8) | 8000h  ;// 81FEh
  mov  [ecx],edx
  shl  edx,16
  mov  [eax],edx
  mov  dword [eax+4],cMmMiddlePageSign
  ;// return @Page+008
  mov  al,8
  ret
.bad_page:
.not_aligned:
  %ifdef ErrHalt
  jmp short $
  %endif
  xor  eax,eax
  ret

;// function MmMarkCur_eax(eax=FreeSpace), preserves all...
MmMarkCur_eax:
  mov  dword [eax+mmf_Signature],cMmCurAllocSign
  ret

;// function MmMidNewPageAlloc(Page,Size): eax=Pointer,edx=rest_space
;// allocate from new mid-page, already formated...
MmMidNewPageAlloc_lin:
  push ebx
  push esi
  and  eax,-1000h
  jz   .no_page ;// return eax=nil, edx=nil
  xor  ebx,ebx
  mov  al,8 ;//or   eax,byte 8  ;// point to 008
  add  edx,byte 7
  shr  edx,3
  ;//
  cmp  edx,cMid_MinSingleInPage_Tiles
  jae  .exact
  ;//
  or   edx,byte 1 ;// odd tile-count for alignment...
  inc  edx ;// first tile reserved for alignment...
  ;//cmp  edx,(4096-16-8)/8  ;// max 4072 bytes, 509=1FDh tiles
  ;//ja   .too_large
  ;//test byte [eax-8+mid_NextFlags],80h
  ;//jz   .not_free
  mov   esi,(4096-8-8)/8 - 1
  sub  esi,edx
  or   si,8000h
  ;// there will be some rest space... eax=space (at 008), edx=this tiles, esi=rest_tiles or 8000h free-bit
  lea  ecx,[eax+8*edx+8] ;// next item data
  mov  [eax+4096-8-8],esi  ;// at FF8, i.e. FF0 from here...
  shl  esi,16
  mov  si,dx
  mov  [ecx-8],esi
  mov  [eax-8+mid_NextSizeFlags],dx  ;// at 002
  ;//
  ;//mov  dword [ecx+mmf_Signature],cMmCurAllocSign
  ;//no! call MmMarkCur_ecx
  ;// return user pointer at 010
  mov  al,10h ;//add  eax,byte 8
  ;//
  push ecx
  ;//
  %ifdef AllocTag
    call MmTagMiddle
  %else
    call MmClearMidTag
  %endif ;AllocTag
  ;//
  pop  edx ;// return rest space in edx
  ;//
  jmp  short .out
  ;//
.exact:
  ;// alloc exact...
  movzx edx,word [eax-8+mid_NextSizeFlags]
  and  edx,1FFh
  ;//??? lea  edx,[edx+esi-1] ;// undo reserved tile, will be added below also...
  dec  edx  ;// this will be undone soon... (is at page-start)
  call MmMidAllocThisExact
.no_page:
  xor  edx,edx ;// no rest space...
  ;//
.out:
  pop  esi
  pop  ebx
  ret

    %if 0
      ;// function MmMidGetPool(Ptr in mid-page): PMmPool
      MmMidGetPool:
        mov  ecx,0FFFh
        and  eax,ecx
        ;// with *lin, there is always page-sign, even with AllocTag...
        cmp  dword [eax+mid_dwTag],cMmMiddlePageSign
        jne  .bad
        ;//
          ;//lea  eax,[eax+cMmMidPageTailOffset]
          ;//cmp  word [eax+mpt_Zero],byte 0
          ;//jne  .bad
          ;//mov  eax,[eax+mpt_Pool]
        mov  eax,[eax+cMmMidPageTailOffset+mpt_Pool]
        mov  edx,eax
        and  edx,ecx
        cmp  edx,byte 8
        jne  .bad
        ret
      .bad:
        xor  eax,eax
        ret
    %endif ;unused

MmMidPageAlloc:
;// function MmMidPageAlloc_lin(var Space,Size): Pointer
;// [eax] is Space usually at mpool_MidPage, edx already 8-byte round, max-size checked, Pool at *FFC already locked if needed...
MmMidPageAlloc_lin:
  push ebx
  push esi
  mov  ebx,eax    ;// ^Space
  mov  eax,[eax]  ;// take Space
  test eax,eax
  jz   .no_space
  add  edx,byte 7
  ;//and  edx,byte -8
  ;//
  shr  edx,3
  jz   .zero_alloc
  or   edx,byte 1  ;// odd tile-count to align all on 16-byte...
  ;//
  ;// 1 more tile at page-start, recognized below by even edx...
  call MmIs008_eax_ecx
  add  edx,ecx
  ;//
  movsx ecx,word [eax-8+mid_NextSizeFlags]
  test ecx,ecx
  mov  esi,ecx
  jns  .not_free
  and  ecx,1FFh
  ;//
  cmp  [eax+8*ecx+mid_PriorSizeFlags],si
  jne  .damaged
  ;//
  mov  esi,ecx
  ;//
  dec  ecx
  sub  ecx,edx
  jl   .not_enough
  ;// here eax=Space, edx=tiles requested, ecx=tiles rest, esi=tiles total, [eax+8*esi]=end_header
  cmp  ecx,byte (midfree_MinSize/8)
  jb   .no_rest
  ;// there will be some rest:
  or   cx,8000h
  mov  [eax+8*esi+mid_PriorSizeFlags],cx
  mov  [eax-8+mid_NextSizeFlags],dx
  mov  [eax+8*edx+mid_PriorSizeFlags],dx
  mov  [eax+8*edx+mid_NextSizeFlags],cx
  ;//
  lea  ecx,[eax+8*edx+8]
  ;//call MmMarkCur_ecx
  mov  dword [ecx+mmf_Signature],cMmCurAllocSign
  ;//
  ;// return rest of space...
  mov  [ebx],ecx
  ;// clear cur-alloc sign here:
  xor  ecx,ecx
  mov  [eax+mmf_Signature],ecx
  ;// skew if at 008
  call MmIs008_eax_ecx
  lea  eax,[eax+8*ecx]
  ;//
  %ifdef AllocTag
    call MmTagMiddle
  %else
    call MmClearMidTag
  %endif ;AllocTag
  ;//
  jmp short .out
  ;//
.damaged:
  ;//!!!todo - repair?
  %ifdef ErrHalt
  jmp short $
  %endif ;Debug
  ;//
.no_space:
.not_free:
.not_enough:
.zero_alloc:
  xor  eax,eax
  jmp  short .out
  ;//
.no_rest: ;// eax=item, esi=TileCount
  xor  ecx,ecx
  mov  [ebx],ecx  ;// unset from ^Space
  mov  [eax+mmf_Signature],ecx ;// clear cur-alloc sign...
  ;// unstep reserve at page-start:
  test dl,1
  setz cl ;// here edx even only at page-start, where was added 1...
  sub  edx,ecx
  ;//
  call MmMidAllocThisExact
  ;//
.out:
            %if 0
              %warning "Temp code"
              .check_not_too_small:
                test eax,eax
                jz   .out_size_ok ;// happens once during startup...
                cmp  word [eax-8+mid_NextSizeFlags],258/8
                jae  .out_size_ok
                cmp  eax,0FB10010h
                je   .out_size_ok
                mov  edx,eax
                and  edx,-1000h
                cmp  dword [edx+8],cMmPoolSign
                jne  .check_not_too_small
              .out_size_ok:
            %endif ;dbg

  pop  esi
  pop  ebx
  ret
  ;//

;// function MmInitMidFreeList(Pool)
MmInitMidFreeList:
  push  ebx
  push  edi
  mov   ebx,eax
  ;//
  mov   edx,(midfree_MaxIndex + midlin_Max_Oversize + 1) * 8 + 32
  lea   eax,[ebx+mpool_MidPage]
  call  MmMidPageAlloc_lin
  ;//
  add   eax,byte 31
  and   eax,byte -10h  ;// align on line, one unused line above
  ;//
  mov   edi,eax
  mov   [ebx+mpool_MidFreeList],eax
  mov   ecx,(midfree_MaxIndex + midlin_Max_Oversize + 1) * 8/4
  xor   eax,eax
  rep   stosd
  ;//
  pop   edi
  pop   ebx
  ret

;// function MmMidLin_UnlinkItem(eax=Item,ebx=Pool): Item not linked in free-list or cursor
MmMidLin_UnlinkItem:
  test  byte [eax-8+mid_NextFlags],80h
  jz    .not_free ;// if it is not free yet, it is not linked, just return it...
  cmp   dword [eax+mmf_Signature],cMmMiddleFreeSign
  jne   .not_linked
  add   eax,byte mmf_OffsNext
  call  MmRelUnlinkC12
  test  eax,eax
  jz    .failed
  sub   eax,byte mmf_OffsNext
.not_free:
.ok:
  ret
.not_linked:
  cmp   dword [eax+mmf_Signature],cMmCurAllocSign
  jne   .ok
  cmp   eax,[ebx+mpool_MidPage]
  jne   .ok
  xor   edx,edx
  mov   [ebx+mpool_MidPage],edx
  mov   [eax+mmf_Signature],edx
  ret
.failed:
  xor   eax,eax
  ret

;// function MmMidLin_MergeNext(eax=Item,ebx=Pool): Item to be linked in free-list, or nil failed, or -1 if cursor unstepped to this item...
;// simply merge this and next free items, unlink either from free-list if linked...
MmMidLin_MergeNext:
  push  esi
  mov   esi,1FFh
  ;//
  mov   ecx,eax  ;// this item
  movzx edx,word [eax-8+mid_NextSizeFlags]
  and   edx,esi
  lea   eax,[ecx+8*edx+8] ;// next item
  ;//
  test  byte [ecx-8+mid_NextFlags],80h
  jz    .this_not_free
  test  byte [eax-8+mid_NextFlags],80h
  jz    .next_not_free
  ;//
  xor   dx,[eax-8+mid_PriorSizeFlags]
  and   edx,esi
  jnz   .damaged
  ;//
  ;// check to unlink next:
  push  ecx
  call  MmMidLin_UnlinkItem
  test  eax,eax
  pop   ecx
  jz    .next_failed_unlink
  ;// check to unlink this:
  push  ecx
  push  eax
  mov   eax,ecx
  call  MmMidLin_UnlinkItem
  test  eax,eax
  pop   eax
  pop   ecx
  jz    .this_failed_unlink
  ;//
  ;// ecx=this, eax=next, neither not linked
.can_merge:
  ;//
  movzx edx,word [eax-8+mid_NextSizeFlags]
  and   edx,esi
  or    dword [eax-8],byte -1 ;// erase middle header...
  ;//mov   [eax-4],esi ;// erase middle tag by 1FF ?
  mov   dword [eax-4],0B1B1B1B1h
  ;//
  movzx eax,word [ecx-8+mid_NextSizeFlags]
  and   eax,esi
  add   eax,edx
  inc   eax ;// combined new count of tiles...
  mov   edx,eax
  or    dx,8000h
  ;// make single free item:
  mov   [ecx-8+mid_NextSizeFlags],dx
  mov   [ecx+8*eax+mid_PriorSizeFlags],dx
  ;// why caller sometimes forgets to release empty pages??? release it here...
  cmp   dx,81feh
  je    .empty_page
  ;//
  ;// return merged item to be added to free-list
.next_not_free:
.next_failed_unlink:
  mov   eax,ecx
.out:
  pop   esi
  ret
  ;//
.empty_page:
  mov   edx,ecx
  and   edx,-1000h
  cmp   word [edx+mid_NextSizeFlags],81feh
  jne   .next_not_free
  mov   eax,[ebx+mpool_VirtPool+vp_Arg]
  call  dword [ebx+mpool_VirtPool+vp_ReleaseRawPage]
  xor   eax,eax
  pop   esi
  ret
  ;//
.this_failed_unlink: ;// this in ecx failed unlink, but next in eax was unlinked, so link next back...
  ;//
  %ifdef ErrHalt
  jmp short $
  %endif ;ErrHalt
  ;//
  mov   edx,ebx
  call  MmMidLin_LinkFree
  ;//
.this_not_free:
.damaged:
  ;//
  %ifdef ErrHalt
  jmp short $
  %endif ;ErrHalt
  ;//
  xor   eax,eax
  jmp   short .out

;// function MmInternalFreeMiddle_lin(Item,ebx=Pool): Boolean;
;// pool already locked, item aligned 8-byte...
MmInternalFreeMiddle_lin:
  ;// if it is at 010, go back to 008
  call  MmMidLin_Unstep10_08
  mov   ecx,eax
  ;//
  movsx edx,word [ecx-8+mid_NextSizeFlags]
  test  edx,edx
  js    short .already_free
  and   edx,1FFh
  cmp   [ecx+8*edx+mid_PriorSizeFlags],dx
  jne   short .damaged
  ;//
    %ifdef LogAlloc
    push ecx
    push edx
    ;//
    shl  edx,16+3
    mov  dx,'Fm'
    push ecx
    push edx
    push byte 8
    call LogWrite
    ;//
    pop  edx
    pop  ecx
    %endif ;LogAlloc
  ;//
  %ifdef Poison_Free
    push ecx
    push edx
    shl  edx,3
    mov  eax,ecx
    call E5Clear_mid
    pop  edx
    pop  ecx
      ;//  xor  eax,eax
  %else ;orig_clear
    xor  eax,eax
    mov  [ecx],eax  ;// at least clear first dword (object VMT)
    ;//
    cmp   dword [ecx+12],cMmMiddleFreeSign
    je    .do_clear_12
    cmp   dword [ecx+12],cMmCurAllocSign
    je    .do_clear_12
    ;//
  %endif ;orig_clear
  ;//
.in_clr:
      ;// ;//rather keep original tag in free items?
      ;//  test  ecx,0FF7h ;// must not clear Page.Signature !
      ;//  jz    .skip_clearTag
      ;//  mov   [ecx-8+mid_dwTag],eax
      ;//.skip_clearTag:
  ;//
  ;// mark item free:
  or    byte [ecx-8+mid_NextFlags],80h
  or    byte [ecx+8*edx+mid_PriorFlags],80h
  ;//
  movsx eax,word [ecx-8+mid_PriorSizeFlags]
  test  eax,eax
  jl    near .merge_prior
  ;//
  test  byte [ecx+8*edx+mid_NextFlags],80h
  jnz   short .merge_next
  ;//
  ;// link to free-list, or release page if it is empty...
.link_free:
  mov   eax,ecx
.link_free_eax:
  mov   edx,ebx
  call  MmMidLin_LinkFree
  ;//
.out1:
  mov   eax,1
  ret
  ;//
%ifndef Poison_Free
.do_clear_12:
  mov   [ecx+mmf_Signature],eax
  jmp   short .in_clr
%endif ;orig_clear
  ;//
.damaged:
.already_free:
  mov  eax,ecx
  call Dbg_BadPtr
  xor  eax,eax
  ret
  ;//
.merge_next: ;// merge this item with next (which may be linked in free-list) ECX=this, ECX+8*EDX=Next
  mov   eax,ecx
  call  MmMidLin_MergeNext
  test  eax,eax
  jz    .out1
  ;// now eax is merged item, not linked in free-lists
  cmp   dword [ebx+mpool_MidPage],byte 0
  jnz   .link_free_eax
.make_cur:
  ;//mov   dword [eax+mmf_Signature],cMmCurAllocSign
  call  MmMarkCur_eax
  mov   [ebx+mpool_MidPage],eax
  jmp   short .out1
  ;//
.merge_prior: ;// ecx=item, ecx+8*edx=next_header, eax=prior_count or flags...
  test  byte [ecx+8*edx+mid_NextFlags],80h
  jz    .merge_prior2
.merge_both:
  push  ecx
  mov   eax,ecx
  call  MmMidLin_MergeNext
  pop   ecx
  movsx eax,word [ecx-8+mid_PriorSizeFlags]
  ;//
  ;// merge prior item with this
.merge_prior2:
  and   eax,1FFh
  neg   eax
  lea   ecx,[ecx+8*eax-8]
  jmp   short .merge_next

;// function MmFreeMiddle(nil,Page,Item): Boolean;
MmFreeMiddle:
MmFreeMiddle_lin:
  test ecx,0FFFh
  jz   short .page_aligned
  ;// with *lin there is always page-sign...
  cmp  dword [edx+mpg_Signature],cMmMiddlePageSign
  jne  short .not_middle
  ;// a middle-page:
  test cl,7
  jnz  short .not_aligned
  ;//
  ;// try-catch
  push ebx
  push ebp
  mov  ebp,esp
  mov  ebx,[edx+cMmMidPageTailOffset+mpt_Pool]
  mov  eax,ebx
  ;//
  push ecx ;// [ebp-4] = Item
  ;//
  call edxoffs_MmAllocMiddle_Bailout ;// = mov edx,offset MmAllocMiddle_Bailout
  xor  ecx,ecx
  call MmPoolMidLock_Try
  ;//
  mov  eax,[ebp-4]
  call MmInternalFreeMiddle_lin
  ;//
.done_middle:
  xchg eax,ebx ;// take Pool, save Result
  lea  eax,[eax+mpool_MidLock]
  push eax
  call LeaveCriticalSection
  ;//
  mov  eax,ebx
  ;//
  ;// leave try-frame...
  xor  edx,edx
  db 64h,8bh,22h ;//mov  esp,fs:[edx]    // why NASM refuses to compile this ?!
  db 64h,8fh,02h ;//pop  dword fs:[edx]  // why NASM refuses to compile this ?!
  ;//
  mov  esp,ebp
  pop  ebp
  pop  ebx
  ;//
  ret
  ;//
.not_middle:
  %ifndef LargeOnlyPA ;// currently unused...
      ;// check if it is large-page:
      cmp  dword [edx],cMmLargePageSign
      jne  .bad_page
    .large_page:
        %ifdef LogAlloc
          push edx
          ;//
          push byte 0
          push dword [edx+mlp_Size]
          lea  eax,[edx+mlp_Data]
          push eax
          push 'FrL:'
          push byte 16
          call LogWrite
          ;//
          pop  edx
        %endif ;LogAlloc
      mov eax,[edx+mlp_Pool]
      push ebx
      mov  ebx,eax
      mov  eax,[eax+mpool_VirtPool+vp_Arg]
      call dword [ebx+mpool_VirtPool+vp_ReleaseRawPage]
      pop  ebx
      ;//
      ret
  %else ;LargeOnlyPA
  jmp short .bad_page
  %endif ;LargeOnlyPA
  ;//
.page_aligned:
  %ifdef MINIMM_PAGEALIGNED
  jmp  MmFreePageAligned
  %endif ;MINIMM_PAGEALIGNED
  ;// else bail to Result:=False
  ;//
.not_aligned:
.bad_page:
  ;//mov  g_Mm_BadPtr,ecx
  mov  eax,ecx
  call Dbg_BadPtr
  ;//
  xor  eax,eax
  ret

MmQuerySizeMiddle:
;// function MmQuerySizeMiddle(Item,Page): integer
;// this does not query page-aligned items...
MmQuerySizeMiddle_lin:
  ;//
  cmp   dword [edx+mpg_Signature],cMmMiddlePageSign
  jne   .not_middle
  ;//
  test  al,7
  jnz   .not_aligned
  ;//mov   edx,0FFFh
  ;//and   edx,eax ;//test  eax,edx
  test  eax,0FFFh
  jz    .page_aligned
  ;//
  ;//and   edx,eax
  ;//cmp   edx,byte 10h
  ;//je    .first_item
  ;//
  ;//xor   edx,edx
  call  MmMidLin_Unstep10_08 ;// checks eax,sets edx=0~8
  ;//
.query2:
  movsx eax,word [eax-8+mid_NextSizeFlags]
  test  eax,eax
  js    .not_used
  and   eax,1FFh
  shl   eax,3
  sub   eax,edx
  ret
  ;//.first_item: ;// here edx=10h
  ;//  sub   edx,byte 8  ;// = 8 skew size for "sub" above...
  ;//  sub   eax,edx     ;// ask offset 008 instead
  ;//  jmp   short .query2
  ;//
.not_aligned:
.page_aligned:
.not_used:
  xor   eax,eax
  ret
  ;//
.not_middle:
    ;//
    %ifdef MicroAlloc
      cmp  dword [edx],cMipgSign
      jne  .not_micro
      test al,7
      jnz  .not_exact
      push byte 8
      pop  eax
      ret
    .not_micro:
    %endif ;Micro
    ;//
  %ifndef LargeOnlyPA ;// now unused...
    ;// check, if it is a large-page:
    cmp dword [edx],cMmLargePageSign
    jne  .bad_page
    ;// a stand-alone item (large-page)
    lea  ecx,[edx+mlp_Data]
    cmp  ecx,eax
    jne  .not_exact
    mov  eax,[edx+mlp_Size]
    sub  eax,byte 16 ;// subtract header size...
    ret
  %endif ;LargeOnlyPA
.not_exact:
.bad_page:
  xor  eax,eax
  ret

;// function MmMidReAlloc_lin(eax=Ptr,edx=Page,esi=NewSize,ebx=Pool): Pointer; // does not free old!
;// Ptr not checked yet, pool not locked... prefer moving item to new location if growing or rest not useful, do not merge...
;// NewSize already 8-byte round...
MmMidReAlloc_lin:
  push esi
  mov  esi,eax
  ;//
  call MmQuerySizeMiddle_lin
  test eax,eax
  jle  .invalid
  ;//
  mov  edx,[esp] ;// NewSize
  cmp  edx,eax
  jle  .no_grow_mid
.grow_mid:
  push eax  ;// OldSize = MoveSize
.go_realloc:
  mov  eax,ebx
  call [ebx+mpool_AllocProc]
  test eax,eax
  pop  ecx  ;// MoveSize
  jz   .failed
  ;//
  push edi
  mov  edi,eax
  shr  ecx,2
    %ifdef LogAlloc
    call LogRealloc
    %endif ;LogAlloc
  rep  movsd
  pop  edi
  ;//
  pop  esi
  ret
  ;//
.no_grow_mid:
  add  edx,byte 20h
  cmp  edx,eax
  jg   .no_change
  sub  edx,byte 20h
  push edx  ;// NewSize = MoveSize
  jmp  short .go_realloc
  ;//
.invalid:
.failed:
  xor  esi,esi ;// return nil if failed
.no_change:
  mov  eax,esi ;// return original Ptr
  pop  esi
  ret

MmReAlloc:
;// function MmReAlloc(Pool,var Ptr,NewSize): Boolean
;// eax=Pool, [edx]=Ptr, ECX=NewSize, out AL=ok
MmReAlloc_lin:
  push  ebx
  push  edi
  push  esi
  ;//
  add   ecx,byte 7
  and   ecx,byte -8
  ;//
  mov   ebx,eax  ;// Pool
  mov   edi,edx  ;// ^Ptr
  mov   esi,ecx  ;// NewSize
  cld
  mov   edx,[edx]
  ;//
  test  edx,edx
  mov   eax,edx    ;// Ptr
  jz    near .alloc_new
  mov   ecx,0FFFh
  test  edx,ecx
  jz    short .page_aligned
  not   ecx
  and   edx,ecx ;// Page
  jz    short .invalid
  ;//
  test  esi,esi
  jle   short .free_old
  ;//
  cmp   dword [edx],cMmPageSign
  jne   short .diff_page
  ;//
.small_page:
  ;// check aligned item, check not free:
  call  MmQuerySizeCheck
  test  eax,eax
  jle   short .bad_item
  ;//
  cmp   esi,eax
  jbe   .no_grow
  ;// growing small item - alloc new and move contents:
  push  eax ;// old size
  mov   eax,ebx
  mov   edx,esi
  call  dword [eax+mpool_AllocProc]
  test  eax,eax
  pop   ecx ;// old size = move size
  jz    short .alloc_failed
  ;//
.go_move:
  mov   esi,[edi] ;// old Ptr
  mov   ebx,edi   ;// ^Ptr
  mov   edi,eax   ;// new Ptr
  shr   ecx,2
    %ifdef LogAlloc
    call LogRealloc
    %endif ;LogAlloc
  rep   movsd
  mov   edi,ebx
  ;//
.ptr_eax_free_old:
  mov   ecx,eax
  xchg  [edi],eax ;// return Ptr, take old
  ;// if same, do not free old:
  cmp   ecx,eax
  je    .ok
  ;//
  mov   edx,eax
  xor   eax,eax
  call  MmFree
.ok:
  mov   eax,1 ;//al,1
.out:
  pop   esi
  pop   edi
  pop   ebx
  ret
  ;//
.free_old:  ;// (NewSize<=0)
  jl    short .invalid
  xor   eax,eax
  jmp   short .ptr_eax_free_old
  ;//
.page_aligned:
  %ifdef MINIMM_PAGEALIGNED
    mov  ecx,esi
    mov  edx,edi
    mov  eax,ebx
    pop  esi
    pop  edi
    pop  ebx
    jmp  MmReAllocPageAligned
  %else ;!MINIMM_PAGEALIGNED
    ;//jmp  short .bad_item -- is just below
  %endif ;!MINIMM_PAGEALIGNED
  ;//
.invalid:
.bad_item:
.alloc_failed:
  %ifdef LogAlloc
    call .log_error
  %endif
  ;//
  %ifdef ErrHalt
  jmp  short $
  %endif ;ErrHalt
  ;//
  xor   eax,eax
  jmp   short .out
  ;//
.no_grow:
  ;// shrinking small item... esi=NewSize, eax=OldSize, esi<=eax
  add   esi,byte 20h
  cmp   esi,eax
  jge   .ok
  sub   esi,byte 20h
  ;//
  mov   eax,ebx
  mov   edx,esi
  call  dword [eax+mpool_AllocProc]
  test  eax,eax
  jz    short .alloc_failed
  ;//
  mov   ecx,esi ;// move size = new size
  jmp   short .go_move
  ;//
.diff_page: ;// eax=Ptr, esi=NewSize, pool not locked...
  cmp   dword [edx+mpg_Signature],cMmMiddlePageSign
  jne   short .no_midPage
.mid_realloc:
  call  MmMidReAlloc_lin
  jmp   short .ptr_eax_free_old
  ;//
.no_midPage:
  ;//
  %ifdef MicroAlloc
    cmp  dword [edx+mip_Signature],cMipgSign
    jne  short .no_MicroPage
    call MmMicroReAlloc
    jmp  short .ptr_eax_free_old
  .no_MicroPage:
  %endif ;MicroAlloc
  ;//
  %ifndef LargeOnlyPA
      cmp dword [edx],cMmLargePageSign ;//cmp  [edx].TMmLargePage.Signature,cMmLargePageSign
      jne  .no_largePage
    .large_page:
      ;// ReAlloc LargePage:
      cmp [edx+mlp_Size],ecx ;//cmp  [edx].TMmLargePage.&Size,ecx
      je   .no_change
      ;//
      mov  ecx,esi
      mov  edx,edi
      mov  eax,ebx
      pop  esi
      pop  edi
      pop  ebx
      jmp  MmReAllocLarge
  %else ;LargeOnlyPA
    ;//jmp short .no_largePage ;// is just below...
  %endif ;LargeOnlyPA
.no_largePage:
  jmp  short .invalid
  ;//
.alloc_new:
  test  ecx,ecx
  jle   .ok
  mov   eax,ebx
  mov   edx,ecx
  call  dword [eax+mpool_AllocProc]
  test  eax,eax
  jz    short .alloc_failed
  mov   [edi],eax
  jmp   short .ok
  ;//
  %ifdef LogAlloc
  .log_error:
    pushad
    mov   eax,[edi]
    mov   edx,esi  ;// NewSize
    push  byte 0
    push  edx
    push  eax
    push  'ErR:'
    push  byte 16
    call  LogWrite
    popad
    ret
  %endif ;LogAlloc

;//%endif ;MidLinear
;//----------------------------------------------------------------

edxoffs_MmAllocMiddle_Bailout: ;// return offset of MmAllocMiddle_Bailout in EDX, avoids reloc...
  call retpop_Edx
;// function MmAllocMiddle_Bailout(ExcFrame)
MmAllocMiddle_Bailout:
  ;// Exception-handler for MmAllocMiddle
  push eax
  ;//
  lea eax,[ebx+mpool_MidLock]
  push eax
  call LeaveCriticalSection
  ;//
  pop  eax
  ;//
  jmp  MmTry_Bailout

align 4
;// function MmAllocMiddle(Pool,Size): Pointer
MmAllocMiddle:
  ;// try-entrance is fixed for MmTry_Bailout (just ebx above ebp)
  push ebx
  push ebp
  mov  ebp,esp
  ;//
  mov  ebx,eax
  push edx      ;// [ebp-4]=Size
  ;//
  cmp  dword [eax],cMmPoolSign
  jne  .bad_pool
  ;//
  cmp  edx,cMmMaxMiddleSize
  ja   .alloc_large
  ;//
  call edxoffs_MmAllocMiddle_Bailout ;//mov  edx,offset MmAllocMiddle_Bailout
  xor  ecx,ecx
  ;// note: F8 stepping over this call in debugger does not work !  (Delphi problem)
  call MmPoolMidLock_Try
  ;//
  mov  eax,ebx
  mov  edx,[ebp-4]
  call MmInternalAllocMiddle
  ;//
  lea  edx,[ebx+mpool_MidLock]
  mov  ebx,eax
  push edx
  call LeaveCriticalSection
  ;//
  mov  eax,ebx
  ;//
  xor  edx,edx
  db 64h,8Bh,22h ;//mov  esp,fs:[edx]  // why NASM cannot compile this ?!
  db 64h,8Fh,02h ;//pop  fs:[edx]  // why NASM cannot compile this ?!
  ;//
.out0:
  mov  esp,ebp
  pop  ebp
  pop  ebx
  ret
  ;//
.alloc_large:
  call MmAllocLarge
  jmp  short .out0
  ;//
.bad_pool:
  xor  eax,eax
  jmp  short .out0


align 4
;// function MmAllocStartup(Pool,Size): Pointer
MmAllocStartup:
  test edx,edx
  jle  .fail
  add  edx,byte 7
  and  edx,byte -8 ;//byte 0FFFFFFF8h ;//not 7
  cmp  edx,cMmMaxMiddleSize
  ja   .large
  ;//
  ;// Note: no need for locking during EXE/DLL startup - entry-point is always single-thread...
  push ebx
  push edx
  mov  ebx,eax
  add  eax,byte mpool_MidPage ;//lea  eax,[eax+mpool_MidPage]
  call MmMidPageAlloc
  test eax,eax
  jz   .start_end
  ;//add  esp,byte 4
  pop  edx
  ;//
  pop  ebx
  ret
  ;//
.start_end:
  ;// end of startup-page... switch to normal run-mode...
  ;//mov  ecx,offset MmAlloc
  call .here25
  .here25:
  pop  ecx
  add  ecx,(MmAlloc - .here25)
  ;//
  mov  eax,ebx
  mov  [eax+mpool_AllocProc],ecx
  pop  edx
  pop  ebx
  ;//jmp  MmAlloc
  jmp  ecx
  ;//
.large:
  jmp short MmAllocLarge
  ;//
.fail:
  xor  eax,eax
  ret

align 4
;// function MmAllocLarge(Pool,Size): Pointer
%ifndef LargeOnlyPA
;// original efficient code:
MmAllocLarge:
  ;// Size and Pool are already checked...
  ;//
  ;// if (Size and $FFF=0) then return MmAllocPageAligned(Pool,Size)
  %ifdef MINIMM_PAGEALIGNED ;//{$ifdef MINIMM_PAGEALIGNED}
  test edx,0FFFh
  jz   .page_aligned
  %endif ;MINIMM_PAGEALIGNED ;//{$endif MINIMM_PAGEALIGNED}
  ;//
.no_aligned:
  push ebx
  mov  ebx,eax
  push edx
  ;//
  add  edx,0FFFh+16
  and  edx,0FFFFF000h ;// Size:=Longint(Cardinal(Size+(16+$FFF)) and $FFFFF000);
  push edx
  ;//
  ;//Large:=Pool.VirtPool.AllocRawPage(Pool.VirtPool.Arg,Size);
  mov  eax,[ebx+mpool_VirtPool+vp_Arg]
  call dword [ebx+mpool_VirtPool+vp_AllocRawPage]
  ;//
  ;//if (Large<>nil) then begin
  test eax,eax
  jz   .failed
  ;// Large.Signature:=cMmLargePageSign;
  mov  dword [eax],cMmLargePageSign ;//mov  [eax].TMmLargePage.Signature,cMmLargePageSign
  ;// Large.Capacity:=Size;
  pop dword [eax+mlp_Capacity] ;//pop  [eax].TMmLargePage.Capacity
  ;// Large.Size:=InSize;//Size-16;
  pop dword [eax+mlp_Size] ;//pop  [eax].TMmLargePage.&Size
  ;// Large.Pool:=Pool;
  mov [eax+mlp_Pool],ebx ;//mov  [eax].TMmLargePage.Pool,ebx
  ;// Result:=@Large.Data;
    %ifdef LogAlloc
    lea edx,[eax+mlp_Data]
    push dword [eax+mlp_Capacity]
    push dword [eax+mlp_Size]
    push edx
    push 'L:'
    push byte 16
    call LogWrite
    %endif ;LogAlloc
  add eax,byte mlp_Data ;//lea eax,[eax+mlp_Data] ;//lea  eax,[eax].TMmLargePage.Data
  pop  ebx
  ret
  ;//
%ifdef MINIMM_PAGEALIGNED ;//{$ifdef MINIMM_PAGEALIGNED}
.page_aligned:
  ;// for other pool, we would not be able to free this memory later...
  cmp byte [eax+mpool_IsMain],0
  jz  .no_aligned
  nop
  ;//
  jmp  MmAllocPageAligned
%endif ;MINIMM_PAGEALIGNED ;//{$endif MINIMM_PAGEALIGNED}
  ;//
.failed:
  ;//Result:=MmOutOfMemoryError(Size,Pointer(Pool));
  pop  eax
  mov  edx,ebx
  call MmOutOfMemoryError
  pop  edx
  pop  ebx
  ret

%else ; --> LargeOnlyPA
;// function MmAllocLarge(Pool,Size): Pointer
MmAllocLarge:
  cmp  byte [eax+mpool_IsMain],0
  je  .main
  push edx
  call MmGetMainPool
  pop  edx
.main:
  jmp  MmAllocPageAligned

%endif ;LargeOnlyPA

%ifdef Poison_Free
;//function E5Clear(mem,size): Pointer
;// clearing -small-and- middle blocks with E5, all sizes are dword-round...
;// preserves all other registers but clears ECX...
  %if 0
    E5Clear_v2a:
      push edi
      push eax
      mov  ecx,edx
      mov  edi,eax
      shr  ecx,2
      ;//mov  eax,0E5E5E5E5h
      mov  eax,0EEFEEEFEh
      cld
      rep  stosd
      pop  eax
      pop  edi
      ret
  %endif ;//v2a
  
  %if 0 ;//x240314: replaced...
    E5Clear:
      push edi
      push eax
        %ifdef LogAlloc__xx
        ;// log clearing also:
        pushad
        and  edx,000FFFFFFh
        or   edx,0EE000000h
        push eax
        push edx
        push byte 8
        call LogWrite
        popad
        %endif ;LogAlloc - old
      mov  ecx,edx
      test edx,edx
      mov  edi,eax
      jle  .skip
      shr  ecx,2
      shl  eax,8
      mov  ax,di
      and  eax,000FF00FFh  ;// displace low word of address in first dword of clear pattern...
      or   eax,0EE00EE00h
      dec  ecx
      cld
      stosd
      mov  eax,0EEFEEEFEh
      rep  stosd
    .skip:
      pop  eax
      pop  edi
      ret
  %endif ;old

;//function E5Clear_mid(mem,size): Pointer
;// this version now clears usually a longer space...
E5Clear_mid: ;//New240314
  push ebp
  mov  ebp,esp
  push edi
  push eax
  ;//mov  edi,eax
  cmp  edx,byte 3
  jle  .out
  shr  edx,2  ;// clearing dwords...
  ;// align stack on 16-byte boundary
  sub  esp,byte 32
  and  esp,byte -10h
  ;//
  mov  eax,0EEFEEEFEh
  ;//mov  [esp],eax
  ;//mov  [esp+4],eax
  ;//mov  [esp+8],eax
  ;//mov  [esp+12],eax
  mov  edi,esp
  stosd
  stosd
  stosd
  stosd
  movaps xmm0,[esp]
  mov   edi,[ebp-8]
  ;//
.cy1:
  test edi,0Fh
  jz   .aligned
  stosd
  dec  edx
  jnz  .cy1
  ;//
  nop
  jmp  short .out
  ;//
.aligned:
  cmp  edx,byte 32
  jge  .large
.go_cy2:
  sub  edx,byte 4
  jl   .last
.cy2:
  movaps [edi],xmm0
  add  edi,byte 16
  sub  edx,byte 4
  jge  .cy2
.last:
  add  edx,byte 4
  jle  .out
.cy3:
  stosd
  dec  edx
  jnz  .cy3
.out:
  mfence
  lea  esp,[ebp-8]
  pop  eax
  pop  edi
  pop  ebp
  ret
.large:
  sub  edx,byte 32 ;// 128 bytes...
  jl   .go_cy4
.cy128:
  movaps [edi],xmm0
  movaps [edi+16],xmm0
  movaps [edi+16*2],xmm0
  movaps [edi+16*3],xmm0
  movaps [edi+16*4],xmm0
  movaps [edi+16*5],xmm0
  movaps [edi+16*6],xmm0
  movaps [edi+16*7],xmm0
  add  edi,128
  sub  edx,byte 32
  jge  .cy128
.go_cy4:
  add  edx,byte (32-16)
  jl   .break4
.cy4:
  movaps [edi],xmm0
  movaps [edi+16],xmm0
  movaps [edi+32],xmm0
  movaps [edi+48],xmm0
  add  edi,byte 64
  sub  edx,byte 16
  ;//jge  .cy4
.break4:
  add  edx,byte 16
  jmp  short .go_cy2

nSmallClears equ 20  ;// 17 needed, must be divisible by 4... note wSmallClears below...

;// function BuildSmallClears(SmallClears): Pointer; -- pre-allocate at least 20*4+16 +16 for align +8 security barrier = 120 bytes
BuildSmallClears:
  call .pushed_wsmclr
.wSmallClears:
  dw  (SmallClear_0 - $)
  dw  (SmallClear_1 - $)
  dw  (SmallClear_2 - $)
  dw  (SmallClear_3 - $)
  dw  (SmallClear_4 - $)
  dw  (SmallClear_5 - $)
  dw  (SmallClear_6 - $)
  dw  (SmallClear_7 - $)
  dw  (SmallClear_8 - $)
  dw  (SmallClear_9 - $)
  dw  (SmallClear_10 - $)
  dw  (SmallClear_11 - $)
  dw  (SmallClear_12 - $)
  dw  (SmallClear_13 - $)
  dw  (SmallClear_14 - $)
  dw  (SmallClear_15 - $)
  dw  (SmallClear_16 - $)
  dw  (SmallClear_0 - $)
  dw  (SmallClear_0 - $)
  dw  (SmallClear_0 - $)
.pushed_wsmclr:
  pop   edx
  push  edi
  lea   edi,[eax+(8+15)]
  and   edi,byte -10h
  push  byte nSmallClears ;// =20, 17 needed, must be divisible by 4, so that clear-pattern is aligned on 16-byte boundary
  pop   ecx
.cy:
  movsx eax,word [edx]
  add   eax,edx
  add   edx,byte 2
  stosd
  dec   ecx
  jnz   .cy
  mov   eax,0EEFEEEFEh
  stosd
  stosd
  stosd
  stosd
  lea   eax,[edi-(nSmallClears*4+16)]
  pop   edi
  ret

SmallClear_16:
  movaps [ebx+15*16],xmm0
SmallClear_15:
  movaps [ebx+14*16],xmm0
SmallClear_14:
  movaps [ebx+13*16],xmm0
SmallClear_13:
  movaps [ebx+12*16],xmm0
SmallClear_12:
  movaps [ebx+11*16],xmm0
SmallClear_11:
  movaps [ebx+10*16],xmm0
SmallClear_10:
  movaps [ebx+9*16],xmm0
SmallClear_9:
  movaps [ebx+8*16],xmm0
SmallClear_8:
  movaps [ebx+7*16],xmm0
SmallClear_7:
  movaps [ebx+6*16],xmm0
SmallClear_6:
  movaps [ebx+5*16],xmm0
SmallClear_5:
  movaps [ebx+4*16],xmm0
SmallClear_4:
  movaps [ebx+3*16],xmm0
SmallClear_3:
  movaps [ebx+2*16],xmm0
SmallClear_2:
  movaps [ebx+16],xmm0
SmallClear_1:
  movaps [ebx],xmm0
SmallClear_0:
  mfence
  ret

%endif ;Poison_Free

;// No checking, discards EDX,ECX, preserves EAX, clears 12 bytes in unlinked entry...
;// function MmRelUnlinkC12(RelEntry): Pointer;
MmRelUnlinkC12:
  push ebx
  mov  ecx,[eax] ;// OffsNext
  mov  edx,[eax+4] ;// OffsPrior
  mov  ebx,ecx
  sub  ebx,edx ;// OffsNext-OffsPrior
  mov  [eax+edx],ebx ;// Prior.OffsNext:=OffsNext-OffsPrior;
  neg  ebx
  mov  [eax+ecx+4],ebx ;// Next.OffsPrior:=OffsPrior-OffsNext;
  ;// clear 12 bytes:
  xor  ebx,ebx
  mov  [eax],ebx
  mov  [eax+4],ebx
  mov  [eax+8],ebx
  ;//
  pop  ebx
  ret

;//type TMmFreeExcFrame -- probably unused?
exf_next         equ 0
exf_ExcHandler   equ 4
exf_pContinue    equ 8
exf_SavedRegs    equ 12

;//type TMidLockTryFrame
mltf_next        equ 0 ;// PExcFrame
mltf_ExcHandler  equ 4 ;// HandlerProc
mltf_BailProc    equ 8
mltf_RegEsi      equ 12
mltf_RegEdi      equ 16
mltf_RegEbx      equ 20
mltf_RegEbp      equ 24
mltf_FailResult  equ 28
  mltf__sizeOf equ 32

align 4
;// function MmPoolMidLock_Try(Pool,BailProc,FailResult)
MmPoolMidLock_Try:
  xchg [esp],ecx
  ;//
  push ebp
  push ebx
  push edi
  push esi
  ;//
  push edx
  ;// push offset MmPoolMidLock_HandleException
  call edxoffs_MmPoolMidLock_HandleExc
  push edx
  ;//
  xor  edx,edx
  db 64h,0FFh,32h ;//push fs:[edx]     // why NASM cannot compile this?!
  db 64h,89h,22h ;//mov  fs:[edx],esp // why NASM cannot compile this?!
  ;//
  push ecx ;// ret-address
  ;//
  add eax,byte mpool_MidLock ;//lea  eax,[eax].TMmPool.MidLock
  push eax
  call EnterCriticalSection
  ret


edxoffs_MmPoolMidLock_HandleExc:
  call retpop_Edx ;// just above MmPoolMidLock_HandleException
;// function MmPoolMidLock_HandleException()
MmPoolMidLock_HandleException:
  cUnwinding          equ 2
  cUnwindingForExit   equ 4
  cUnwindInProgress   equ cUnwinding | cUnwindingForExit

  %ifdef Halt_Except
  jmp short $
  %endif ;Halt_Except

;// function GuardExcHandler(excPtr: PExceptionRecord; errPtr: PGuardExcFrame; ctxPtr,dspPtr: Pointer): Longint; stdcall;
        ;//{ ->    [ESP+ 4] excPtr: PExceptionRecord       }
        ;//{       [ESP+ 8] errPtr: PExcFrame              }
        ;//{       [ESP+12] ctxPtr: Pointer                }
        ;//{       [ESP+16] dspPtr: Pointer                }
        ;//{ <-    EAX return value - always one   }
        ;//
        MOV     EAX,[ESP+4]
        test byte [eax+4],6 ;//test dword [eax+4],6 ;//TEST    [EAX].TExceptionRecord.ExceptionFlags,cUnwindInProgress
        jnz     .exit_try
        ;//
  ;//...
.GoUnwind:
  cld
        or dword [eax+4],byte 2 ;//OR      [EAX].TExceptionRecord.ExceptionFlags,cUnwinding
        mov     edx,[esp+8]
  ;// call RtlUnwind:
        PUSH    byte 0
        PUSH    EAX
        ;//PUSH    offset @@returnAddress
        call .raOffs
        .raOffs:
        add  dword [esp],byte (.returnAddress - .raOffs)
        ;//
        PUSH    EDX
        CALL    RtlUnwind
  ;// RtlUnwind returns here...
.returnAddress:
  mov  eax,[esp+8] ;// ESP=PExcFrame
  xor  edx,edx
  mov  ecx,[eax] ;//mov  ecx,[eax].TMidLockTryFrame.next
  db 64h,89h,0Ah ;//mov  fs:[edx],ecx ;// pop prev-frame // why NASM refrains to compile that ?
  ;//
  mov  esi,[eax+mltf_RegEsi]
  mov  edi,[eax+mltf_RegEdi]
  mov  ebx,[eax+mltf_RegEbx]
  mov  ebp,[eax+mltf_RegEbp]
  ;//
  jmp dword [eax+mltf_BailProc] ;//jmp  [eax].TMidLockTryFrame.BailProc // go to MmMidGrowInplace_Bailout
  ;//
.exit_try:
  push byte 1
  pop  eax
  ret

;//retpop_Edx:
;//  pop  edx
;//  ret

align 4
;// function MmTry_Bailout(ExcFrame)
MmTry_Bailout:
  test eax,eax
  jz   .skip_res
  mov  eax,[eax+mltf_FailResult] ;//mov  eax,[eax].TMidLockTryFrame.FailResult
.skip_res:
  ;// undo stack-frame entrance in MmMiddleGrowInplace and return to original caller:
  mov  esp,ebp
  pop  ebp
  pop  ebx
  ret

;// now used also by HugeVPool ...
edxoffs_MmMidGrowInplace_Bailout:
  call retpop_Edx
;// function MmMidGrowInplace_Bailout(ExcFrame)
MmMidGrowInplace_Bailout:
  ;// Exception-handler for MmMiddleGrowInplace and MmMiddleShrinkInplace
  push eax
  ;//
  lea  eax,[ebx+mpool_MidLock]
  push eax
  call LeaveCriticalSection
  ;//
  pop  eax
  ;//
  jmp  short MmTry_Bailout

;// function MmCheckFreePageBase(Item): Boolean
MmCheckFreePageBase:
  ;// Freeing Item and $FFF=0  -- can be VeryLarge item allocated at page-start?
  %ifdef MINIMM_PAGEALIGNED
  ;//if (Item<>nil)
  test eax,0FFFF0000h
  jz   .bad
  ;//and (Cardinal(Item) and $FFF=0)
  test eax,0FFFh
  jnz  .bad
  ;//then Result:=MmFreePageAligned(g_MainMmPool,Item,Item); exit;
    ;//mov  edx,eax
    ;//mov  ecx,eax
    ;//mov  eax,[g_MainMmPool]
    ;//jmp  MmFreePageAligned
  push eax
  call MmGetMainPool
  pop  edx
  mov  ecx,edx
  jmp  MmFreePageAligned
  %endif ;MINIMM_PAGEALIGNED
.bad:
  ;//Result:=False;
  xor  eax,eax
  ret

align 4
;// function MmFree(Pool,Item): Boolean
MmFree:
  ;//xp: push eax -- Pool arg unused...
  mov  ecx,edx
  mov  eax,edx
  and  edx,0FFFFF000h
  jz   near .bad_ptr
  test eax,0FFFh
  jz   .page_base
  cmp dword [edx],cMmPageSign ;//cmp  [edx].TMmPage.Signature,cMmPageSign
  jne  .diff_page
  ;// check 16-byte alignment:
  test  al,0Fh ;//test eax,0Fh
  jnz  near .not_exact
  ;// check alignment to type-size:
    %ifdef Align_v2
      push edx
    %endif
  mov  ecx,[edx+mp_Typ]
  call dword [ecx+mt_CheckAligned]
  test eax,eax
    %ifdef Align_v2
      pop edx
    %endif
  jz   near .not_exact
  ;//
  ;// check, if already free:
  cmp word [eax+mfi_wSign],cMmFreeSign ;//cmp  [eax].TMmFreeItem.wSign,cMmFreeSign
  je   .check_free
.free_ok:
  ;//
  ;//New240314 - moved from below...
  push ebx
  mov  ebx,eax
  ;//
  %ifdef Poison_Free
            %if 0 ;//x240314:
              push edx
              mov  edx,[edx+mp_Typ]
              movzx edx,byte [edx+mt_ItemSize]
              shl  edx,4
              call E5Clear
              pop  edx
            %endif ;old
    mov   ecx,[edx+mp_Typ]
    movzx eax,byte [ecx+mt_ItemSize]
    mov   ecx,[ecx+mt_Pool]
    mov   ecx,[ecx+mpool_SmallClears]
    movaps xmm0,[ecx+nSmallClears*4]
    call  dword [ecx+4*eax] ;// SmallClear_1 .. SmallClear_16
  %else ;orig_clear
    ;// clear vmt:
    xor  ecx,ecx
    mov  [eax],ecx
    mov  [eax+4],ecx
    mov  [eax+8],ecx
    mov  [eax+12],ecx
  %endif ;orig_clear
  ;//
    %ifdef LogAlloc
      push edx
      ;//
      mov  edx,[edx+mp_Typ]
      movzx edx,byte [edx+mt_ItemSize]
      shl  edx,4+16
      mov  dx,'F:'
      push ebx ;//eax
      push edx
      push byte 8
      call LogWrite
      ;//
      pop  edx
    %endif ;LogAlloc
  ;//
  ;//push ebx -- moved above...
  ;//mov  ebx,eax
  ;//
  ;// convert to TileIndex
  mov  ecx,ebx ;//eax
  and  ecx,0FF0h
  shr  ecx,4
  ;//
  mov word [ebx+mfi_wSign],cMmFreeSign ;//mov  [ebx].TMmFreeItem.wSign,cMmFreeSign
.retry:
  mov al,[edx+mp_FreeList] ;//mov  al,[edx].TMmPage.FreeList
  mov [ebx+mfi_NextFree],al ;//mov  [ebx].TMmFreeItem.NextFree,al
  lock cmpxchg [edx+mp_FreeList],cl ;//lock cmpxchg [edx].TMmPage.FreeList,cl
  jne  .retry_f
  ;//
  mov  cl,1
  xadd [edx+mp_FreeCount],cl ;//xadd [edx].TMmPage.FreeCount,cl
  cmp  cl,4 ;// re-link with 5 free items...
  ;//? cmp  cl,9 // re-link with 10 free items... (not much difference)
  je   .check_link_free
  inc  cl ;//New200822 -- needed after xadd...
  cmp cl,[edx+mp_MaxFreeCount] ;//cmp  cl,[edx].TMmPage.MaxFreeCount
  jae  .empty_page
  ;//
.done_ok:
  mov  eax,1
  pop  ebx
  ;//xp: mov  [esp],eax ;// clear Pool from stack...
  ;//xp: pop  edx
  ret
  ;//
.diff_page:
  ;//mov  ecx,eax  ;//x240318: already...
    %ifdef MicroAlloc
    cmp  dword [edx],cMipgSign
    je   near MmMicroFree
    %endif ;Micro
  ;//xp: pop  eax
  xor  eax,eax
  jmp  MmFreeMiddle ;//xp: Pool arg unused...
  ;//
.page_base:
  nop
  jmp  MmCheckFreePageBase
  ;//
.retry_f:
  db 0F3h
  nop
  jmp short .retry
  ;//
.empty_page:
  ;// the whole page seems empty, check to release it...
  ;//xp: mov  eax,[esp+4]
  mov eax,[edx+mp_Typ] ;//mov  eax,[edx].TMmPage.Typ
  mov eax,[eax+mt_Pool] ;//mov  eax,[eax].TMmType.Pool
  call MmCheckReleasePage
  jmp short .done_ok
  ;//
.check_free:
  ;// item seems already free, check it:
  mov  dl,1
  call MmCheckItemFree
  mov  edx,eax
  and  edx,0FFFFF000h
  jnz  .free_ok
  xor  eax,eax
  jmp short .bad_ptr
  ;//
.check_link_free:
  cmp dword [edx+mp_NextFreePage],byte 0 ;//cmp  [edx].TMmPage.NextFreePage,0
  jnz  .done_ok
.link_free:
  ;// link page to free-list:
  ;//xp: mov  eax,[esp+4] // Pool...
  mov eax,[edx+mp_Typ]  ;//mov  eax,[edx].TMmPage.Typ
  mov eax,[eax+mt_Pool] ;//mov  eax,[eax].TMmType.Pool
  call MmLinkFreePage
  jmp short .done_ok
  ;//
.not_exact:
.bad_ptr:
  call Dbg_BadPtr ;//mov g_Mm_BadPtr,eax
  xor  eax,eax
  ;//note: ebx pushed later, not in this branch...
  ;//xp: mov  [esp],eax // clear Pool from stack...
  ;//xp: pop  edx
  ret

align 4
;// function MmQuerySizeFast(Item): integer
;// does not query MicroAlloc or page-aligned...
MmQuerySizeFast:
  mov  edx,eax
  and  edx,0FFFFF000h
  jz   .bad_ptr  ;// page-aligned not needed here, is zero-initialized...
  ;//
  cmp dword [edx],cMmPageSign ;//cmp  [edx].TMmPage.Signature,cMmPageSign
  jne  .diff_page
  movzx eax,byte [edx+mp_ItemSize] ;//movzx eax,[edx].TMmPage.ItemSize
  shl  eax,4
  ret
.diff_page:
  nop
  jmp  MmQuerySizeMiddle
.bad_ptr:
  xor  eax,eax
  ret

align 4
;// function MmQuerySizeCheck(Item): integer
MmQuery:
MmQuerySizeCheck:
  mov  edx,eax
  and  edx,0FFFFF000h
  jz   .bad_ptr
  test eax,0FFFh
  jz   .page_aligned
  cmp dword [edx],cMmPageSign ;//cmp  [edx].TMmPage.Signature,cMmPageSign
  jne  .diff_page
  ;// check 16-byte rounding:
  test eax,0Fh
  jnz  .not_exact
  ;// check alignment to type-size:
    %ifdef Align_v2
      push edx
    %endif
  mov  ecx,[edx+mp_Typ] ;//mov  ecx,[edx].TMmPage.Typ
  call dword [ecx+mt_CheckAligned] ;//call [ecx].TMmType.CheckAligned
  test eax,eax
    %ifdef Align_v2
      pop edx
    %endif
  jz   .not_exact
  ;//
  cmp  word [eax+mfi_wSign],cMmFreeSign ;//cmp  [eax].TMmFreeItem.wSign,cMmFreeSign //x200822: cmp  [eax].TMmFreeItem.bSign,cMmFreeSign
  je   .check_free
.item_ok:
  ;//
  movzx eax,byte [edx+mp_ItemSize] ;//movzx eax,[edx].TMmPage.ItemSize
  shl  eax,4
  ret
  ;//
.check_free:
  xor  edx,edx
  call MmCheckItemFree
  mov  edx,eax
  and  edx,0FFFFF000h
  jnz  .item_ok
  xor  eax,eax
  jmp short .bad_ptr
  ;//
.diff_page:
  nop
  jmp  MmQuerySizeMiddle
  ;//
.page_aligned:
  %ifdef MINIMM_PAGEALIGNED
  ;//mov  edx,eax
  ;//mov  eax,[g_MainMmPool]
  push eax
  call MmGetMainPool
  pop  edx
  ;//
  jmp  MmQueryPageAligned
  %endif ;MINIMM_PAGEALIGNED
.bad_ptr:
.not_exact:
  xor  eax,eax
  ret

%ifdef LogAlloc
LogRealloc: ;// just before rep  movsd
  pushad
  shl ecx,2
  push ecx ;// move size
  push esi
  push edi
  push 'Rsm:'
  push byte 16
  call LogWrite
  popad
  ret
%endif ;LogAlloc

%ifdef C_MEM_Handlers
;// function MmReAlloc0(Pool,var Ptr,NewSize): Boolean -- zero-init new memory...
MmReAlloc0:
  test ecx,ecx
  jle  .free_old
  push ebp
  mov  ebp,esp
  push edx   ;// [ebp-4] = ^Ptr
  push eax   ;// [ebp-8] = Pool
  push ecx   ;// [ebp-12] = NewSize
  ;//
  mov  eax,[edx]
  push eax   ;// [ebp-16] = Ptr
  call MmQuerySizeCheck
  test eax,eax
  jz   .alloc_new
  push eax   ;// [ebp-20] = OldSize
  ;//
  cmp  eax,[ebp-12]
  je   .nochange
  ;//
  xor  eax,eax
  mov  edx,[ebp-4]
  xchg [edx],eax
  lea  edx,[ebp-16]
  mov  [edx],eax ;// re-alloc our copy of the pointer first before clearing...
  ;//
  mov  eax,[ebp-8]
  mov  ecx,[ebp-12]
  call MmReAlloc
  test al,al
  jz   .fail
  ;//
  mov  edx,[ebp-20]  ;// OldSize
  add  edx,byte 3
  and  edx,byte -4 ;// dword-round
  mov  ecx,[ebp-12]  ;// NewSize
  add  ecx,byte 3
  and  ecx,byte -4 ;// dword-round
  ;// zero-init new space: (shrinking&nochange checked below)
  push edi
  mov  edi,[ebp-16]
  xor  eax,eax
  add  edi,edx
  sub  ecx,edx
  jle  .skip_clear
  cld
  rep  stosd
.skip_clear:
  pop  edi
  ;// return ptr to app...
.noclear:
  mov  eax,[ebp-16]
  mov  edx,[ebp-4]
  mov  [edx],eax
.nochange:
  push byte 1
  pop  eax
.out:
  mov  esp,ebp
  pop  ebp
  ret
.free_old:
  xor  ecx,ecx
  xchg [edx],ecx
  mov  edx,ecx
  jmp  MmFree
.alloc_new:
  mov  eax,[ebp-8]
  mov  edx,[ebp-12]
  call MmAlloc0
  mov  edx,[ebp-4]
  mov  [edx],eax
  xor  edx,edx
  test eax,eax
  setnz dl
  mov  eax,edx
  jmp short .out
.fail:
  ;//!!! tmp
  mov  eax,[ebp-4]
  mov  eax,[eax]
  call Dbg_BadPtr
  ;//
  xor  eax,eax
  jmp short .out
  
%endif ;C_MEM_Handlers

%ifndef LargeOnlyPA
align 4
;// function MmReAllocLarge(Pool,var P,NewSize): Boolean
;//                         EAX  [EDX] ECX     ->AL
MmReAllocLarge:
  ;//!!!todo needs: VirtPool.ReAllocRawPage:function(Arg: Pointer; var Page: Pointer; OldSize,NewCapacity,NewCommit: integer): Boolean register;
  push ebx
  push ecx ;// [esp+4]=NewSize
  push edx ;// [esp]=^P
  mov  ebx,eax
  ;//
  add  ecx,0FFFh+16
  and  ecx,0FFFFF000h
  mov  edx,[edx]
  and  edx,0FFFFF000h
  cmp dword [edx],cMmLargePageSign ;//cmp  [edx].TMmLargePage.Signature,cMmLargePageSign
  jne  near .bad_page
  cmp  ecx,[edx+mlp_Capacity] ;//cmp  ecx,[edx].TMmLargePage.Capacity
  ja   near .growing_capa
  mov  eax,[edx+mlp_Size] ;//mov  eax,[edx].TMmLargePage.&Size
  add  eax,0FFFh
  and  eax,0FFFFF000h
  cmp  ecx,eax ;//?? [edx].TMmLargePage.&Size
  ja   .growing_commit
  je   .no_change1
  ;// shrinking commit:
  add  ecx,ecx
  cmp  ecx,[edx+mlp_Capacity] ;//cmp  ecx,[edx].TMmLargePage.Capacity
  jb   .shrink_half
  shr  ecx,1
  ;// shrinking to more than half current capacity, just decommit...
  push MEM_DECOMMIT
  sub  eax,ecx
  push eax
  lea  eax,[edx+ecx]
  push eax
  mov  eax,[esp+4+12]
  mov  [edx+mlp_Size],eax ;//mov  [edx].TMmLargePage.&Size,eax
  call VirtualFree
.no_change:
.done_ok:
  ;//mov  eax,1
  push byte 1
  pop  eax
  ;//
  add  esp,byte 8
  pop  ebx
  ret
  ;//
.no_change1:
  ;// still within same 4kb page...
  ;// just change Size to actual used size:
  mov  eax,[esp+4]
  mov  [edx+mlp_Size],eax ;//mov  [edx].TMmLargePage.&Size,eax
  jmp short .done_ok
  ;//
.shrink_half:
  ;// shrinking to less than half current size - realloc in new...
  mov  edx,[esp+4]
  mov  eax,ebx
  call [eax+mpool_AllocProc] ;//call [eax].TMmPool.AllocProc
  mov  ecx,[esp+4]
  ;//
.after_realloc: ;// ECX=MoveSize, EAX=New, [esp]=^P
  test eax,eax
  jz   .alloc_failed
  ;//
  mov  edx,[esp]
  push edi
  push esi
  add  ecx,byte 3
  shr  ecx,2
  mov  esi,[edx]
  mov  edi,eax
  ;//
    %ifdef LogAlloc
    call LogRealloc
    %endif ;LogAlloc
  ;//
  cld
  rep  movsd
  pop  esi
  pop  edi
  ;//
  xchg [edx],eax
  ;//
  mov  edx,eax
  xor  eax,eax
  call MmFree
  ;//
  jmp short .done_ok
  ;//
.growing_commit:
  ;// Growing CommitSize, can retain current Capacity... EAX=PageRound(OldSize),ECX=PageRound(NewSize),EDX=Page
  sub  ecx,eax ;// ecx=AddSize
  push edx
  ;//
  ;//push byte PAGE_READWRITE
  ;//push MEM_COMMIT
  ;//push ecx
  ;//add  eax,edx
  ;//push eax
  ;//call VirtualAlloc
  ;//zmena240215:
  push ecx
  add  eax,edx
  push eax
  call MmVCommit
  ;//
  test eax,eax
  pop  edx
  jz   .alloc_failed
  mov  eax,[esp+4]
  mov  [edx+mlp_Size],eax ;//mov  [edx].TMmLargePage.&Size,eax
  jmp short .done_ok
  ;//
.growing_capa:
  ;// re-allocate in new space:
  ;//!!! use smarter ReAllocRawPage with some reserve in advance ?!
  mov  edx,[esp+4] ;//?? ecx
  mov  eax,ebx
  call [eax+mpool_AllocProc] ;//call [eax].TMmPool.AllocProc
  test eax,eax
  jz   .alloc_failed
  ;//
  mov  edx,[esp]
  mov  edx,[edx]
  and  edx,0FFFFF000h
  mov  ecx,[edx+mlp_Size] ;//mov  ecx,[edx].TMmLargePage.&Size ;// MoveSize=Old.Size
  jmp short .after_realloc
  ;//
.bad_page:
.alloc_failed:
  xor  eax,eax
  add  esp,byte 8
  pop  ebx
  ret
%endif ;!LargeOnlyPA

;// common code for (old MmMiddleGrowInplace and MmMiddleShrinkInplace and) HugeVPool ...
;// eax=Pool, edx=Item, ecx=NewSize, [esp]=[ebp+8]=InternalProc
MmMiddle_GrowShrink:
  push ebx
  push ebp
  mov  ebp,esp
  ;//
  mov  ebx,eax
  push edx
  push ecx
  ;//
  call edxoffs_MmMidGrowInplace_Bailout ;//mov  edx,offset MmMidGrowInplace_Bailout
  xor  ecx,ecx
  ;// note: F8 stepping over this call in debugger does not work ! (Delphi problem)
  call MmPoolMidLock_Try
  ;//
  mov  eax,[ebp-4]
  mov  edx,[ebp-8]
  call dword [ebp+8] ;//call InternalMmMiddleGrowInplace
  ;//
  push eax
  lea eax,[ebx+mpool_MidLock] ;//lea  eax,[ebx].TMmPool.MidLock
  push eax
  call LeaveCriticalSection
  pop  eax
  ;//
  xor  edx,edx
  db 64h,8Bh,22h ;//mov  esp,fs:[edx]       // why NASM refuses to compile this ?!
  db 64h,8Fh,02h ;//pop  dword ptr fs:[edx] // why NASM refuses to compile this ?!
  ;//
  mov  esp,ebp
  pop  ebp
  pop  ebx
  ;//
  pop  ecx ;// InternalProc
  ret

;// function MmCheckItemFree(Item,bnFreeing): Pointer
MmCheckItemFree:
  ;// PMmFreeItem(Item).bSign=$AB - check, if it is a free item... return NIL if bad, return Item if ok
  push ebx
  mov  ebx,eax
  ;//
  and  ebx,0FFFFF000h
  mov  ecx,256
  movzx edx,byte [ebx+mp_FreeList] ;//movzx edx,[ebx].TMmPage.FreeList
  ;// while (idx<>0)
  test edx,edx
  jz   .break
.cy:
  ;// if (--C==0) break;
  dec  ecx
  jz   .break
  ;// Walk:=@Page[idx shl 4]
  add  edx,edx
  lea  edx,[ebx+edx*8]
  ;// if (Walk=Item) then return nil;
  cmp  edx,eax
  je   .found
  ;// idx:=Walk.NextFree
  movzx edx,byte [edx+mfi_NextFree] ;//movzx edx,[edx].TMmFreeItem.NextFree
  ;// while (idx<>0)
  test edx,edx
  jnz  .cy
  ;// not a linked free item...
.break:
  pop  ebx
  ret
.found:
  xor  eax,eax
  pop  ebx
  ret


;// function MmLinkFreePage(Pool,Page)
MmLinkFreePage:
  push ebx
  mov  ebx,edx
  ;//
  cmp dword [edx],cMmPageSign ;//cmp  [edx].TMmPage.Signature,cMmPageSign
  jne  .bad_page
  cmp dword [edx+mp_NextFreePage],byte 0 ;//cmp  [edx].TMmPage.NextFreePage,0
  jne  .already_linked
  ;//
  mov ecx,[edx+mp_Typ] ;//mov  ecx,[edx].TMmPage.Typ
  cmp  ecx,10000h
  jbe  .bad_type
  ;//
.retry_link:
  mov edx,[ecx+mt_FreePages] ;//mov  edx,[ecx].TMmType.FreePages
  xor  eax,eax
  lock cmpxchg [ebx+mp_NextFreePage],edx ;//lock cmpxchg [ebx].TMmPage.NextFreePage,edx
  jnz  .thread_problem ;// Page was linked by another thread?
  ;//
  mov  eax,edx
  lock cmpxchg [ecx+mt_FreePages],ebx ;//lock cmpxchg [ecx].TMmType.FreePages,ebx
  jnz  .link_failed ;// other thread linked another free-page, so we will retry...
  ;//
  pop  ebx
  xor  eax,eax
  ret
  ;//
.link_failed:
  db 0F3h
  nop
  jmp short .retry_link
  ;//
.done:
.bad_page:
.bad_type:
.thread_problem:
.already_linked:
  pop  ebx
  xor  eax,eax
  ret


;// function MmCheckReleasePage(Pool,Page)
MmCheckReleasePage:
  mov   ecx,[edx+mp_Typ]
  cmp   edx,[ecx+mt_FreePages]
  je    .out
  cmp   dword [edx+mp_NextFreePage],byte 0
  jz    .out
  lea   ecx,[eax+120]
  inc   dword [ecx+mpool_iColNeed-120]
  cmp   dword [ecx+mpool_iColNeed-120],byte 20h
  jle   .out
  sub   dword [ecx+mpool_iColNeed-120],byte 8
  call  MmCollectFree
.out:
  ret

          %ifdef Align_v1
          ;// function InitAlignTables()
          InitAlignTables:
            mov  eax,g_Div3Table ;//offset Div3Table  //fixed offset
            push byte 3
            pop  edx
            call .InitTable
            ;//
            mov  eax,g_Div5Table ;//offset Div5Table  //fixed offset
            push byte 5
            pop  edx
            call .InitTable
            ;//
            mov  eax,g_Div7Table ;//offset Div7Table  //fixed offset
            push byte 7
            pop  edx
            call .InitTable
            ;//
            mov  eax,g_Div9Table ;//offset Div9Table  //fixed offset
            push byte 9
            pop  edx
            call .InitTable
            ;//
            mov  eax,g_Div11Table ;//offset Div11Table  //fixed offset
            push byte 11
            pop  edx
            call .InitTable
            ;//
            mov  eax,g_Div13Table ;//offset Div13Table  //fixed offset
            push byte 13
            pop  edx
            call .InitTable
            ;//
            mov  eax,g_Div15Table ;//offset Div15Table  //fixed offset
            push byte 15
            pop  edx
            call .InitTable
            ;//
            ret
            ;//
          .InitTable:
            ;// in EAX=^Table, EDX=ItemSize...
            xor  ecx,ecx
            ;// Item 0 should not be set...
            add  ecx,edx
          .cy:
            bts  [eax],ecx
            add  ecx,edx
            cmp  ecx,0FFh
            jbe  .cy
            ret
          %endif ;Align_v1

%ifdef Align_v2
;// function InitAlignTables_v2(DivTables)
InitAlignTables_v2:
  push ebx
  mov  ebx,eax
  push byte 3
  pop  edx
.tcy:
  mov  eax,ebx
  ;//
.InitTable_v2:
  xor  ecx,ecx
  add  ecx,edx ;// Item 0 should not be set...
.bicy:
  bts  [eax],ecx
  add  ecx,edx
  cmp  ecx,0FFh
  jbe  .bicy
  ;//
  add  ebx,byte 32
  inc  edx
  inc  edx
  cmp  edx,byte 15
  jbe  .tcy
  ;//
  pop  ebx
  ret
%endif ;Align_v2

;// function GetAlignCheckCode(Index): TCheckAlignedProc  mt_CheckAligned
GetAlignCheckCode:
  call  .gacc2
.gacc:
  dw 0
  dw (CheckAligned1 - .gacc)
  dw (CheckAligned2 - .gacc)
  dw (CheckAligned3 - .gacc)
  dw (CheckAligned4 - .gacc)
  dw (CheckAligned5 - .gacc)
  dw (CheckAligned6 - .gacc)
  dw (CheckAligned7 - .gacc)
  dw (CheckAligned8 - .gacc)
  dw (CheckAligned9 - .gacc)
  dw (CheckAligned10 - .gacc)
  dw (CheckAligned11 - .gacc)
  dw (CheckAligned12 - .gacc)
  dw (CheckAligned13 - .gacc)
  dw (CheckAligned14 - .gacc)
  dw (CheckAligned15 - .gacc)
  dw (CheckAligned16 - .gacc)
.gacc2:
  pop   edx
  movzx ecx,word [edx+2*eax]
  lea   eax,[edx+ecx]
  ret

align 4
;// function CheckAligned1(P): Pointer
CheckAligned1:
  ;// and $F already checked...
  test eax,0FF0h
  jz   UnalignedCheck ;// item 0 is not available...
  ret

;// function CheckAligned2(P): Pointer
CheckAligned2:
  test eax,1Fh
  jnz  UnalignedCheck
  ;//test eax,0FF0h
  ;//jz   UnalignedCheck ;// item 0 is not available...
  ;//ret
  jmp short ali_a_no0

;// function CheckAligned3(P,page,typ): Pointer
CheckAligned3:
%ifdef Align_v1
  mov  ecx,eax
  shr  ecx,4
  and  ecx,0FFh
  bt   dword [g_Div3Table],ecx   ;// fixed pointer
  jnc  UnalignedCheck
  ret
%else ;Align_v2
  mov  edx,[ecx+mt_Pool]
  mov  edx,[edx+mpool_DivTables]
  mov  ecx,eax
  shr  ecx,4
  ;//and  ecx,0FFh
  jmp  short BitAlign_dc
%endif ;Align_v2

;// function CheckAligned4(P): Pointer
CheckAligned4:
  test al,3Fh ;//test eax,3Fh
  jnz  UnalignedCheck
  ;//test eax,0FF0h
  ;//jz   UnalignedCheck ;// item 0 is not available...
  ;//ret
  jmp short ali_a_no0

;// function CheckAligned5(P,page,typ): Pointer
CheckAligned5:
%ifdef Align_v1
  mov  ecx,eax
  shr  ecx,4
  and  ecx,0FFh
  bt   dword [g_Div5Table],ecx   ;// fixed pointer
  jnc  UnalignedCheck
  ret
%else ;Align_v2
  mov  edx,[ecx+mt_Pool]
  mov  ecx,eax
  mov  edx,[edx+mpool_DivTables]
  shr  ecx,4
  add  edx,byte off_Div5Table
  ;//and  ecx,0FFh
  jmp  short BitAlign_dc
%endif ;Align_v2

;// function CheckAligned6(P,page,typ): Pointer
CheckAligned6:
%ifdef Align_v1
  mov  ecx,eax
  and  ecx,0FFFh
  shr  ecx,5
  jc   UnalignedCheck
  ;//and  ecx,$FF
  bt   dword [g_Div3Table],ecx   ;// fixed pointer
  jnc  UnalignedCheck
  ret
%else ;Align_v2
  mov  edx,[ecx+mt_Pool]
  mov  ecx,eax
  mov  edx,[edx+mpool_DivTables]
  and  ecx,0FFFh
  shr  ecx,5
  jc   UnalignedCheck
BitAlign_dc:
  and  ecx,0FFh
  bt   [edx],ecx
  jnc  UnalignedCheck
  ret
%endif ;Align_v2

;// function CheckAligned7(P,page,typ): Pointer
CheckAligned7:
%ifdef Align_v1
  mov  ecx,eax
  shr  ecx,4
  and  ecx,0FFh
  bt   dword [g_Div7Table],ecx   ;// fixed pointer
  jnc  UnalignedCheck
  ret
%else ;Align_v2
  mov  edx,[ecx+mt_Pool]
  mov  ecx,eax
  mov  edx,[edx+mpool_DivTables]
  shr  ecx,4
  add  edx,byte off_Div7Table
  ;//and  ecx,0FFh
  jmp  short BitAlign_dc
%endif ;Align_v2

;// function UnalignedCheck(P): Pointer
UnalignedCheck:
  ;// Freeing unaligned pointer...
  call Dbg_BadPtr ;//g_Mm_BadPtr,eax
  ;//
  %ifdef ErrHalt
  jmp short $
  %endif ;ErrHalt
  ;//
  xor  eax,eax
  ret

;// function CheckAligned8(P): Pointer
CheckAligned8:
  test al,7Fh ;//test eax,7Fh
  jnz  UnalignedCheck2
ali_a_no0:
  test eax,0FF0h
  jz   UnalignedCheck2 ;// item 0 is not available...
  ret

;// function CheckAligned9(P,page,typ): Pointer
CheckAligned9:
%ifdef Align_v1
  mov  ecx,eax
  shr  ecx,4
  and  ecx,0FFh
  bt   dword [g_Div9Table],ecx   ;// fixed pointer
  jnc  UnalignedCheck2
  ret
%else ;Align_v2
  mov  edx,[ecx+mt_Pool]
  mov  ecx,eax
  mov  edx,[edx+mpool_DivTables]
  shr  ecx,4
  add  edx,byte off_Div9Table
  ;//and  ecx,0FFh
  jmp  short BitAlign_dc
%endif ;Align_v2

;// function CheckAligned10(P,page,typ): Pointer
CheckAligned10:
%ifdef Align_v1
  mov  ecx,eax
  and  ecx,0FFFh
  shr  ecx,5
  jc   near UnalignedCheck2
  ;//and  ecx,$FF
  bt   dword [g_Div5Table],ecx   ;// fixed pointer
  jnc  UnalignedCheck2
  ret
%else ;Align_v2
  mov  edx,[ecx+mt_Pool]
  mov  ecx,eax
  mov  edx,[edx+mpool_DivTables]
  and  ecx,0FFFh
  add  edx,byte off_Div5Table
  shr  ecx,5
  jnc  BitAlign_dc
  jmp  short UnalignedCheck2
%endif ;Align_v2

;// function CheckAligned11(P,page,typ): Pointer
CheckAligned11:
%ifdef Align_v1
  mov  ecx,eax
  shr  ecx,4
  and  ecx,0FFh
  bt   dword [g_Div11Table],ecx   ;// fixed pointer
  jnc  UnalignedCheck2
  ret
%else ;Align_v2
  mov  edx,[ecx+mt_Pool]
  mov  ecx,eax
  mov  edx,[edx+mpool_DivTables]
  shr  ecx,4
  add  edx,off_Div11Table
  ;//and  ecx,0FFh
  jmp  short BitAlign_dc
%endif ;Align_v2

;// function CheckAligned12(P,page,typ): Pointer
CheckAligned12:
%ifdef Align_v1
  mov  ecx,eax
  test ecx,30h
  jnz  UnalignedCheck2
  and  ecx,0FFFh
  shr  ecx,6
  ;//and  ecx,$FF
  bt   dword [g_Div3Table],ecx   ;// fixed pointer
  jnc  UnalignedCheck2
  ret
%else ;Align_v2
  mov  edx,[ecx+mt_Pool]
  mov  ecx,eax
  mov  edx,[edx+mpool_DivTables]
  test ecx,3Fh
  jnz  UnalignedCheck2
  and  ecx,0FFFh
  shr  ecx,6
  jmp  near BitAlign_dc
%endif ;Align_v2

;// function CheckAligned16(P): Pointer
CheckAligned16:
  test eax,0FFh
  jz ali_a_no0
  ;//
UnalignedCheck2:
  jmp near UnalignedCheck

;// function CheckAligned13(P,page,typ): Pointer
CheckAligned13:
%ifdef Align_v1
  mov  ecx,eax
  shr  ecx,4
  and  ecx,0FFh
  bt   dword [g_Div13Table],ecx   ;// fixed pointer
  jnc  UnalignedCheck2
  ret
%else ;Align_v2
  mov  edx,[ecx+mt_Pool]
  mov  ecx,eax
  mov  edx,[edx+mpool_DivTables]
  shr  ecx,4
  add  edx,off_Div13Table
  ;//and  ecx,0FFh
  jmp  near BitAlign_dc
%endif ;Align_v2

;// function CheckAligned14(P,page,typ): Pointer
CheckAligned14:
%ifdef Align_v1
  mov  ecx,eax
  and  ecx,0FFFh
  shr  ecx,5
  jc   UnalignedCheck2
  ;//and  ecx,$FF
  bt   dword [g_Div7Table],ecx   ;// fixed pointer
  jnc  UnalignedCheck2
  ret
%else ;Align_v2
  mov  edx,[ecx+mt_Pool]
  mov  ecx,eax
  mov  edx,[edx+mpool_DivTables]
  and  ecx,0FFFh
  add  edx,byte off_Div7Table
  shr  ecx,5
  jnc  BitAlign_dc
  jmp short UnalignedCheck2
%endif ;Align_v2

;// function CheckAligned15(P,page,typ): Pointer
CheckAligned15:
%ifdef Align_v1
  mov  ecx,eax
  shr  ecx,4
  and  ecx,0FFh
  bt   dword [g_Div15Table],ecx   ;// fixed pointer
  jnc  UnalignedCheck2
  ret
%else ;Align_v2
  mov  edx,[ecx+mt_Pool]
  mov  ecx,eax
  mov  edx,[edx+mpool_DivTables]
  shr  ecx,4
  add  edx,off_Div15Table
  ;//and  ecx,0FFh
  jmp  near BitAlign_dc
%endif ;Align_v2


;// function Dbg_BadPtr(Ptr)
Dbg_BadPtr:
  mov [g_Mm_BadPtr],eax  ;//!!!todo - fixed address into data segment ?!
  ret


align 4
;// function MmOutOfMemoryError(Size,Typ): Pointer
MmOutOfMemoryError:
  ;// Out of memory:  Typ may be PMmType or PMmPool... with PMmType, Size=0 ...
  ;//{$ifdef MINIMM_DBG}
  ;//DbgBreak(Typ);
  ;//{$endif MINIMM_DBG}
  %ifdef ErrHalt
    jmp short $ ;//halt
  %endif
  ;//todo - raise exception ?!
  
  xor  eax,eax ;//Result:=nil;
  ret

align 4
;// function MmAcquirePage(Pool,Typ): Pointer
MmAcquirePage:
  ;// Need another free page of this type:
  cmp dword [eax],cMmPoolSign ;//cmp  [eax].TMmPool.Signature,cMmPoolSign
  jne  near .badPool
  push edx
  ;// AllocRawPage uses locking anyway, so we'll link the page inside another level of the lock...
  call MmAllocSmallPage
  ;//
  test eax,eax
  jz   near .OutOfMemory
  mov  edx,[esp]
  ;//
  and  eax,0FFFFF000h
  cmp  dword [eax],byte 0
  jnz  near .not_empty
  ;//
  mov  [eax+mp_Typ],edx ;//mov  [eax].TMmPage.Typ,edx
  mov  dword [eax],cMmPageSign ;//mov  [eax].TMmPage.Signature,cMmPageSign
  mov  ecx,dword [edx+mt_ItemSize] ;//mov  ecx,dword ptr [edx].TMmType.ItemSize ;// copy (ItemSize,FreeCount,FreeList,MaxFreeCount) as 1 dword...
  mov  dword [eax+mp_ItemSize],ecx ;//mov  dword [eax].TMmPage.ItemSize,ecx
  ;//
  ;// format free-list:
  push ebx
  push eax
  lea  ecx,[eax+1000h]
  movzx edx,byte [edx+mt_ItemSize] ;//movzx edx,[edx].TMmType.ItemSize
  shl  edx,4
  sub  ecx,edx ;// last possible item...
  ;//
  cmp  edx,byte 32 ;// TMmPage header size
  jb   .more_reserve
  ;//
  lea  eax,[eax+edx] ;// first item...
  ;//
.fmtcy:
  lea  ebx,[eax+edx]
  cmp  ebx,ecx
  ja   .last_item
  shl  ebx,4
  and  ebx,cMmNextFreeMask_DW
  or   ebx,cMmFreeSign_DW
  mov  [eax+8],ebx
  add  eax,edx
  jmp  short .fmtcy
  ;//
.last_item:
  mov  dword [eax+8],cMmFreeSign_DW
  ;//
  pop  eax
  pop  ebx
  ;//
  ;// add to Typ.FreePages:
  mov  ecx,eax
  mov  edx,[esp]
.retry_linkFree:
  mov  eax,[edx+mt_FreePages] ;//mov  eax,[edx].TMmType.FreePages
  ;//
  test eax,eax
  jz   .first_page
  ;//
  mov [ecx+mp_NextFreePage],eax ;//mov  [ecx].TMmPage.NextFreePage,eax
  lock cmpxchg [edx+mt_FreePages],ecx ;//lock cmpxchg [edx].TMmType.FreePages,ecx
  jne  .thread_problem
  mov  eax,ecx
  pop  edx
  ret
  ;//
.more_reserve:
  push ecx
  lea  ecx,[eax+32] ;// TMmPage header size
.more_res2:
  add  eax,edx ;// with edx=0 it would block here...?
  cmp  eax,ecx
  jb   .more_res2
  pop  ecx
  jmp short .fmtcy
  ;//
.first_page:
  mov  [ecx+mp_NextFreePage],edx ;//mov  [ecx].TMmPage.NextFreePage,edx
  lock cmpxchg [edx+mt_FreePages],ecx ;//lock cmpxchg [edx].TMmType.FreePages,ecx
  jne  .thread_problem
  mov  eax,ecx
  pop  edx
  ret
  ;//
.thread_problem:
  db 0F3h
  nop
  jmp short .retry_linkFree
  ;//
.OutOfMemory:
  pop  edx
  mov  eax,1000h
  jmp  MmOutOfMemoryError
  ;//
.not_empty:
  pop  edx
.badPool:
  xor  eax,eax
  ret

align 4
;// function MmAllocSmallPage(Pool,Typ): Pointer
MmAllocSmallPage:
  ;// AllocRawPage uses locking anyway, so we'll link the page inside another level of the lock...
  push ebx
  push edi
  mov  ebx,eax
  ;//
  lea  eax,[ebx+mpool_MidLock]
  push eax
  call EnterCriticalSection
  ;//!!!todo try?!
  ;//
  mov  eax,[ebx+mpool_VirtPool+vp_Arg]
  mov  edx,1000h
  call dword [ebx+mpool_VirtPool+vp_AllocRawPage]
  ;//
  test eax,eax
  mov  edi,eax
  jz   .fail
  ;//
  lea  edx,[eax+mp_SmallPageLink]
  lea  eax,[ebx+mpool_SmallPageList]
  call MmInsertTailList
  ;//
.fail:
  ;//!!!todo finally?!
  lea  eax,[ebx+mpool_MidLock]
  push eax
  call LeaveCriticalSection
  ;//
  mov  eax,edi
  ;//
  pop  edi
  pop  ebx
  ret


;// function MmSmallPage_IsEmpty(Page,MaxFreeCount): Boolean
MmSmallPage_IsEmpty:
  ;// from MmCheckItemFree above...
  push ebx
  push esi
  push edx
  mov  ebx,eax
  test ebx,0FFFh
  jnz  .bad_ptr
  xor  esi,esi ;// actual count...
  mov  ecx,255 ;// max count...
  movzx edx,byte [ebx+mp_FreeList] ;//movzx edx,[ebx].TMmPage.FreeList
  test edx,edx
  jz   .break
.cy:
  dec  ecx
  jz   .infinite
  ;// Walk:=@Page[idx shl 4]
  add  edx,edx
  lea  edx,[ebx+edx*8]
  ;//
  movzx eax,byte [edx+mfi_NextFree] ;//movzx eax,[edx].TMmFreeItem.NextFree
  cmp word [edx+mfi_wSign],cMmFreeSign ;//cmp  [edx].TMmFreeItem.wSign,cMmFreeSign
  jne  .free_damaged
  ;//
  inc  esi
  mov  edx,eax
  test eax,eax
  jnz  .cy
  ;// end of free-list...
.break:
  mov  eax,esi
  cmp  al,[ebx+mp_FreeCount] ;//cmp  al,[ebx].TMmPage.FreeCount // FreeCount == Page.FreeCount ?
  sete dl
  cmp  esi,[esp] ;// FreeCount == MaxFreeCount ?
  sete al
  and  al,dl
  jmp short .done
  ;//
.bad_ptr:
.infinite:
.free_damaged:
  xor  eax,eax
  ;//
.done:
  pop  edx
  pop  esi
  pop  ebx
  ret

align 4
;// function MmType_CollectFree(Typ,Pool)
MmType_CollectFree:
  ;// cannot use locking, other threads in MmAlloc/MmFree don't use locking either...
  ;// it is behind MidLock to avoid concurency of multiple Collectors...
  push ebp
  mov  ebp,esp
  ;//
  push edx ;// [ebp-4]=^Pool
  push ebx ;// [ebp-8]
  push edi ;// [ebp-12]
  push esi ;// [ebp-16]
  push byte 0   ;// [ebp-20] = Count
  ;//
  mov  esi,eax ;// PMmType
.restart:
  lea ebx,[esi+mt_FreePages] ;//lea  ebx,[esi].TMmType.FreePages
  ;// skip TopPage
.cy0:
  mov  eax,[ebx]
  test eax,eax
  jle near .done
  ;//
  cmp  eax,esi
  je   near .typ_empty
  ;//
  cmp [eax+mp_Typ],esi ;//cmp  [eax].TMmPage.Typ,esi ;//cmp  [eax].TMmPage.Signature,cMmPageSign
  jne   .first_bad
  lea ebx,[eax+mp_NextFreePage] ;//lea  ebx,[eax].TMmPage.NextFreePage
  ;//
  ;//New200831 - skip second also...
  mov  eax,[ebx]
  test eax,eax
  jle  near .done
  cmp  eax,esi
  je   near .typ_empty
  cmp [eax+mp_Typ],esi ;//cmp  [eax].TMmPage.Typ,esi
  jne  .second_bad
  lea ebx,[eax+mp_NextFreePage] ;//lea  ebx,[eax].TMmPage.NextFreePage
  ;//
.cy1:
  mov  eax,[ebx]
  test eax,eax
  jle  near .done
  ;//
  cmp  eax,esi ;// last page in free-list has NextFreePage=Typ
  je   .done
  ;//
  cmp [ebx-mp_NextFreePage+mp_Typ],esi ;//cmp  [ebx-(offset TMmPage.NextFreePage)+(offset TMmPage.Typ)],esi
  jne  .done
  ;//
  cmp [eax+mp_Typ],esi ;//cmp  [eax].TMmPage.Typ,esi ;//cmp  [eax].TMmPage.Signature,cMmPageSign
  jne  .diff_page
  mov  cl,[eax+mp_FreeCount] ;//mov  cl,[eax].TMmPage.FreeCount
  cmp  cl,[eax+mp_MaxFreeCount] ;//cmp  cl,[eax].TMmPage.MaxFreeCount
  je   .empty_page
  ;//
  cmp  eax,[ebx]
  jne  .chain_modified
  ;//
  lea ebx,[eax+mp_NextFreePage] ;//lea  ebx,[eax].TMmPage.NextFreePage
  ;//
  add  dword [ebp-20],byte 1
  cmp  byte [ebp-19],10h ;// 16Mb...
  jb   .cy1
  ;// infinite chain suspected, or walked enough... -- yes, it may get circular ?!
  nop
  jmp short .done
  ;//
.second_bad:
.first_bad:
  ;// is it still there?
  cmp  [ebx],eax
  jne  .restart
  ;// first page is bad...
  nop
  jmp short .done
  ;//
.empty_page:
  ;// this page seems empty...
  ;// unlink it - first take NextFreePage, then check if it was valid:
  mov  edx,[eax+mp_NextFreePage] ;//mov  edx,[eax].TMmPage.NextFreePage
  cmp  [eax+mp_Typ],esi ;//cmp  [eax].TMmPage.Typ,esi ;//cmp  [eax].TMmPage.Signature,cMmPageSign
  jne  .chain_modified
  ;//
  mov  ecx,eax ;// for case cmpxchg fails, eax is modified...
  lock cmpxchg [ebx],edx
  jne  .unlink_failed
  ;// now the page was "acquired"... check it...
  ;// first also remove original NextFreePage
  mov  eax,edx
  xor  edx,edx
  lock cmpxchg [ecx+mp_NextFreePage],edx ;//lock cmpxchg [ecx].TMmPage.NextFreePage,edx
  jne  .unlink_failed
  ;// check it more thoroughly, if it is really free...
  ;//
  mov  eax,ecx
  mov  edx,esi
  call MmFreeSmallPageUnlinked
  ;//
  and dword [ebp-20],byte 0 ;// reset Count...
  ;//
  ;// now see, if the chain is still valid...
  mov  edx,ebx
  and  edx,0FFFFF000h
  cmp [edx+mp_Typ],esi ;//cmp  [edx].TMmPage.Typ,esi ;//cmp  [edx].TMmPage.Signature,cMmPageSign
  je   .cy1
  ;// previous page is gone...
  nop
  jmp short .done
  ;//
.unlink_failed:
  mov  eax,ecx
.diff_page:
.chain_modified:
  ;// is it still there in FreePages or NextFreePage?
  cmp  eax,[ebx]
  je   .chain_bad
  ;// this page in EAX was unlinked by someone else...
  ;//x:cmp  [ebp-20],0
  ;//x:je   .restart
  ;// either this or previous page was unlinked:
  mov  edx,ebx
  and  edx,0FFFFF000h
  cmp [edx+mp_Typ],esi ;//cmp  [edx].TMmPage.Typ,esi ;//cmp  [edx].TMmPage.Signature,cMmPageSign
  je   .cy1 ;// previous is ok...
  ;// else previous page is gone...
.chain_bad:
  nop
  ;//x:jmp  .done
  ;//
.typ_empty:
.done:
  lea  esp,[ebp-16]
  pop  esi
  pop  edi
  pop  ebx
  ;// clear Pool from stack...
  pop  edx
  push eax
  pop  eax
  pop  ebp
  ret

align 4
;// function MmCheckFreePages(Typ): Boolean
MmCheckFreePages:
  push ebx
  push edi
  mov  ebx,eax
  ;//
.restart:
  xor  ecx,ecx
  lea  edx,[eax+mt_FreePages] ;//lea  edx,[eax].TMmType.FreePages
  cmp  [edx],ecx
  je   .empty 
.cy:
  mov  eax,[edx]
  ;//
  cmp  eax,ebx
  je   .done_ok
  test eax,eax
  je   .done_bad
  ;//
  cmp  dword [eax+mp_FreeLink],byte 0 ;//cmp  [eax].TMmPage.FreeLink.FLink,0
  jnz  .unlink_free
  ;//
.continue:
  cmp  [edx],eax
  jne  .restart
  lea  edx,[eax+mp_NextFreePage] ;//lea  edx,[eax].TMmPage.NextFreePage
  inc  ecx
  cmp  ecx,32768 ;//16384
  jb   .cy
  ;// chain is circular ?!
  ;// (we could cut it here, but if there is really so much pages, we would loose the rest...)
  mov [eax+mp_NextFreePage],ebx ;//mov  [eax].TMmPage.NextFreePage,ebx
.done_bad:
  xor  eax,eax
  jmp  short .done
  ;//
.unlink_free:
  ;// RemoveEntryListAndClear(@eax.FreeLink)
  and  eax,0FFFFF000h
  lea  eax,[eax+mp_FreeLink] ;//lea  eax,[eax].TMmPage.FreeLink
  mov  edi,[eax] ;//mov  edi,[eax].TListEntry.FLink
  mov  ecx,[eax+4] ;//mov  ecx,[eax].TListEntry.BLink
  cmp  [edi+4],eax ;//cmp  [edi].TListEntry.BLink,eax
  jne  .bad_link
  cmp  [ecx],eax ;//cmp  [ecx].TListEntry.FLink,eax
  jne  .bad_link
  mov  [edi+4],ecx ;//mov  [edi].TListEntry.BLink,ecx
  mov  [ecx],edi ;//mov  [ecx].TListEntry.FLink,edi
.bad_link:
  xor  ecx,ecx
  mov  [eax],ecx ;//mov  [eax].TListEntry.FLink,ecx
  mov  [eax+4],ecx ;//mov  [eax].TListEntry.BLink,ecx
  and  eax,0FFFFF000h
  jmp short .continue
  ;//
.empty:
.done_ok:
  mov  al,1
.done:
  pop  edi
  pop  ebx
  ret

align 4
;// function MmInsertHeadList(Base,Entry: PListEntry): Pointer
;//                           EAX  EDX               ->EAX   (returns Entry or NIL)
MmInsertHeadList:
  mov ecx,[eax]     ;//mov  ecx,[eax].TListEntry.FLink
  cmp [ecx+4],eax   ;//cmp  [ecx].TListEntry.BLink,eax
  jne  .bad_link
  mov [edx+4],eax   ;//mov  [edx].TListEntry.BLink,eax
  mov [edx],ecx     ;//mov  [edx].TListEntry.FLink,ecx
  mov [eax],edx     ;//mov  [eax].TListEntry.FLink,edx
  mov [ecx+4],edx   ;//mov  [ecx].TListEntry.BLink,edx
  mov  eax,edx
  ret
.bad_link:
  xor  eax,eax
  ret

align 4
;// function MmInsertTailList(Base,Entry: PListEntry): Pointer
;//                           EAX  EDX               ->EAX   (returns Entry or NIL)
MmInsertTailList:
  mov  ecx,[eax+4]  ;//mov  ecx,[eax].TListEntry.BLink
  cmp  [ecx],eax    ;//cmp  [ecx].TListEntry.FLink,eax
  jne  .bad_link
  mov  [edx],eax    ;//mov  [edx].TListEntry.FLink,eax
  mov  [edx+4],ecx  ;//mov  [edx].TListEntry.BLink,ecx
  mov  [eax+4],edx  ;//mov  [eax].TListEntry.BLink,edx
  mov  [ecx],edx    ;//mov  [ecx].TListEntry.FLink,edx
  mov  eax,edx
  ret
.bad_link:
  xor  eax,eax
  ret

;// function LinkPoolFreeSched_v2(Base: PListEntry,Page: PMmPage): Boolean
LinkPoolFreeSched_v2:
       cmp    dword [eax+4],byte 0             ; 0040775C      83 78 04 00
       jz     .loc_0040776D                    ; 00407760      74 0B
       add    edx,byte mp_FreeLink             ; 00407762      83 C2 10
       call   MmInsertTailList                 ; 00407765      E8 46 09 00 00
       mov    al,1                             ; 0040776A      B0 01
       ret                                     ; 0040776C      C3
.loc_0040776D:         ; j< 00407760           ; 0040776D
       xor    eax,eax                          ; 0040776D      33 C0
       ret                                     ; 0040776F      C3


align 4
;// function MmFreeSmallPageUnlinked(Page,Typ)
MmFreeSmallPageUnlinked:
  ;// now Page.NextFreePage=nil, Page.Typ=Typ, Page.Signature=cMmPageSign
  ;// Page.FreeCount>=Page.NextFreeCount - so verify it is empty...
  ;// there should be no contention on freeing from this page,
  ;// but other thread may have started to allocate there...
  ;// Called inside MidLock...
       push   ebx                              ; 00407770      53
       push   esi                              ; 00407771      56
       mov    esi,edx                          ; 00407772      8B F2
       mov    ebx,eax                          ; 00407774      8B D8
       mov    edx,[esi+mt_Pool]                ; ...
       dec    dword [edx+mpool_iColNeed]       ; ...
       mov    cl,byte [ebx+mp_FreeCount]       ; ...
       cmp    cl,byte [ebx+mp_MaxFreeCount]    ; ...
       jb     .loc_004077C1                    ; 00407785      72 3A
       xor    edx,edx                          ; 00407787      33 D2
       mov    dl,byte [esi+mt_MaxFreeCount]    ; 00407789      8A 56 13
       ;//mov    eax,ebx                          ; 0040778C      8B C3
       call   MmSmallPage_IsEmpty              ; 0040778E      E8 79 FF FF FF
       test   al,al                            ; 00407793      84 C0
       jz     .loc_004077C1                    ; 00407795      74 2A
       cmp    dword [ebx+mp_FreeLink_Next],byte 0   ; 00407797      83 7B 10 00
       jnz    .loc_004077C1                    ; 0040779B      75 24
       cmp    ebx,dword [esi+mt_FreePages]     ; 0040779D      3B 5E 04
       jz     .loc_004077C1                    ; 004077A0      74 1F
       ;// schedule freeing this page...
       mov    eax,dword [esi+mt_Pool]          ; 004077A2      8B 46 0C
       add    eax,mpool_FreePageList           ; 004077A5      05 B0 00 00 00
       mov    edx,ebx                          ; 004077AA      8B D3
       call   LinkPoolFreeSched_v2             ; 004077AC      E8 AB FF FF FF
       test   al,al                            ; 004077B1      84 C0
       jz     .loc_004077E7                    ; 004077B3      74 32
       mov    eax,dword [esi+mt_Pool]          ; 004077B5      8B 46 0C
       inc    dword [eax+mpool_FreeSchedCnt]   ; 004077B8      FF 80 AC 00 00 00
       ;//pop    esi                              ; 004077BE      5E
       ;//pop    ebx                              ; 004077BF      5B
       ;//ret                                     ; 004077C0      C3
       jmp short .psb_ret
.loc_004077C1:          ; j< 00407785          ; 004077C1
                        ; j< 00407795          ; 004077C1
                        ; j< 0040779B          ; 004077C1
       cmp    dword [ebx],cMmPageSign          ; 004077C1      81 3B B5 50 67 A9
       jnz    .loc_004077E7                    ; 004077C7      75 1E
       cmp    esi,dword [ebx+mp_Typ]           ; 004077C9      3B 73 08
       jnz    .loc_004077E7                    ; 004077CC      75 19
       cmp    dword [ebx+mp_NextFreePage],byte 0 ; 004077CE      83 7B 04 00
       jnz    .loc_004077E7                    ; 004077D2      75 13
       mov    edx,ebx                          ; 004077D4      8B D3
       mov    eax,[esi+mt_Pool]                ; 004077D6      8B 46 0C
       call   MmLinkFreePage                   ; 004077D9      E8 F2 FA FF FF
       mov    eax,[esi+mt_Pool]                ; 004077DE      8B 46 0C
       inc    dword [eax+mpool_iColNeed]       ; 004077E1      FF 80 A0 00 00 00
.loc_004077E7:         ; j< 004077B3           ; 004077E7
                       ; j< 004077C7           ; 004077E7
                       ; j< 004077CC           ; 004077E7
.psb_ret:
       pop    esi                              ; 004077E7      5E
       pop    ebx                              ; 004077E8      5B
       ret                                     ; 004077E9      C3

align 4
;// function MmCollectFree(Pool)
MmCollectFree:
       push   ebp                              ; 00407BFC      55
       mov    ebp,esp                          ; 00407BFD      8B EC
       add    esp,byte -8                      ; 00407BFF      83 C4 F8
       push   ebx                              ; 00407C02      53
       push   esi                              ; 00407C03      56
       push   edi                              ; 00407C04      57
       mov    dword [ebp-4],eax   ;// Pool     ; 00407C05      89 45 FC
       ;// try
       xor    edx,edx                          ; 00407C08      33 D2
       push   ebp                              ; 00407C0A      55
       ;//push   offset .loc_00407D33_EHandler              ; 00407C0B      68 33 7D 40 00
       call .here12
       .here12:
       add dword [esp],(.loc_00407D33_EHandler - .here12)
       ;//
       db 64h,0FFh,32h ;//push   fs:[edx]                         ; 00407C10      64 FF 32
       db 64h,89h,22h ;//mov    dword fs:[edx],esp           ; 00407C13      64 89 22
       ;//
       mov    eax,dword [ebp-4]            ; 00407C16      8B 45 FC
       cmp    dword [eax],cMmPoolSign ;//0A970AAB5h       ; 00407C19      81 38 B5 AA 70 A9
       jnz   near .loc_00407D29_out1                     ; 00407C1F      0F 85 04 01 00 00
       ;//
       ;//mov    eax,dword [ebp-4]            ; 00407C25      8B 45 FC
       add    eax,byte mpool_MidLock                          ; 00407C28      83 C0 5C
       push   eax                              ; 00407C2B      50
       call   EnterCriticalSection             ; 00407C2C      E8 6B E0 FF FF
       ;// try
       xor    edx,edx                          ; 00407C31      33 D2
       push   ebp                              ; 00407C33      55
       ;//push   offset .loc_00407D22_goFinally              ; 00407C34      68 22 7D 40 00
       call .here13
       .here13:
       add dword [esp],(.loc_00407D22_goFinally - .here13)
       ;//
       db 64h,0FFh,32h ;//push   fs:[edx]                         ; 00407C39      64 FF 32
       db 64h,89h,22h ;//mov    dword fs:[edx],esp           ; 00407C3C      64 89 22
       ;//
       mov    eax,dword [ebp-4]            ; 00407C3F      8B 45 FC
       mov    esi,dword [eax+mpool_FreeSchedCnt]         ; 00407C42      8B B0 AC 00 00 00
       ;//mov    eax,dword [ebp-4]            ; 00407C48      8B 45 FC
       and    dword [eax+mpool_iColNeed],byte 0           ; 00407C4B      83 A0 A0 00 00 00 00
       mov    ebx,1                            ; 00407C52      BB 01 00 00 00
       ;//
.loc_00407C57_for:          ; j> 00407C70           ; 00407C57
       mov    eax,dword [ebp-4]            ; 00407C57      8B 45 FC
       mov edx,eax
       mov    eax,dword [eax+4*ebx+mpool_SmallTypes]    ; 00407C5A      8B 44 98 18
       cmp    dword [eax+mt_FreePages],byte 0              ; 00407C5E      83 78 04 00
       jz     .loc_00407C6C                     ; 00407C62      74 08
       ;//mov    edx,dword [ebp-4]            ; 00407C64      8B 55 FC
       call   MmType_CollectFree               ; 00407C67      E8 80 FB FF FF
       ;//
.loc_00407C6C:          ; j< 00407C62           ; 00407C6C
       inc    ebx                              ; 00407C6C      43
       cmp    ebx,byte 17                          ; 00407C6D      83 FB 11
       jnz    .loc_00407C57_for                     ; 00407C70      75 E5
       ;//
       mov    eax,dword [ebp-4]            ; 00407C72      8B 45 FC
       cmp    dword [eax+mpool_iColNeed],byte 0           ; 00407C75      83 B8 A0 00 00 00 00
       jnl    .loc_00407C88                     ; 00407C7C      7D 0A
       ;//mov    eax,dword [ebp-4]            ; 00407C7E      8B 45 FC
       and    dword [eax+mpool_iColNeed],byte 0           ; 00407C81      83 A0 A0 00 00 00 00
.loc_00407C88:          ; j< 00407C7C           ; 00407C88
       ;//
       ;//mov    eax,dword [ebp-4]            ; 00407C88      8B 45 FC
       cmp    esi,dword [eax+mpool_FreeSchedCnt]         ; 00407C8B      3B B0 AC 00 00 00
       jnl    .loc_00407D08_leave2                     ; 00407C91      7D 75
       ;//
       ;// actually free the pages after some small time in other thread...
       ;// if they are still free...
       ;//mov    eax,dword [ebp-4]            ; 00407C93      8B 45 FC
       mov    ebx,dword [eax+mpool_hColThread]         ; 00407C96      8B 98 C0 00 00 00
       test   ebx,ebx                          ; 00407C9C      85 DB
       jz     .loc_00407CD1                     ; 00407C9E      74 31
       lea    eax,[ebp-8]                      ; 00407CA0      8D 45 F8
       push   eax                              ; 00407CA3      50
       push   ebx                              ; 00407CA4      53
       call   GetExitCodeThread                ; 00407CA5      E8 7A E0 FF FF
       test   eax,eax                          ; 00407CAA      85 C0
       jz     .loc_00407CD1                     ; 00407CAC      74 23
       ;//
       cmp    dword [ebp-8],STILL_ACTIVE ;//103h           ; 00407CAE      81 7D F8 03 01 00 00
       jz     .loc_00407CCC                     ; 00407CB5      74 15
       ;//
       mov    eax,dword [ebp-4]            ; 00407CB7      8B 45 FC
       xor    edx,edx                          ; 00407CBA      33 D2
       mov    dword [eax+mpool_hColThread],edx         ; 00407CBC      89 90 C0 00 00 00
       push   ebx                              ; 00407CC2      53
       call   CloseHandle                      ; 00407CC3      E8 7C DF FF FF
       xor    ebx,ebx                          ; 00407CC8      33 DB
       jmp   short .loc_00407CDC                     ; 00407CCA      EB 10
;-----------------------------------------------------------   ; 00407CCA
.loc_00407CCC:          ; j< 00407CB5           ; 00407CCC
       mov    ebx,dword [ebp-4]            ; 00407CCC      8B 5D FC
       jmp   short .loc_00407CDC                     ; 00407CCF      EB 0B
;-----------------------------------------------------------   ; 00407CCF
.loc_00407CD1:          ; j< 00407C9E           ; 00407CD1
                       ; j< 00407CAC                           ; 00407CD1
       xor    ebx,ebx                          ; 00407CD1      33 DB
       mov    eax,dword [ebp-4]            ; 00407CD3      8B 45 FC
       mov    dword [eax+mpool_hColThread],ebx         ; 00407CD6      89 98 C0 00 00 00
.loc_00407CDC:          ; j< 00407CCA           ; 00407CDC
                       ; j< 00407CCF                           ; 00407CDC
       test   ebx,ebx                          ; 00407CDC      85 DB
       jnz    .loc_00407D08_leave2                     ; 00407CDE      75 28
       ;//
       mov    eax,dword [ebp-4]            ; 00407CE0      8B 45 FC
       add    eax,mpool_idColThread ;//0C4h                         ; 00407CE3      05 C4 00 00 00
       push   eax                              ; 00407CE8      50
       push   byte 0                                ; 00407CE9      6A 00
       mov    eax,dword [ebp-4]            ; 00407CEB      8B 45 FC
       push   eax                              ; 00407CEE      50
       ;//push   offset MmCollectThread           ; 00407CEF      68 C0 7B 40 00
       call .here14
       .here14:
       add dword [esp],(MmCollectThread - .here14)
       ;//
       push   byte 0                                ; 00407CF4      6A 00
       push   byte 0                                ; 00407CF6      6A 00
       call   CreateThread                     ; 00407CF8      E8 8F DF FF FF
       ;//mov    ebx,eax                          ; 00407CFD      8B D8
       ;//
       ;//mov    eax,dword [ebp-4]            ; 00407CFF      8B 45 FC
       ;//mov    dword [eax+mpool_hColThread],ebx         ; 00407D02      89 98 C0 00 00 00
       mov edx,[ebp-4]
       mov [edx+mpool_hColThread],eax
       ;//
.loc_00407D08_leave2:          ; j< 00407C91           ; 00407D08
                       ; j< 00407CDE                           ; 00407D08
       xor    eax,eax                          ; 00407D08      33 C0
       pop    edx                              ; 00407D0A      5A
       pop    ecx                              ; 00407D0B      59
       pop    ecx                              ; 00407D0C      59
       db 64h,89h,10h ;//mov    dword fs:[eax],edx           ; 00407D0D      64 89 10
       ;//push   offset .loc_00407D29_out1              ; 00407D10      68 29 7D 40 00
       call .here15
       .here15:
       add dword [esp],byte (.loc_00407D29_out1 - .here15)
       ;//
.loc_00407D15_fin:          ; j> 00407D27           ; 00407D15
       mov    eax,dword [ebp-4]            ; 00407D15      8B 45 FC
       add    eax,byte mpool_MidLock ;//5Ch                          ; 00407D18      83 C0 5C
       push   eax                              ; 00407D1B      50
       call   LeaveCriticalSection             ; 00407D1C      E8 AB E0 FF FF
       ret                                     ; 00407D21      C3
;-----------------------------------------------------------   ; 00407D21
.loc_00407D22_goFinally:          ; p< 00407C34           ; 00407D22
       jmp    HandleFinally                   ; 00407D22      E9 BD B3 FF FF
       jmp  short .loc_00407D15_fin                     ; 00407D27      EB EC
;-----------------------------------------------------------   ; 00407D27
.loc_00407D29_out1:          ; j< 00407C1F           ; 00407D29
                       ; p< 00407D10                           ; 00407D29
       xor    eax,eax                          ; 00407D29      33 C0
       pop    edx                              ; 00407D2B      5A
       pop    ecx                              ; 00407D2C      59
       pop    ecx                              ; 00407D2D      59
       db 64h,89h,10h ;//mov    dword fs:[eax],edx           ; 00407D2E      64 89 10
       jmp  short .loc_00407D41_out0                     ; 00407D31      EB 0E
;-----------------------------------------------------------   ; 00407D31
.loc_00407D33_EHandler:          ; p< 00407C0B           ; 00407D33
       jmp    HandleAnyException              ; 00407D33      E9 4C B1 FF FF
;-----------------------------------------------------------   ; 00407D33
       ;//cmp    dword [ebp-4],byte 0              ; 00407D38      83 7D FC 00
       call   DoneExcept                      ; 00407D3C      E8 B7 B4 FF FF
       ;//
.loc_00407D41_out0:          ; j< 00407D31           ; 00407D41
       pop    edi                              ; 00407D41      5F
       pop    esi                              ; 00407D42      5E
       pop    ebx                              ; 00407D43      5B
       pop    ecx                              ; 00407D44      59
       pop    ecx                              ; 00407D45      59
       pop    ebp                              ; 00407D46      5D
       ret                                     ; 00407D47      C3


;// function MmBgCollectWork_v2(Pool)
MmBgCollectWork_v2:
       push   ebx                              ; 00407928      53
       push   esi                              ; 00407929      56
       push   edi                              ; 0040792A      57
       push   ebp                              ; 0040792B      55
               ;//x240223:
               ;//add    esp,byte -8                      ; 0040792C      83 C4 F8
               ;//mov    [esp],eax           ;// Pool     ; 0040792F      89 04 24
               ;//zmena240223
       xor  edx,edx
       push edx    ;// [esp+4,5] bnDamaged, bnRetried
       push eax    ;// [esp] = Pool 
       ;//
        ;// first walk all Typ.FreePages links (but may be circular)
        ;// and all pages in Typ.FreePages chain unschedule from this releasing
        ;// or unlink from FreePages chain...?
.loc_00407932_retry:
       mov    byte [esp+4],0   ;// bnDamaged   ; 00407932      C6 44 24 04 00
       ;//mov    esi,1                            ; 00407937      BE 01 00 00 00
       push byte 1
       pop  esi
.loc_0040793C_cycle:
       mov    eax,[esp]                        ; 0040793C      8B 04 24
       mov    eax,[eax+4*esi+mpool_SmallTypes] ; 0040793F      8B 44 B0 18
       call   MmCheckFreePages                 ; 00407943      E8 7C FF FF FF
       test   al,al                            ; 00407948      84 C0
       jnz    .loc_00407951                    ; 0040794A      75 05
       mov    byte [esp+4],1  ;// bnDamaged    ; 0040794C      C6 44 24 04 01
.loc_00407951:
       inc    esi                              ; 00407951      46
       cmp    esi,byte 16                      ; 00407952      83 FE 10
       jle    .loc_0040793C_cycle              ; 00407955      7E E5
       ;//
       ;// free pages in FreePageList, if they are really still empty...
       mov    eax,[esp]                        ; 00407957      8B 04 24
       lea    edi,[eax+mpool_FreePageList]     ; 0040795A      8D B8 B0 00 00 00
       jmp   near .loc_00407A05_whileNext      ; 00407960      E9 A0 00 00 00
       ;//
.loc_00407965_cycle:          ;// j> 00407A12          ; 00407965
       mov    esi,eax                          ; 00407965      8B F0
       call   MmRemoveEntryListAndClear        ; 00407969      E8 5A 07 00 00
       test   eax,eax                          ; 0040796E      85 C0
       jnz    .loc_00407984                    ; 00407970      75 12
       ;// Chain is damaged?!
       cmp    esi,[edi]                        ; 00407972      3B 37
       jnz    near .loc_00407A05_whileNext     ; 00407974      0F 85 8B 00 00 00
       mov    byte [esp+4],1  ;// bnDamaged    ; 0040797A      C6 44 24 04 01
       jmp  near  .loc_00407A18_break          ; 0040797F      E9 94 00 00 00
;-----------------------------------------------------------   ; 0040797F
.loc_00407984:          ; j< 00407970          ; 00407984
       mov    ebp,esi                          ; 00407984      8B EE
       and    ebp,0FFFFF000h   ;// Page        ; 00407986      81 E5 00 F0 FF FF
       lea    eax,[ebp+mp_FreeLink]            ; 0040798C      8D 45 10
       cmp    esi,eax                          ; 0040798F      3B F0
       jne    .loc_00407A05_whileNext          ; 00407991      75 72
       mov    ebx,[esi]                        ; 00407993      8B 1E
       cmp    esi,ebx                          ; 00407995      3B F3
       je     .loc_0040799D                    ; 00407997      74 04
       test   ebx,ebx                          ; 00407999      85 DB
       jnz    .loc_00407A05_whileNext          ; 0040799B      75 68
.loc_0040799D:          ; j< 00407997          ; 0040799D
       ;//
       cmp    dword [ebp+mp_NextFreePage],byte 0                  ; 0040799D      83 7D 04 00
       jnz    .loc_00407A05_whileNext          ; 004079A1      75 62
       ;//
       mov    al,[ebp+mp_FreeCount]            ; 004079A3      8A 45 0D
       cmp    al,[ebp+mp_MaxFreeCount]         ; 004079A6      3A 45 0F
       jb     .loc_00407A05_whileNext          ; 004079A9      72 5A
       ;//
       cmp    dword [ebp+mp_Typ],byte 0        ; 004079AB      83 7D 08 00
       jz     .loc_00407A05_whileNext          ; 004079AF      74 54
       ;// all Typ are in Pool-page...
       mov    eax,[ebp+mp_Typ]                 ; 004079B1      8B 45 08
       xor    eax,[esp]                        ; 004079B4      33 04 24
       test   eax,0FFFFF000h                   ; 004079B7      A9 00 F0 FF FF
       jnz    .loc_00407A05_whileNext          ; 004079BC      75 47
       ;//
       mov    eax,[ebp+mp_Typ]                 ; 004079BE      8B 45 08
       cmp    ebp,[eax+mt_FreePages]           ; 004079C1      3B 68 04
       je     .loc_00407A05_whileNext          ; 004079C4      74 3F
       ;//
       ;//mov    eax,[ebp+mp_Typ]              ; 004079C6      8B 45 08
       mov    al,[eax+mt_MaxFreeCount]         ; 004079C9      8A 40 13
       cmp    al,[ebp+mp_MaxFreeCount]         ; 004079CC      3A 45 0F
       jne    .loc_00407A05_whileNext          ; 004079CF      75 34
       ;//
       xor    edx,edx                          ; 004079D1      33 D2
       ;//mov    dl,byte [ebp+mp_MaxFreeCount]                ; 004079D3      8A 55 0F
       mov  dl,al
       mov    eax,ebp                          ; 004079D6      8B C5
       call   MmSmallPage_IsEmpty              ; 004079D8      E8 2F FD FF FF
       test   al,al                            ; 004079DD      84 C0
       jz     .loc_00407A05_whileNext          ; 004079DF      74 24
       ;// Free this page now...
       mov    eax,dword [esp]                  ; 004079E1      8B 04 24
       dec    dword [eax+mpool_FreeSchedCnt]   ; 004079E4      FF 88 AC 00 00 00
       ;//
       lea    eax,[ebp+mp_SmallPageLink]       ; 004079EA      8D 45 18
       call   MmRemoveEntryListAndClear        ; 004079ED      E8 D6 06 00 00
       ;//
       mov    eax,[esp]                        ; 004079F2      8B 04 24
       mov  ebx,eax
       mov    eax,[eax+mpool_VirtPool+vp_Arg]  ; 004079F5      8B 40 0C
       ;//mov    ebx,[esp]                        ; 004079F8      8B 1C 24
       ;//mov    ecx,1000h                        ; 004079FB      B9 00 10 00 00
       mov    edx,ebp                          ; 00407A00      8B D5
       call   dword [ebx+mpool_VirtPool+vp_ReleaseRawPage]                    ; 00407A02      FF 53 08
       ;//
.loc_00407A05_whileNext:
       mov    eax,[edi]                        ; 00407A05      8B 07
       test   eax,eax                          ; 00407A07      85 C0
       jz     .loc_00407A18_break              ; 00407A09      74 0D
       cmp    edi,eax                          ; 00407A0B      3B F8
       jz     .loc_00407A18_break              ; 00407A0D      74 09
       cmp    edi,dword [eax+4]                ; 00407A0F      3B 78 04
       jz     .loc_00407965_cycle              ; 00407A12      0F 84 4D FF FF FF
       ;//
.loc_00407A18_break:
       mov    eax,[esp]                        ; 00407A18      8B 04 24
       add    eax,mpool_FreePageList ;//0B0h                         ; 00407A1B      05 B0 00 00 00
       ;//call   MmInitializeListHead             ; 00407A20      E8 57 06 00 00
       mov [eax],eax
       mov [eax+4],eax
       ;//
       mov    eax,[esp]                        ; 00407A25      8B 04 24
       xor    edx,edx                          ; 00407A28      33 D2
       mov    [eax+mpool_FreeSchedCnt],edx     ; 00407A2A      89 90 AC 00 00 00
       ;//
       ;// any bnDamaged found?
       cmp    byte [esp+4],0                   ; 00407A30      80 7C 24 04 00
       jz    near .loc_00407B09_out            ; 00407A35      0F 84 CE 00 00 00
       ;//
       ;// Try to re-collect other free pages, if somewhere link is broken:
       ;// this would swap-in whole process... (could have the link elsewhere in a "descriptor" ?)
       xor    ebx,ebx                          ; 00407A3B      33 DB
       mov    eax,[esp]                        ; 00407A3D      8B 04 24
       lea    edi,[eax+mpool_SmallPageList]    ; 00407A40      8D B8 B8 00 00 00
       mov    esi,[edi]                        ; 00407A46      8B 37
       cmp    edi,esi                          ; 00407A48      3B FE
       jz     near .loc_00407B01_break         ; 00407A4A      0F 84 B1 00 00 00
       test   esi,esi                          ; 00407A50      85 F6
       jz     near .loc_00407B01_break         ; 00407A52      0F 84 A9 00 00 00
       cmp    edi,dword [esi+4]                ; 00407A58      3B 7E 04
       jnz    near .loc_00407B01_break         ; 00407A5B      0F 85 A0 00 00 00
       jmp  near  .loc_00407AF5_whNext         ; 00407A61      E9 8F 00 00 00
;-----------------------------------------------------------   ; 00407A61
.loc_00407A66_whCycle:          ; j> 00407AFB          ; 00407A66
       xor    eax,eax                          ; 00407A66      33 C0
       add    eax,byte mp_SmallPageLink        ; 00407A68      83 C0 18
       mov    ebp,esi                          ; 00407A6B      8B EE
       sub    ebp,eax                          ; 00407A6D      2B E8
       test   ebp,0FFFh                        ; 00407A6F      F7 C5 FF 0F 00 00
       jnz    near .loc_00407B01_break         ; 00407A75      0F 85 86 00 00 00
       ;//
       push   byte 4                           ; 00407A7B      6A 04
       push   ebp                              ; 00407A7D      55
       call   IsBadWritePtr                    ; 00407A7E      E8 41 E3 FF FF
       test   eax,eax                          ; 00407A83      85 C0
       jnz    .loc_00407B01_break              ; 00407A85      75 7A
       ;//
       cmp    dword [ebp+0],cMmPageSign ;//0A96750B5h         ; 00407A87      81 7D 00 B5 50 67 A9
       jnz    .loc_00407B01_break              ; 00407A8E      75 71
       ;//
       mov    al,[ebp+mp_FreeCount]            ; 00407A90      8A 45 0D
       cmp    al,[ebp+mp_MaxFreeCount]         ; 00407A93      3A 45 0F
       jb     .loc_00407AE7                    ; 00407A96      72 4F
       ;//
       cmp    dword [ebp+mp_NextFreePage],byte 0                  ; 00407A98      83 7D 04 00
       jnz    .loc_00407AE7                    ; 00407A9C      75 49
       ;//
       cmp    dword [ebp+mp_FreeLink],byte 0   ; 00407A9E      83 7D 10 00
       jnz    .loc_00407AE7                    ; 00407AA2      75 43
       ;//
       mov    eax,[ebp+mp_Typ]                 ; 00407AA4      8B 45 08
       xor    eax,[esp]                        ; 00407AA7      33 04 24
       test   eax,0FFFFF000h                   ; 00407AAA      A9 00 F0 FF FF
       jnz    .loc_00407AE7                    ; 00407AAF      75 36
       ;//
       mov    eax,[ebp+mp_Typ]                 ; 00407AB1      8B 45 08
       cmp    ebp,[eax+mt_FreePages]           ; 00407AB4      3B 68 04
       je     .loc_00407AE7                    ; 00407AB7      74 2E
       ;//
       ;//mov    eax,dword [ebp+mp_Typ]                ; 00407AB9      8B 45 08
       xor    edx,edx                          ; 00407ABC      33 D2
       mov    dl,byte [eax+mt_MaxFreeCount]    ; 00407ABE      8A 50 13
       mov    eax,ebp                          ; 00407AC1      8B C5
       call   MmSmallPage_IsEmpty              ; 00407AC3      E8 44 FC FF FF
       test   al,al                            ; 00407AC8      84 C0
       jz     .loc_00407AE7                    ; 00407ACA      74 1B
       ;//
       mov    eax,dword [esp]                  ; 00407ACC      8B 04 24
       inc    dword [eax+mpool_FreeSchedCnt]   ; 00407ACF      FF 80 AC 00 00 00
       ;//
       lea    edx,[ebp+mp_FreeLink]            ; 00407AD5      8D 55 10
       mov    eax,[esp]                        ; 00407AD8      8B 04 24
       add    eax,mpool_FreePageList                         ; 00407ADB      05 B0 00 00 00
       call   MmInsertTailList                 ; 00407AE0      E8 CB 05 00 00
       ;//New240223
       test  eax,eax
       jz    .loc_00407AE7
       ;//
       mov    bl,1   ;// bnRetry               ; 00407AE5      B3 01
.loc_00407AE7:
       lea    eax,[ebp+mp_SmallPageLink]       ; 00407AE7      8D 45 18
       mov    esi,[eax]                        ; 00407AEA      8B 30
       test   esi,esi                          ; 00407AEC      85 F6
       jz     .loc_00407B01_break              ; 00407AEE      74 11
       cmp    eax,dword [esi+4]                ; 00407AF0      3B 46 04
       jne    .loc_00407B01_break              ; 00407AF3      75 0C
.loc_00407AF5_whNext:          ; j< 00407A61   ; 00407AF5
       test   esi,esi                          ; 00407AF5      85 F6
       jz     .loc_00407B01_break              ; 00407AF7      74 08
       cmp    edi,esi                          ; 00407AF9      3B FE
       jnz    .loc_00407A66_whCycle            ; 00407AFB      0F 85 65 FF FF FF
.loc_00407B01_break:
       test   bl,bl                            ; 00407B01      84 DB
       ;//x240223: jnz    .loc_00407932_retry                    ; 00407B03      0F 85 29 FE FF FF
       ;//zmena240223 - in case of damage, retry at most twice:
       jz  .loc_00407B09_out
       inc byte [esp+5]
       cmp byte [esp+5],3
       jb near .loc_00407932_retry
       ;//
.loc_00407B09_out:          ; j< 00407A35      ; 00407B09
       pop    ecx                              ; 00407B09      59
       pop    edx                              ; 00407B0A      5A
       pop    ebp                              ; 00407B0B      5D
       pop    edi                              ; 00407B0C      5F
       pop    esi                              ; 00407B0D      5E
       pop    ebx                              ; 00407B0E      5B
       ret                                     ; 00407B0F      C3

align 4
;// function MmInternalCollectThread(Pool)
MmInternalCollectThread:
       push   ebp                              ; 00407B10      55
       mov    ebp,esp                          ; 00407B11      8B EC
       add    esp,byte -8                      ; 00407B13      83 C4 F8
       mov    dword [ebp-4],eax                ; 00407B16      89 45 FC
       xor    eax,eax                          ; 00407B19      33 C0
       mov    dword [ebp-8],eax                ; 00407B1B      89 45 F8
.loc_00407B1E_retry:          ; j> 00407BB4           ; 00407B1E
       ;//
       push   300                             ; 00407B1E      68 2C 01 00 00
       call   Sleep                            ; 00407B23      E8 1C E3 FF FF
       ;//
       mov    eax,dword [ebp-4]                ; 00407B28      8B 45 FC
       cmp    dword [eax],cMmPoolSign ;//0A970AAB5h           ; 00407B2B      81 38 B5 AA 70 A9
       jnz   near .loc_00407BAD                     ; 00407B31      75 7A
       ;//
       mov    eax,dword [ebp-4]            ; 00407B33      8B 45 FC
       add    eax,byte mpool_MidLock ;//5Ch                          ; 00407B36      83 C0 5C
       push   eax                              ; 00407B39      50
       call   EnterCriticalSection             ; 00407B3A      E8 5D E1 FF FF
       ;// try
       xor    edx,edx                          ; 00407B3F      33 D2
       push   ebp                              ; 00407B41      55
       ;//push   offset .loc_00407BA6_goFinally              ; 00407B42      68 A6 7B 40 00
       call .here17
       .here17:
       add dword [esp],byte (.loc_00407BA6_goFinally - .here17)
       ;//
       db 64h,0FFh,32h ;//push   fs:[edx]                         ; 00407B47      64 FF 32
       db 64h,89h,22h ;//mov    dword fs:[edx],esp           ; 00407B4A      64 89 22
       ;//
       mov    eax,dword [ebp-4]            ; 00407B4D      8B 45 FC
       call   near MmBgCollectWork_v2            ; 00407B50      E8 D3 FD FF FF
       ;//
       call   GetCurrentThreadId               ; 00407B55      E8 BA E1 FF FF
       mov    edx,dword [ebp-4]            ; 00407B5A      8B 55 FC
       cmp    eax,dword [edx+mpool_idColThread]         ; 00407B5D      3B 82 C4 00 00 00
       jnz    .loc_00407B8C                     ; 00407B63      75 27
       ;//
       ;//mov    eax,dword [ebp-4]            ; 00407B65      8B 45 FC
       ;//mov    eax,dword [eax+0C0h]         ; 00407B68      8B 80 C0 00 00 00
       ;// mov eax,[edx+mpool_hColThread]
       ;// ;//mov    edx,dword [ebp-4]            ; 00407B6E      8B 55 FC
       ;// and    dword [edx+mpool_hColThread],byte 0           ; 00407B71      83 A2 C0 00 00 00 00
       ;// ;//mov    edx,dword [ebp-4]            ; 00407B78      8B 55 FC
       ;// and    dword [edx+mpool_idColThread],byte 0           ; 00407B7B      83 A2 C4 00 00 00 00
       add  edx,mpool_hColThread
       xor  eax,eax
       xchg  [edx],eax
       and  dword [edx+(mpool_idColThread-mpool_hColThread)],byte 0
       ;//
       test   eax,eax                          ; 00407B82      85 C0
       jz     .loc_00407B8C                     ; 00407B84      74 06
       push   eax                              ; 00407B86      50
       call   CloseHandle                      ; 00407B87      E8 B8 E0 FF FF
.loc_00407B8C:          ; j< 00407B63           ; 00407B8C
                       ; j< 00407B84                           ; 00407B8C
       ;// end-try
       xor    eax,eax                          ; 00407B8C      33 C0
       pop    edx                              ; 00407B8E      5A
       pop    ecx                              ; 00407B8F      59
       pop    ecx                              ; 00407B90      59
       db 64h,89h,10h ;//mov    dword fs:[eax],edx           ; 00407B91      64 89 10
       ;//push   offset .loc_00407BAD              ; 00407B94      68 AD 7B 40 00
       call .here18
       .here18:
       add dword [esp],byte (.loc_00407BAD - .here18)
       ;//
.loc_00407B99_finally:          ; j> 00407BAB           ; 00407B99
       mov    eax,dword [ebp-4]            ; 00407B99      8B 45 FC
       add    eax,5Ch                          ; 00407B9C      83 C0 5C
       push   eax                              ; 00407B9F      50
       call   LeaveCriticalSection             ; 00407BA0      E8 27 E2 FF FF
       ret                                     ; 00407BA5      C3
;-----------------------------------------------------------   ; 00407BA5
.loc_00407BA6_goFinally:          ; p< 00407B42           ; 00407BA6
       jmp    HandleFinally                   ; 00407BA6      E9 39 B5 FF FF
       jmp   short .loc_00407B99_finally                     ; 00407BAB      EB EC
;-----------------------------------------------------------   ; 00407BAB
.loc_00407BAD:          ; j< 00407B31           ; 00407BAD
                       ; p< 00407B94                           ; 00407BAD
       ;// try once more soon, if some other pages were released just after our LeaveCriticalSection...
       push byte 20
       call Sleep
       ;//
       inc    dword [ebp-8]                ; 00407BAD      FF 45 F8
       cmp    dword [ebp-8],byte 1              ; 00407BB0      83 7D F8 01
       jz     .loc_00407B1E_retry                     ; 00407BB4      0F 84 64 FF FF FF
       ;//
       pop    ecx                              ; 00407BBA      59
       pop    ecx                              ; 00407BBB      59
       pop    ebp                              ; 00407BBC      5D
       ret                                     ; 00407BBD      C3

align 4
;// function MmCollectThread(Param): Longint; stdcall;
MmCollectThread:
       push   ebp                              ; 00407BC0      55
       mov    ebp,esp                          ; 00407BC1      8B EC
       push   ebx                              ; 00407BC3      53
       push   esi                              ; 00407BC4      56
       push   edi                              ; 00407BC5      57
       ;//try
       xor    eax,eax                          ; 00407BC6      33 C0
       push   ebp                              ; 00407BC8      55
       ;//push   offset loc_00407BE6           ; 00407BC9      68 E6 7B 40 00
       call .here16
       .here16:
       add dword [esp],byte (.loc_00407BE6 - .here16)
       ;// try
       db 64h,0FFh,30h ;//push   fs:[eax]                         ; 00407BCE      64 FF 30
       db 64h,89h,20h ;//mov    dword fs:[eax],esp           ; 00407BD1      64 89 20
       ;//
       mov    eax,dword [ebp+8]            ; 00407BD4      8B 45 08
       call   MmInternalCollectThread          ; 00407BD7      E8 34 FF FF FF
       ;// end-try
       xor    eax,eax                          ; 00407BDC      33 C0
       pop    edx                              ; 00407BDE      5A
       pop    ecx                              ; 00407BDF      59
       pop    ecx                              ; 00407BE0      59
       db 64h,89h,10h ;//mov    dword fs:[eax],edx           ; 00407BE1      64 89 10
       jmp  short  .loc_00407BF0                     ; 00407BE4      EB 0A
;-----------------------------------------------------------   ; 00407BE4
.loc_00407BE6:          ; p< 00407BC9           ; 00407BE6
       jmp    HandleAnyException              ; 00407BE6      E9 99 B2 FF FF
;-----------------------------------------------------------   ; 00407BE6
       call   DoneExcept                      ; 00407BEB      E8 08 B6 FF FF
.loc_00407BF0:          ; j< 00407BE4           ; 00407BF0
       xor    eax,eax                          ; 00407BF0      33 C0
       pop    edi                              ; 00407BF2      5F
       pop    esi                              ; 00407BF3      5E
       pop    ebx                              ; 00407BF4      5B
       pop    ebp                              ; 00407BF5      5D
       retn   4                                ; 00407BF6      C2 04 00

;//--------------------------------------------------------------------
%ifdef MicroAlloc

;// function MmMicroAlloc(MPool,Size<=8): Pointer;
MmMicroAlloc:
  test edx,edx
  jle  .invalid
  ;//
  mov  ecx,[eax+mpool_MicroPool]  ;// MiPool
  ;// from free-list:
.retry_free:
  mov  eax,[ecx+mmi_FreeItems]
  test eax,eax
  jz   .no_free
  mov  edx,mif_FreeSign4
  cmp  dword [eax+4],edx
  jne  .invalid_free
.valid_free:
  mov  edx,[eax]
  cmp  edx,0EEFEEEFEh
  je   .last_free
  not  edx
.put_next_free:
  lock cmpxchg [ecx+mmi_FreeItems],edx
  jne  .retry_free_f
.done:
  xor  edx,edx
  mov  [eax],edx
  mov  [eax+4],edx
  ret
.retry_free_f: ;// thread contention?
  db 0F3h
  nop
  jmp  short .retry_free
  ;// normal thread race condition is caught by "cmpxchg"
  ;// but there can be a rare race condition, that we pick it, other thread allocates it, we check it "invalid", but other thread frees it, and we cut the chain in vain...
.invalid_free:
  cmp  eax,[ecx+mmi_FreeItems]
  jne  .retry_free
  cmp  [eax+4],edx ;//mif_FreeSign4
  je   .valid_free
  %ifdef ErrHalt
  jmp short $
  %endif ;Debug
.last_free:
  xor  edx,edx
  jmp  short .put_next_free
.no_free:
  mov  eax,[ecx+mmi_TopPage]
  test eax,eax
  jz   .first_page
.from_page:
  mov  edx,8
  lock xadd [eax+mip_Cursor],edx
  cmp  edx,4096-8
  ja   .page_full
  add  eax,edx
  jmp  short .done
.page_full:
  or   edx,byte -8
  lock xadd [eax+mip_Cursor],edx
.first_page:
.next_page:
  push ecx
  call MmiAcquirePage
  pop  ecx
  test eax,eax
  jnz  short .retry_free
.invalid:
  xor  eax,eax
  ret

;// function MmiAcquirePage(ecx=MiPool): Bool
MmiAcquirePage:
  push ebx
  mov  ebx,ecx
  ;//
  push dword [ecx+mmi_Lock]
  call EnterCriticalSection
  ;// after TopPage
  ;// if we waited for other thread, it may have already allocated new TopPage...
  mov  eax,[ebx+mmi_TopPage]
  test eax,eax
  jz   .new_space
  cmp  dword [eax+mip_Cursor],4096-8
  jb   .done
  ;//
  cmp  ah,0F0h
  jae  .new_space
  add  ah,10h  ;// = add eax,1000h
  ;//
  mov  edx,1000h
  push edx
  ;//
  push edx
  push eax
  call MmVCommit
  test eax,eax
  pop  edx
  jz   .new_space
.fmt_new_page_addStat:
  add  dword [ebx+mmi_TotalCommit],edx
  ;// format new page:
.fmt_new_page:
  mov  edx,eax
  mov  dword [eax],cMipgSign
  mov  [eax+mip_Pool],ebx
  mov  byte [eax+mip_Cursor],10h
  ;// link new page:
  mov  eax,[ebx+mmi_TopPage]
  mov  [edx+mip_NextPage],eax
  mov  [ebx+mmi_TopPage],edx ;// lock cmpxchg [ebx+mmi_TopPage],edx -- cmpxchg not needed, pool is locked...
  mov  eax,edx
  ;//
.done:
  push eax
  ;//
  push dword [ebx+mmi_Lock]
  call LeaveCriticalSection
  ;//
  pop  eax
  pop  ebx
  ret
.new_space:
  call OwReserve64
  test eax,eax
  jz   .out_of_mem
  add  dword [ebx+mmi_TotalReserve],10000h
  push eax
  ;//
  mov  edx,1000h
  push edx
  ;//
  push edx
  push eax
  call MmVCommit
  test eax,eax
  pop  edx
  pop  ecx
  jnz  .fmt_new_page_addStat
  mov  eax,ecx
  call MmVRelease
.out_of_mem:
  mov  eax,ebx
  push byte 8
  pop  edx
  call MmOutOfMemoryError
  xor  eax,eax
  jmp  short .done

;// function MmMicroFree(edx=Page,ecx=Item): Boolean
;// page signature already checked in MmFree...
MmMicroFree:
  ;// clear free item:
  test cl,7
  jnz  .not_aligned
  mov  dword [ecx+4],mif_FreeSign4
  mov  edx,[edx+mip_Pool]
.retry:
  mov  eax,[edx+mmi_FreeItems]
  test eax,eax
  jz   .no_free
  not  eax
  mov  [ecx],eax
  not  eax
.link_free:
  lock cmpxchg [edx+mmi_FreeItems],ecx
  jne  .retry_f
  mov  al,1
  ret
.no_free:
  mov  dword [ecx],0EEFEEEFEh
  jmp  short .link_free
.retry_f:
  db 0F3h
  nop
  jmp short .retry
.not_aligned:
__mic_xar:
  xor  eax,eax
  ret

;// function MmMicroReAlloc(eax=Ptr,edx=Page,esi=NewSize,ebx=MPool): Pointer; // does not free old!
MmMicroReAlloc:
  test al,7
  jnz  __mic_xar
  push eax
  mov  edx,esi
  mov  eax,ebx
  call [ebx+mpool_AllocProc]
  test eax,eax
  pop  edx ;// old item...
  jz   .failed
.solved:
  ;// copy contents:
  mov  ecx,[edx]
  mov  edx,[edx+4]
  mov  [eax],ecx
  mov  [eax+4],edx
  ret
.failed:
  push edx
  mov  eax,ebx
  mov  edx,esi
  call MmOutOfMemoryError
  test eax,eax
  pop  edx
  jnz  .solved
  ret

;// function MmiCreate(eax=MmPool): TMmMicroPool
MmiCreate:
  push ebx
  mov  ebx,eax
  ;//
  add  eax,byte mpool_MidPage
  push byte mmi__sizeOf
  pop  edx
  call MmMidPageAlloc
  ;//
  mov  dword [eax],cMmiSignature
  mov  [eax+mmi_MPool],ebx
  add  ebx,mpool_MidLock
  mov  [eax+mmi_Lock],ebx
  ;//
  xor  edx,edx
  mov  [eax+mmi_FreeItems],edx
  ;//mov  [eax+mmi_Pages],edx
  mov  [eax+mmi_TopPage],edx
  mov  [eax+mmi_TotalReserve],edx
  mov  [eax+mmi_TotalCommit],edx
  ;//
  pop  ebx
  ret

%endif ;MicroAlloc
;//--------------------------------------------------------------------

;// function MmVirtPoolPreCreate(): Pointer
;//MmVirtPoolPreCreate:
;//  mov  eax,cMmInitVirtPool
;//  ret

              %if 0  ;// rather inline...
                  align 4
                  ;// function MmInitializeListHead(Entry)
                  MmInitializeListHead:
                    mov [eax],eax
                    mov [eax+4],eax
                    ret
              %endif ;inline

align 4
;// function MmFastNextEntry(Entry): Pointer
MmFastNextEntry:
  mov  edx,eax
  mov  eax,[eax] ;//mov  eax,[eax].TListEntry.FLink
  cmp  eax,edx
  je   .empty
  cmp  [eax+4],edx ;//cmp  [eax].TListEntry.BLink,edx
  jne  .bad_link
  ret
.bad_link:
.empty:
  xor  eax,eax
  ret

align 4
;// function MmRemoveEntryListAndClear(Entry): Pointer
MmRemoveEntryListAndClear:
  mov  edx,[eax] ;//mov  edx,[eax].TListEntry.FLink
  mov  ecx,[eax+4] ;//mov  ecx,[eax].TListEntry.BLink
  test edx,edx
  jz   .not_linked
  test ecx,ecx
  jz   .not_linked
  cmp  [edx+4],eax ;//cmp  [edx].TListEntry.BLink,eax
  jne  .bad_link
  cmp  [ecx],eax ;//cmp  [ecx].TListEntry.FLink,eax
  jne  .bad_link
  ;// unlink:
  mov  [edx+4],ecx ;//mov  [edx].TListEntry.BLink,ecx
  mov  [ecx],edx ;//mov  [ecx].TListEntry.FLink,edx
  xor  edx,edx
  mov  [eax],edx ;//mov  [eax].TListEntry.FLink,eax  ?!
  mov  [eax+4],edx ;//mov  [eax].TListEntry.BLink,eax  ?!
  ret
.bad_link:
.not_linked:
  xor eax,eax
  ret

              %if 0
                  ;// function SetBit(Dst,Index)
                  SetBit:
                    bts dword [eax],edx
                    ret
              %endif

;// function SetNBitsAligned(Bits,Count);
SetNBitsAligned:
  cmp edx,byte 8
  jb  .small
  or  ecx,byte -1
  sub edx,byte 32
  jl  .after32
.cy32:
  mov [eax],ecx
  add eax,byte 4
  sub edx,byte 32
  jnl .cy32
.after32:
  add edx,byte 32
  jz  .done
  sub edx,byte 8
  jl  .after8
.cy8:
  mov [eax],cl
  inc eax
  sub edx,byte 8
  jnl .cy8
.after8:
  add edx,byte 8
  jz  .done
.small:
  xor ecx,ecx
.cy1:
  bts [eax],ecx
  inc ecx
  dec edx
  jnz .cy1
.done:
  ret

;// function MmVReserve(Where,Size): Pointer; stdcall
;// [esp+4]=Where, [esp+8]=Size
MmVReserve:
  mov  eax,[esp+4]
  mov  edx,[esp+8]
  push byte PAGE_NOACCESS ;// 1
  push MEM_RESERVE        ;// 2000h
VaDa:
  push edx
  push eax
  call VirtualAlloc
  retn 8

;// function MmVCommit(Where,Size): Pointer; stdcall
;// [esp+4]=Where, [esp+8]=Size
MmVCommit:
  mov  eax,[esp+4]
  mov  edx,[esp+8]
  push byte PAGE_READWRITE ;// 4
  push MEM_COMMIT ;// 1000h
  jmp  short VaDa
  ;//push edx
  ;//push eax
  ;//call VirtualAlloc
  ;//retn 8

;// function MmVRelease(eax=Ptr)
MmVRelease:
  push MEM_RELEASE
  push byte 0
  push eax
  call VirtualFree
  ret

;// function MmVirtAllocFromNewSpace(VPool,Size): Pointer
MmVirtAllocFromNewSpace:
  push ebp
  mov  ebp,esp
  push ebx
  push edi
  push esi ;// [ebp-12] saved registers
  mov  ebx,eax ;// VPool
  xor  esi,esi
  ;//
  add  edx,0FFFh
  and  edx,-1000h
  ;//
  push edx ;// [ebp-16] = Size requested
  mov  eax,[ebx+mvp_DefSpaceSize]
  cmp  eax,edx
  cmovg edx,eax
  ;//
  add  edx,0FFFFh
  and  edx,-10000h
  ;//
  push edx ;// [ebp-20] = SpaceSize
  ;//
.retry_VReserve:
  push edx
  push byte 0
  call MmVReserve
  test eax,eax
  jz   .out_of_space_firstAttempt
  ;//New240303
  mov  edx,[ebp-20]
  add  [ebx+mvp_TotalReserve],edx
  ;//
  mov  edx,eax
  mov  eax,ebx
  mov  ecx,[ebp-20]
  shr  ecx,12
  call MmVirtMakeMvsDesc
  mov  edi,eax
  ;//
  ;// alloc from this mvs:
  push dword [ebp-16]
  push dword [edi+mvs_Base]
  call MmVCommit
  test eax,eax
  jz   .out_of_mem
  mov  esi,eax ;// Result
  ;//
  ;// mark bits allocated:
  xor  edx,edx
  mov  eax,[edi+mvs_HiMap]
  bts  dword [eax],edx
  mov  edx,[ebp-16]
  shr  edx,12 ;// PageCount
  mov  eax,[edi+mvs_LoMap]
  sub  [edi+mvs_FreePageCount],dx
  mov  [edi+mvs_wMinFree],dx
  call SetNBitsAligned
  ;//
  ;// add mvs desc to VPool:
  lea  eax,[ebx+mvp_Spaces]
  mov  edx,edi ;// mvs_Entry at start...
  call MmInsertTailList
  inc  dword [ebx+mvp_SpaceCount]
  ;//
  ;// done:
.done:
  mov  eax,esi
  lea  esp,[ebp-12]
  pop  esi
  pop  edi
  pop  ebx
  pop  ebp
  ret
  ;//New240302 - if there is no 4Mb address-space left, try smaller...
.out_of_space_firstAttempt:
  mov  edx,[ebp-20] ;// SpaceSize
  shr  edx,1        ;// SpaceSize / 2
  cmp  edx,[ebp-16] ;// >= SizeRequested ?
  jb   .out_of_space
  cmp  edx,10000h   ;// >= 64k
  jb   .out_of_space
  mov  [ebp-20],edx
  jmp short .retry_VReserve
  ;//
.out_of_mem:
  xor  eax,eax
  xchg [edi+mvs_Base],eax
  call MmVRelease
  ;//New240303
  mov  edx,[edi+mvs_Capacity]
  sub  [ebx+mvp_TotalReserve],edx
  ;//
  mov  edx,edi
  mov  eax,ebx
  call MmFreeMvsDesc
.out_of_space:
  mov  eax,[ebp-16]
  call MmOutOfMemoryError
  jmp short .done

align 4
;// function MmVirtInternalPageAlloc(VPool,Size): Pointer
MmVirtInternalPageAlloc:
  ;// Pool is already locked, Size is rounded up...
  push ebx
  push edi
  push esi
  push edx
  shr  edx,12 ;// PageCount
  jz   .none
.1page:
  mov  ebx,eax  ;// VPool
  ;//
  add  eax,byte mvp_Spaces ;//lea  eax,[eax+mvp_Spaces] ;//lea  eax,[eax].TMmVirtPool.Spaces
  mov  ecx,[eax] ;//mov  ecx,[eax].TListEntry.FLink ;// Space
  ;//
.go_cy:
  jmp near .cy_in
.none:
  ;//New240217
  pop  edx
  push 1000h
  ;//
  push byte 1
  pop  edx
  jmp short .1page
  ;//
.cy:
  cmp  dx,[ecx+mvs_FreePageCount] ;//cmp  dx,[ecx].TMmVirtSpace.FreePageCount
  ja   short .next_lda
  ;//
  ;// find free bits:
  mov  edi,[ecx+mvs_LoMap] ;//mov  edi,[ecx].TMmVirtSpace.LoMap
  movzx eax,word [ecx+mvs_wMinFree] ;//movzx eax,[ecx].TMmVirtSpace.wMinFree
  cmp  ax,[ecx+mvs_PageCount] ;//cmp  ax,[ecx].TMmVirtSpace.PageCount
  jae short .next_lda ;//x240229: ja  short .next_lda
  ;//
.bit_cy1a:
  bt   dword [edi],eax
  jc   .bit_skip1a
  ;// first bit found...
  mov [ecx+mvs_wMinFree],ax ;//mov  [ecx].TMmVirtSpace.wMinFree,ax
  jmp short .first_found
  ;//
.bit_skip1a:
  inc  eax
  cmp ax,[ecx+mvs_PageCount] ;//cmp  ax,[ecx].TMmVirtSpace.PageCount
  jb   .bit_cy1a
  ;//lea  eax,[ebx+mvp_Spaces] ;//lea  eax,[ebx].TMmVirtPool.Spaces
  ;//jmp near .next
  nop
  jmp short .next_lda
  ;//
.bit_cy1b:
  bt   dword [edi],eax
  jc   .bit_skip1b
  ;// first bit found...
.first_found:
  mov  esi,1
  cmp  edx,esi ;//1
  je   .found
  inc  eax
  ;// check other bits:        //!!!TODO: faster bit-skipping for FFFFFFFF...
.bit_cy2:
  bt   dword [edi],eax
  jc   .bit_skip1b
  inc  eax
  inc  esi
  cmp  esi,edx
  jae  .found0
  cmp  ax,[ecx+mvs_PageCount] ;//cmp  ax,[ecx].TMmVirtSpace.PageCount
  jb   .bit_cy2
  ;//
  ;//lea  eax,[ebx+mvp_Spaces] ;//lea  eax,[ebx].TMmVirtPool.Spaces
  ;//jmp short .next
  nop
  jmp short .next_lda
  ;//
.bit_skip1b:
  inc  eax
  cmp  ax,[ecx+mvs_PageCount] ;//cmp  ax,[ecx].TMmVirtSpace.PageCount
  jb   .bit_cy1b
.next_lda:
  lea  eax,[ebx+mvp_Spaces] ;//lea  eax,[ebx].TMmVirtPool.Spaces
  jmp short .next
  ;//
  ;//New240217
.updStats: ;// in esi=commit size
  add [ebx+mvp_TotalCommit],esi
  jmp short .out
  ;//
  ;// free bits found, mark them
.found0:
  ;//New240218 - may have found just after the last bit, when searching for 2 from last bit...!
  cmp  ax,[ecx+mvs_PageCount]
  ja   .next_lda
  ;//
  sub  eax,esi
.found:
  ;// now EAX=BitIndex of free space...
  cmp  ax,[ecx+mvs_wMinFree] ;//cmp  ax,[ecx].TMmVirtSpace.wMinFree
  jne  .no_move_minFree
  add  eax,esi
  mov  [ecx+mvs_wMinFree],ax ;//mov  [ecx].TMmVirtSpace.wMinFree,ax
  sub  eax,esi
.no_move_minFree:
  ;//
  push eax
  mov  edi,[ecx+mvs_HiMap] ;//mov  edi,[ecx].TMmVirtSpace.HiMap
  bts  dword [edi],eax
  mov  edi,[ecx+mvs_LoMap] ;//mov  edi,[ecx].TMmVirtSpace.LoMap
  mov  esi,edx
.mark_cy:
  bts  dword [edi],eax
  inc  eax
  sub  esi,byte 1
  jg   .mark_cy
  pop  eax
  ;//
  sub  [ecx+mvs_FreePageCount],dx  ;//sub  [ecx].TMmVirtSpace.FreePageCount,dx
  ;// commit memory:
  shl  eax,12
  add  eax,[ecx+mvs_Base] ;//add  eax,[ecx].TMmVirtSpace.Base
  shl  edx,12
  mov  edi,ecx
  ;//push byte PAGE_READWRITE
  ;//push MEM_COMMIT
  ;//push edx
  ;//push eax
  ;//call VirtualAlloc
    ;//New240217 - stats
    mov  esi,edx
    ;//
  ;//zmena240215:
  push edx
  push eax
  call MmVCommit
  ;//
  mov  ecx,edi
  test eax,eax
  jnz .updStats ;//jnz  .out //zmena240217 - stats
  ;// commit failed?!
  %ifdef ErrHalt
  jmp short $
  %endif ;ErrHalt
  mov  edx,[esp]
  shr  edx,12 ;//New240217
.skip:
  lea  eax,[ebx+mvp_Spaces] ;//lea  eax,[ebx].TMmVirtPool.Spaces
.next:
  mov  ecx,[ecx] ;//mov  ecx,[ecx].TListEntry.FLink
.cy_in:
  ;// while (Space<>nil) and (Space<>@Pool.Spaces)
  test ecx,ecx
  jz   .break
  cmp  ecx,eax
  jne  .cy
.break:
  ;// not found, start a new space...
  mov  eax,ebx
  shl  edx,12
  call MmVirtAllocFromNewSpace
.out:
  add  esp,byte 4
  pop  esi
  pop  edi
  pop  ebx
  ret

align 4
;// function MmVirtInternalPageFree(VPool,Page,Size): Boolean
MmVirtInternalPageFree:
  ;// Pool is already locked, Page is checked to be a page-pointer...
  push ebx
  push edi
  push esi
  push eax ;//New240217 [esp+4]=VPool
  push edx ;// [esp]=Page
  ;//x140820: mov  ebx,eax
  lea  eax,[eax+mvp_Spaces] ;//lea  eax,[eax].TMmVirtPool.Spaces
  mov  ecx,[eax]
  cmp  ecx,eax
  je   .break
.fcy:
  mov  edx,[esp]
  sub  edx,[ecx+mvs_Base] ;//sub  edx,[ecx].TMmVirtSpace.Base
  cmp  edx,[ecx+mvs_Capacity] ;//cmp  edx,[ecx].TMmVirtSpace.Capacity
  jb   .this_space
  mov  esi,[ecx] ;//mov  esi,[ecx].TListEntry.FLink
  test esi,esi
  jz   .list_damaged
  cmp  [esi+4],ecx ;//cmp  [esi].TListEntry.BLink,ecx
  jne  .list_damaged
  ;//x:mov  ecx,[ecx].TListEntry.FLink
  mov  ecx,esi
  cmp  esi,eax
  jne  .fcy
  ;// space not found...
.fail:
  xor  eax,eax
.out:
  add  esp,byte 8 ;//x240217: 4
  pop  esi
  pop  edi
  pop  ebx
  ret
  ;//
.ok:
  ;//mov  eax,1
  push byte 1
  pop  eax
  jmp short .out
  ;//
.list_damaged:
  ;// Some repair?
  ;//!!!
  jmp short .fail
  ;//
.this_space:
  shr  edx,12 ;// PageIndex
  mov  eax,[ecx+mvs_HiMap] ;//mov  eax,[ecx].TMmVirtSpace.HiMap
  mov  edi,[ecx+mvs_LoMap] ;//mov  edi,[ecx].TMmVirtSpace.LoMap
  ;//
  cmp  dx,[ecx+mvs_wMinFree] ;//cmp  dx,[ecx].TMmVirtSpace.wMinFree
  ja   .not_min_free
  mov  [ecx+mvs_wMinFree],dx ;//mov  [ecx].TMmVirtSpace.wMinFree,dx
.not_min_free:
  ;//
  btr  dword [eax],edx
  jnc  near .not_start
  xor  esi,esi
.cy:
  btr  dword [edi],edx
  jnc  .break
  ;//x:inc  [ecx].TMmVirtSpace.FreePageCount
  inc  esi
  inc  edx
  cmp  dx,[ecx+mvs_PageCount] ;//cmp  dx,[ecx].TMmVirtSpace.PageCount
  jae  .break
  bt   dword [eax],edx
  jnc  .cy
.break:
  add  [ecx+mvs_FreePageCount],si ;//add  [ecx].TMmVirtSpace.FreePageCount,si
  mov  ebx,ecx ;//New140820
  ;//New200907 - if there is error and esi=0 at start of space, that would decommit whole space
  test esi,esi
  jz   .skip_decommit
  ;//
  ;// free pages:
  mov  edx,[esp]
  push MEM_DECOMMIT
  shl  esi,12
  push esi
  push edx
  call VirtualFree
    ;//New240217 - stats
    mov  eax,[esp+4] ;// VPool
    sub  [eax+mvp_TotalCommit],esi
    ;//
  ;//
.skip_decommit:
  ;//
  mov  ecx,ebx ;//New140820
  ;//
  ;// Check, if whole page released:
  movzx eax,word [ecx+mvs_FreePageCount] ;//movzx eax,[ecx].TMmVirtSpace.FreePageCount
  cmp ax,[ecx+mvs_PageCount] ;//cmp  ax,[ecx].TMmVirtSpace.PageCount
  jb   .ok
  ;//
  ;// check, that really free:
  xor  edx,edx
  mov  eax,[ecx+mvs_LoMap] ;//mov  eax,[ecx].TMmVirtSpace.LoMap
.cy2:
  bt   dword [eax],edx
  jc   .sync_FreeCount ;// not all free?
  inc  edx
  cmp  dx,[ecx+mvs_PageCount] ;//cmp  dx,[ecx].TMmVirtSpace.PageCount
  jb   .cy2
  ;//
  ;// Drop whole space:
  mov  edi,ecx
  ;// unlink:
  mov  eax,ecx
  call MmRemoveEntryListAndClear
  test eax,eax
  jz   .ok
    ;//New240217 - stats
    mov  edx,[esp+4] ;// VPool
    movzx ecx,word [edi+mvs_PageCount]
    shl  ecx,12
    sub  [edx+mvp_TotalReserve],ecx
    dec  dword [edx+mvp_SpaceCount]
    ;//
  ;// free memory:
  xor  eax,eax
                    %if 0 ;// Original:
                      mov  [edi+mvs_Signature],ax ;//mov  [edi].TMmVirtSpace.Signature,ax
                    %endif ;old
  xchg [edi+mvs_Base],eax ;//xchg [edi].TMmVirtSpace.Base,eax
  ;//
  ;//push MEM_RELEASE
  ;//push byte 0
  ;//push eax
  ;//call VirtualFree
  call MmVRelease
  ;//
  ;// free space desc
                    %if 0 ;// Original:
                    xor  eax,eax
                    mov  edx,edi
                    call MmFree
                    %endif ;old
  mov  eax,[esp+4] ;// VPool
  mov  edx,edi
  call MmFreeMvsDesc
  ;//
.go_ok:
  jmp near .ok
  ;//
.sync_FreeCount:
  inc  esi
  jmp short .cy3_in
.cy3:
  bt   [eax],edx
  jc   .sync_FreeCount
.cy3_in:
  inc  edx
  cmp  dx,[ecx+mvs_PageCount] ;//cmp  dx,[ecx].TMmVirtSpace.PageCount
  jb   .cy3
  ;//
  neg  esi
  add  si,[ecx+mvs_PageCount] ;//add  si,[ecx].TMmVirtSpace.PageCount ;// PageCount-UsedPageCount
  mov  [ecx+mvs_FreePageCount],si ;//mov  [ecx].TMmVirtSpace.FreePageCount,si
  jmp short .go_ok ;//jmp near .ok
  ;//
.not_start:
  xor  eax,eax
  jmp near .fail

align 4
;// function MmVirtPageAlloc(Arg,Size): Pointer
MmVirtPageAlloc:               ; ?> 0040878F           ; 004084F4
       push   ebp                              ; 004084F4      55
       mov    ebp,esp                          ; 004084F5      8B EC
       add    esp,byte -8                           ; 004084F7      83 C4 F8
       push   ebx                              ; 004084FA      53
       mov    ebx,edx     ;// Size             ; 004084FB      8B DA
       ;// if(Size<=0) return nil;
       test   ebx,ebx                          ; 004084FD      85 DB
       jg     .loc_0040850B_sizeOk             ; 004084FF      7F 0A
       xor    eax,eax                          ; 00408501      33 C0
       mov    [ebp-4],eax                      ; 00408503      89 45 FC
       jmp  near  .loc_004085CC_done                    ; 00408506      E9 C1 00 00 00
       ;// if(Arg=cMmInitVirtPool) and (Size=$1000)
.loc_0040850B_sizeOk:    ; j< 004084FF         ; 0040850B
       cmp    eax,cMmInitVirtPool              ; 0040850B      3D E3 A8 57 D4
       jnz    .loc_00408561_normal             ; 00408510      75 4F
       cmp    ebx,1000h                        ; 00408512      81 FB 00 10 00 00
       jnz    .loc_00408561_normal             ; 00408518      75 47
       ;//
       ;//push   byte PAGE_NOACCESS ;//1                                ; 0040851A      6A 01
       ;//push   MEM_RESERVE ;//2000h                            ; 0040851C      68 00 20 00 00
       ;//push   10000h                           ; 00408521      68 00 00 01 00
       ;//push   byte 0                                ; 00408526      6A 00
       ;//call   VirtualAlloc                     ; 00408528      E8 27 D9 FF FF
       ;//zmena240215:
       mov  ebx,10000h
       push ebx ;//push 10000h
       push def_InitPool
       call MmVReserve
       test eax,eax
       jnz  .init_ok
       push ebx ;//push 10000h
       push byte 0
       call MmVReserve
     .init_ok:
       ;//
       mov    ebx,eax    ;// Space             ; 0040852D      8B D8
       test eax,eax ;//test   ebx,ebx          ...
       jz    near .loc_004085C7_fail                     ; 00408531      0F 84 90 00 00 00
       ;//
       ;//push   byte PAGE_READWRITE ;// 4                                ; 00408537      6A 04
       ;//push   MEM_COMMIT ;//1000h                            ; 00408539      68 00 10 00 00
       ;//push   1000h                            ; 0040853E      68 00 10 00 00
       ;//push   ebx                              ; 00408543      53
       ;//call   VirtualAlloc                     ; 00408544      E8 0B D9 FF FF
       ;//zmena240215:
       push 1000h
       push ebx
       call MmVCommit
       ;//
       mov    [ebp-4],eax        ;//Result     ; 00408549      89 45 FC
       ;//cmp    dword [ebp-4],0               ; 0040854C      83 7D FC 00
       test eax,eax
       jnz   short .loc_004085CC_done          ; 00408550      75 7A
       ;//
       ;// Commit failed?!
       ;//
       ;//push   MEM_RELEASE ;//8000h                            ; 00408552      68 00 80 00 00
       ;//push byte 0                             ; 00408557      6A 00
       ;//push   ebx                              ; 00408559      53
       ;//call   VirtualFree                      ; 0040855A      E8 FD D8 FF FF
       mov  eax,ebx
       call MmVRelease
       ;//
       jmp  short .loc_004085C7_fail                     ; 0040855F      EB 66
       ;//
.loc_00408561_normal:  ; j< 00408510           ; 00408561
                       ; j< 00408518                           ; 00408561
       test   eax,eax                          ; 00408561      85 C0
       jz     .loc_004085C7_fail                     ; 00408563      74 62
       ;// round:
       add    ebx,0FFFh                        ; 00408565      81 C3 FF 0F 00 00
       and    ebx,0FFFFF000h                   ; 0040856B      81 E3 00 F0 FF FF
       ;//
       mov    [ebp-8],eax         ;// VPool    ; 00408571      89 45 F8
       cmp    dword [eax],cMmVirtPoolSign ;//84E0D36Fh        ; 00408577      81 38 6F D3 E0 84
       jnz    .loc_004085C7_fail                     ; 0040857D      75 48
       ;//
       mov    eax,[eax+mvp_Lock]               ; 00408582      8B 40 04
       push   eax                              ; 00408585      50
       call   EnterCriticalSection             ; 00408586      E8 11 D7 FF FF
       ;// try
       xor    eax,eax                          ; 0040858B      33 C0
       push   ebp                              ; 0040858D      55
       ;//push   offset .loc_004085C0 ;             ; 0040858E      68 C0 85 40 00
       call .here1
       .here1:
       add dword [esp],byte (.loc_004085C0_goFinally - .here1)
       ;//
       db 64h,0ffh,30h ;//push   fs:[eax]                         ; 00408593      64 FF 30
       db 64h,89h,20h ;//mov    dword fs:[eax],esp           ; 00408596      64 89 20
       ;//
       mov    edx,ebx                          ; 00408599      8B D3
       mov    eax,[ebp-8]                      ; 0040859B      8B 45 F8
       call   MmVirtInternalPageAlloc          ; 0040859E      E8 0D FD FF FF
       ;//
       mov    [ebp-4],eax       ;// Result     ; 004085A3      89 45 FC
       ;// end-try:
       xor    eax,eax                          ; 004085A6      33 C0
       pop    edx                              ; 004085A8      5A
       pop    ecx                              ; 004085A9      59
       pop    ecx                              ; 004085AA      59
       db 64h,89h,10h ;//mov    dword fs:[eax],edx           ; 004085AB      64 89 10
       ;//
       ;//push   offset loc_004085CC_done            ; 004085AE      68 CC 85 40 00
       call  .here2
       .here2:
       add  dword [esp],byte (.loc_004085CC_done - .here2)
       ;//
.loc_004085B3_finally:
       mov    eax,[ebp-8]                      ; 004085B3      8B 45 F8
       mov    eax,[eax+mvp_Lock]               ; 004085B6      8B 40 04
       push   eax                              ; 004085B9      50
       call   LeaveCriticalSection             ; 004085BA      E8 0D D8 FF FF
       ret                                     ; 004085BF      C3
       ;//
.loc_004085C0_goFinally:          ; p< 0040858E           ; 004085C0
       jmp    HandleFinally                   ; 004085C0      E9 1F AB FF FF
       ;//
       jmp  short .loc_004085B3_finally        ; 004085C5      EB EC
       ;//
  ;// Fail:
.loc_004085C7_fail:          ; j< 00408531     ; 004085C7
                       ; j< 0040855F                           ; 004085C7
                       ; j< 00408563                           ; 004085C7
       xor    eax,eax                          ; 004085C7      33 C0
       mov    [ebp-4],eax                      ; 004085C9      89 45 FC
       ;//
.loc_004085CC_done:
       mov    eax,[ebp-4]                      ; 004085CC      8B 45 FC
       ;//
.out:
       pop    ebx                              ; 004085CF      5B
       pop    ecx                              ; 004085D0      59
       pop    ecx                              ; 004085D1      59
       pop    ebp                              ; 004085D2      5D
       ret                                     ; 004085D3      C3

align 4
;// function MmVirtPageFree(Arg,Page,Size): Boolean
MmVirtPageFree:
       push   ebp                              ; 004085D4      55
       mov    ebp,esp                          ; 004085D5      8B EC
       add    esp,byte -8                   ; 004085D7      83 C4 F8
       push   ebx                              ; 004085DA      53
       push   esi                              ; 004085DB      56
       ;//
       mov    esi,ecx   ;// Size               ; 004085DC      8B F1
       mov    ebx,edx   ;// Page               ; 004085DE      8B DA
       mov    dword [ebp-8],eax ;// VPool  ; 004085E0      89 45 F8
       ;//cmp    dword [ebp-8],0              ; 004085E3      83 7D F8 00
       test eax,eax
       jz     .loc_0040864A_fail                     ; 004085E7      74 61
       ;//mov    eax,dword [ebp-8]            ; 004085E9      8B 45 F8
       cmp    dword [eax],cMmVirtPoolSign        ; 004085EC      81 38 6F D3 E0 84
       jnz    .loc_0040864A_fail                     ; 004085F2      75 56
       ;//
       test   ebx,0FFFh                        ; 004085F4      F7 C3 FF 0F 00 00
       jnz    .loc_0040864A_fail                     ; 004085FA      75 4E
       ;//
       test   ebx,ebx                          ; 004085FC      85 DB
       jz     .loc_0040864A_fail                     ; 004085FE      74 4A
       ;//
       ;//mov    eax,dword [ebp-8]            ; 00408600      8B 45 F8
       mov    eax,dword [eax+mvp_Lock]            ; 00408603      8B 40 04
       push   eax                              ; 00408606      50
       call   EnterCriticalSection             ; 00408607      E8 90 D6 FF FF
       ;// try
       xor    eax,eax                          ; 0040860C      33 C0
       push   ebp                              ; 0040860E      55
       ;//push   offset .loc_00408643_gofinally              ; 0040860F      68 43 86 40 00
       call .here3
       .here3:
       add  dword [esp],byte (.loc_00408643_gofinally - .here3)
       ;//
       db 64h,0ffh,30h ;//push   fs:[eax]                         ; 00408614      64 FF 30
       db 64h,89h,20h ;//mov    dword fs:[eax],esp           ; 00408617      64 89 20
       ;//
       mov    ecx,esi                          ; 0040861A      8B CE
       mov    edx,ebx                          ; 0040861C      8B D3
       mov    eax,dword [ebp-8]            ; 0040861E      8B 45 F8
       call   MmVirtInternalPageFree           ; 00408621      E8 7A FD FF FF
       ;//
       mov    byte [ebp-1],al              ; 00408626      88 45 FF
       ;// end-try:
       xor    eax,eax                          ; 00408629      33 C0
       pop    edx                              ; 0040862B      5A
       pop    ecx                              ; 0040862C      59
       pop    ecx                              ; 0040862D      59
       db 64h,89h,10h ;//mov    dword fs:[eax],edx           ; 0040862E      64 89 10
       ;//push   offset .loc_0040864E_done              ; 00408631      68 4E 86 40 00
       call .here4
       .here4:
       add dword [esp],byte (.loc_0040864E_done - .here4)
       ;//
.loc_00408636_finally:          ; j> 00408648           ; 00408636
       mov    eax,dword [ebp-8]            ; 00408636      8B 45 F8
       mov    eax,dword [eax+mvp_Lock]            ; 00408639      8B 40 04
       push   eax                              ; 0040863C      50
       call   LeaveCriticalSection             ; 0040863D      E8 8A D7 FF FF
       ret                                     ; 00408642      C3
;-----------------------------------------------------------   ; 00408642
.loc_00408643_gofinally:          ; p< 0040860F           ; 00408643
       jmp    HandleFinally                   ; 00408643      E9 9C AA FF FF
;-----------------------------------------------------------   ; 00408643
       jmp  short .loc_00408636_finally                     ; 00408648      EB EC
;-----------------------------------------------------------   ; 00408648
.loc_0040864A_fail:          ; j< 004085E7           ; 0040864A
                       ; j< 004085F2                           ; 0040864A
                       ; j< 004085FA                           ; 0040864A
       mov    byte [ebp-1],0               ; 0040864A      C6 45 FF 00
.loc_0040864E_done:          ; p< 00408631           ; 0040864E
       mov    al,byte [ebp-1]              ; 0040864E      8A 45 FF
       ;//
       pop    esi                              ; 00408651      5E
       pop    ebx                              ; 00408652      5B
       pop    ecx                              ; 00408653      59
       pop    ecx                              ; 00408654      59
       pop    ebp                              ; 00408655      5D
       ret                                     ; 00408656      C3

;// function MmVirtMakeMvsDesc(VPool,Space,PageCount)
MmVirtMakeMvsDesc:
  push  ebx
  push  edi
  push  esi
  mov   ebx,eax ;// VPool
  mov   edi,edx ;// Space
  mov   edx,ecx ;// PageCount
  push  edx
  add   edx,byte 7
  shr   edx,3   ;// MapSize
  push  edx
  add   edx,edx
  add   edx,byte mvs__sizeOf
  mov   eax,[ebx+mvp_OwPool]
  call  OwAlloc
  mov   esi,eax
  mov   dword [eax+mvs_Signature],cMmVirtSpaceSign ;// also sets mvs_wMinFree:=0
  mov   [eax+mvs_Base],edi
  lea   edx,[eax+mvs__sizeOf]
  mov   [eax+mvs_LoMap],edx
  pop   ecx ;// MapSize
  add   edx,ecx
  mov   [eax+mvs_HiMap],edx
  pop   edx ;// PageCount
  mov   [eax+mvs_PageCount],dx
  mov   [eax+mvs_FreePageCount],dx
  shl   edx,12
  mov   [eax+mvs_Capacity],edx
  ;//
  pop   esi
  pop   edi
  pop   ebx
  ret

;// function MmFreeMvsDesc(VPool,Mvs)
MmFreeMvsDesc:
  push eax
  xor  ecx,ecx
  cmp  [edx+mvs_Base],ecx
  jnz  .invalid
  mov  ax,cMmVirtSpaceSign
  lock cmpxchg [edx+mvs_Signature],cx
  jne  .invalid
  ;// free desc:
  mov  ecx,[edx+mvs_HiMap]
  sub  ecx,[edx+mvs_LoMap] ;// map-size
  add  ecx,[edx+mvs_HiMap] ;// mvs end
  sub  ecx,edx ;// mvs size
  pop  eax ;// VPool
  mov  eax,[eax+mvp_OwPool]
  call OwFree
  push byte 1
  pop  eax
  ret
.invalid:
  pop  eax
  xor  eax,eax
  ret

;// function MmVirtPoolReInit(Pager,AllocProc,AllocArg,lpLockRtl)  // lpLockRtl is passed on stack...
MmVirtPoolReInit:
  cmp  dword [eax+vp_Arg],cMmInitVirtPool
  je   .init
  retn 4
.init:
  push ebx
  push edi
  push esi
  mov  esi,ecx ;// PMmPool
  mov  ebx,eax ;// TMmVirtPager
  mov  eax,def_InitMvp
    c_mvs_min_size equ (def_VSpace_Size/4096/8*2+mvs__sizeOf) ;// =120h = 288 for 4Mb spaces...
  mov  edx,c_mvs_min_size ;// MinSize - ignore smaller free items...
  call OwCreate ;// does not fail at startup, or crash...
  mov  edi,eax ;// POwPool
  push byte mvp__sizeOf
  pop  edx
  call OwAlloc
  mov  dword [eax],cMmVirtPoolSign
  mov  [eax+mvp_MemPool],esi
  mov  esi,eax ;// TMmVirtPool
  mov  [esi+mvp_OwPool],edi
  mov  eax,[esp+12+4] ;// lpLockRtl
  test eax,eax
  mov  [esi+mvp_Lock],eax
  jnz  .lock_ok
.init_lock:
  push  byte 18h  ;// SizeOf(TRtlCriticalSection)
  pop   edx
  mov   eax,edi
  call  OwAlloc
  mov   [esi+mvp_Lock],eax
  push  eax
  call  InitializeCriticalSection
.lock_ok:
  lea  eax,[esi+mvp_Spaces]
  mov  [eax],eax ;// MmInitializeListHead
  mov  [eax+4],eax
  mov  dword [esi+mvp_DefSpaceSize],def_VSpace_Size
  xor  eax,eax
  mov  [esi+mvp_SpaceCount],eax
  mov  [ebx+vp_Arg],esi
  ;//mov  dword [esi+mvp_TotalCommit],1000h
  ;//mov  dword [esi+mvp_TotalReserve],10000h
  mov  ah,10h
  mov  [esi+mvp_TotalCommit],eax
  shl  eax,4
  mov  [esi+mvp_TotalReserve],eax
  ;// Make Mvs Descriptor for init space:
  mov  edx,[esi+mvp_MemPool]
  ;//and  edx,0FFFF0000h ;// round down from MemPool to vpage-start
  neg  eax
  and  edx,eax
  ;//
  push byte 10h ;// 64k >> 12
  pop  ecx
  mov  eax,esi
  call MmVirtMakeMvsDesc
  ;//
  mov  edx,[eax+mvs_LoMap] ;// set bit in LoMap, do not set in HiMap - should not free it...
  xor  ecx,ecx
  bts  [edx],ecx
  dec  word [eax+mvs_FreePageCount]
  ;//
  mov  edx,eax
  lea  eax,[esi+mvp_Spaces]
  call MmInsertTailList
  ;//
  mov  eax,ebx
  pop  esi
  pop  edi
  pop  ebx
  ;//
.out0:
  retn 4
  

;// function MmVDecomRelease(Ptr,Size)
MmVDecomRelease:
  push MEM_RELEASE
  push byte 0
  push eax
  push MEM_DECOMMIT
  push edx
  push eax
  call VirtualFree
  call VirtualFree
  ret

align 4
;// function MmVirtPoolShutdown(Arg,MemPool): Boolean
MmVirtPoolShutdown:
  ;// if (Pool.MemPool=MemPool) then begin
  cmp [eax+mvp_MemPool],edx ;//cmp  [eax].TMmVirtPool.MemPool,edx
  jne  .fail0
  ;// drop spaces:
  push ebp
  mov  ebp,esp
  ;//
  push dword [eax+mvp_OwPool]
  ;//
  push byte 0
  push byte 0
  ;//
  lea ecx,[eax+mvp_Spaces] ;//lea  ecx,[eax].TMmVirtPool.Spaces
  and dword [eax+mvp_SpaceCount],byte 0
  mov  eax,ecx
.cy1:
  mov  edx,[eax] ;//mov  edx,[eax].TListEntry.FLink
  cmp  [edx+4],eax ;//cmp  [edx].TListEntry.BLink,eax
  jne  .damaged
  cmp  edx,ecx
  je   .break1
  mov  eax,edx
  cmp  word [eax+mvs_Signature],cMmVirtSpaceSign ;//cmp  [eax].TMmVirtSpace.Signature,cMmVirtSpaceSign
  jne  .damaged
  ;//
  cmp  dword [eax+mvs_Base],byte 0 ;//cmp  [eax].TMmVirtSpace.Base,0
  je   .cy1
  push dword [eax+mvs_Capacity] ;//push [eax].TMmVirtSpace.Capacity
  push dword [eax+mvs_Base] ;//push [eax].TMmVirtSpace.Base
  jmp  short .cy1
.break1:
.damaged:
  ;//
.cy2:
  pop  eax
  pop  edx
  ;//
  test eax,eax
  jz   .break2
  ;//
        ;////x240221:
        ;//push MEM_RELEASE
        ;//push byte 0
        ;//push eax
        ;//push MEM_DECOMMIT
        ;//push edx
        ;//push eax
        ;//call VirtualFree
        ;//call VirtualFree
  call MmVDecomRelease
  ;//
  jmp short .cy2
  ;//
.break2:
  ;// OwPool outside of Mvs spaces:
  pop  eax
  call OwShutdown
  ;//
  push byte 1
  pop  eax
  mov  esp,ebp
  pop  ebp
  ret
  ;//
.fail0:
  xor  eax,eax
  ret

;//align 4
;// function MmGetDefVirtPager(out VirtPool);
MmGetDefVirtPager:
  call .here5
  .here5:
  pop   ecx
  ;//VirtPool.AllocRawPage:=MmVirtPageAlloc;
  lea  edx,[ecx+(MmVirtPageAlloc-.here5)]
  mov  [eax+vp_AllocRawPage],edx
  ;//VirtPool.ReleaseRawPage:=MmVirtPageFree;
  lea  edx,[ecx+(MmVirtPageFree-.here5)]
  mov  [eax+vp_ReleaseRawPage],edx
  ;//VirtPool.ReInit:=MmVirtPoolReInit;
  lea  edx,[ecx+(MmVirtPoolReInit-.here5)]
  mov  [eax+vp_ReInit],edx
  ;//VirtPool.Shutdown:=MmVirtPoolShutdown;
  lea  edx,[ecx+(MmVirtPoolShutdown-.here5)]
  mov  [eax+vp_Shutdown],edx
  ;//VirtPool.Arg:=MmVirtPoolPreCreate();
  mov  dword [eax+vp_Arg],cMmInitVirtPool
  ;//
  ret

;//--------------------------------------------------------------------
;// Simple One-way pool:

align 4
;// function OwCreate(defBase,MinSize) - returns POwPool
;// MinSize is hint of min free item worth retaining, all allocation is (usually?) rounded on 16-byte boundary
OwCreate:
  push edx ;// MinSize
  call OwReserve64
  test eax,eax
  jz   .out_of_mem
.useSpace:
  call OwCommit2nd
  test eax,eax
  jz   .commit_failed
  ;// eax=Page=POwPool, ecx=VPage, edx=VEnd
.init:
  push edx ;// VEnd
  mov  dword [eax],cMmOwPoolSign
  lea  edx,[eax+owp__sizeOf]  ;// OwPage
  mov  [eax+owp_TopPage],edx
  ;//mov  [eax+owp_Pages],edx
  mov  dword [edx],cMmOwPgSign
  mov  [edx+owpg_VBase],ecx
  mov  [edx+owpg_CStart],eax
  mov  [edx+owpg_Pool],eax
  ;//
  pop  ecx ;// VEnd
  mov  [edx+owpg_VEnd],ecx
  mov  [eax+owp_NextSpace],ecx
  ;//
  pop  ecx ;// MinSize
  cmp  ecx,10h
  jg   .min_ok
  push byte 10h
  pop  ecx
.min_ok:
  mov  [eax+owp_MinSize],ecx
  ;//
  lea  ecx,[eax+1000h]
  mov  [edx+owpg_CEnd],ecx
  mov  [eax+owp_CEnd],ecx
  lea  ecx,[edx+owpg__sizeOf]
  mov  [eax+owp_Cur],ecx
  xor  ecx,ecx
  mov  [eax+owp_Free],ecx
  mov  [edx+owpg_Next],ecx
  ret
  ;//
.commit_failed:
  mov  eax,ecx
  call MmVRelease
.out_of_mem:
  %ifdef ErrHalt
    jmp short $ ;// halt
  %endif ;ErrHalt
  xor  eax,eax
  pop  edx
  ret

;// function OwReserve64(defBase) - reserve 64k:
OwReserve64:
  push byte 2
.retry:
  push 10000h
  push eax
  call MmVReserve
  test eax,eax
  jz   .retry_f
  pop  edx
  ret
.retry_f:
  pop  edx
  dec  edx
  push edx
  jnz  .retry
retpop_Edx:
  pop  edx
  ret

;// OwCommit2nd(VBase) - commit second page, returns eax=CStart~nil, ecx=VBase, edx=VEnd
;// one page left unused as sanitary barrier
OwCommit2nd:
  push eax
  mov  edx,1000h
  push edx
  add  eax,edx
  push eax
  call MmVCommit
  pop  ecx
  lea  edx,[ecx+10000h]
  ret

;// __OwCheckPool - check OwPool in EAX, return nil to outer caller if bad...
__OwCheckPool:
  test eax,eax
  jle  .fail
  cmp  dword [eax],cMmOwPoolSign
  jne  .fail
  ret
.fail:
  pop  eax ;// pop our caller
  xor  eax,eax
  ret      ;// return to outer caller

;// OwFree(OwPool,Ptr,Size)
OwFree:
  call __OwCheckPool
  push ebx
  push edi
  mov  ebx,eax ;// OwPool
  test edx,edx
  jle  .fail
  cmp  ecx,[ebx+owp_MinSize] ;//byte 10h?
  jl   .fail
  shr  ecx,2
  push edx
  push ecx
  mov  edi,edx ;// was missing in v15...! but by some random coincidence, there already was this pointer (from callers of MmFreeMvsDesc) in all real use cases and it was not used after this, so I didn't notice it and it worked...
  xor  eax,eax
  rep  stosd
  pop  ecx
  pop  edx
  shl  ecx,2 ;// also rounds size down to nearest dword...
  ;// if it is just before Cur, just move Cur back:
  lea  eax,[edx+ecx]
  lock cmpxchg [ebx+owp_Cur],edx
  je   .ok
  ;//
  mov  [edx+owf_Size],ecx
  mov  dword [edx+owf_Signature],cMmOwFreeSign
.retry_link:
  mov  eax,[ebx+owp_Free]
  mov  [edx+owf_Next],eax
  lock cmpxchg [ebx+owp_Free],edx
  jne  .retry_link
.ok:
  pop  edi
  pop  ebx
  push byte 1
  pop  eax
  ret
.fail:
  xor  eax,eax
  pop  edi
  pop  ebx
  ret

;// OwAlloc(OwPool,Size) - returns Pointer
OwAlloc:
  call __OwCheckPool
  push ebx
  mov  ebx,eax  ;// OwPool
  add  edx,byte 0Fh
  and  edx,byte -10h
  jle  .fail
  cmp  edx,0EF80h ;// maximum available size little less than 60kb
  ja   .fail
  cmp  dword [ebx+owp_Free],byte 0
  jnz  .find_free
.new:
  ;// normal flow is very simple and fast:
  mov  eax,[ebx+owp_Cur]
  lea  ecx,[eax+edx]
  cmp  ecx,[ebx+owp_CEnd]
  jae  short .go_need_commit
  lock cmpxchg [ebx+owp_Cur],ecx
  jne  .retry_new
.out:
  pop  ebx
  ret
.fail: ;// see also .fail2 below...
  xor  eax,eax
  pop  ebx
  ret
.retry_new:
  db 0F3h
  nop
  jmp short .new
  ;//
.go_need_commit:
  jmp  short .need_commit
  ;//
.find_free: ;// ebx=Pool, eax=free_space, edx=size
  push esi
  push edx  ;// [esp+4] = size
  ;//
  mov  esi,4096 ;// max count of free items, or cut the chain as suspecting circular link...
  ;//
  lea  ecx,[ebx+owp_Free]
  mov  eax,[ecx]
  push eax  ;// [esp] = orig first free item
.cy_free:
  test eax,eax
  jle  .end_free
  dec  esi
  jz   .end_free
  cmp  dword [eax+owf_Signature],cMmOwFreeSign
  jne  .end_free
  cmp  edx,[eax+owf_Size]
  jbe  .found_free
  mov  ecx,eax ;// [eax+owf_Next] at start...
  mov  eax,[eax]
  test eax,eax
  jnz  .cy_free
  ;// no such free
  pop  eax
  pop  edx
  pop  esi
.go_new:
  jmp  short .new
  ;//
.found_free:
  ;//push eax
  mov  edx,[eax+owf_Next]
  lock cmpxchg [ecx],edx
  ;//pop  eax
  jnz  .diff_free
  ;// allocated...
  xor  ecx,ecx
  mov  [eax+owf_Signature],ecx
  mov  [eax+owf_Next],ecx
  xchg [eax+owf_Size],ecx
  mov  edx,[esp+4] ;// edx=requested size, ecx=avail size
  sub  ecx,edx ;// rest size
  cmp  ecx,[ebx+owp_MinSize] ;//byte 40h?
  jl   .no_rest
  ;// return rest of free space for reuse:
  push eax
  add  edx,eax
  mov  eax,ebx
  call OwFree
  pop  eax
  ;//
.no_rest:
  pop  edx
  pop  edx
  pop  esi
  jmp short .out
  ;//
.diff_free:
  xor  eax,eax
.end_free: ;// damaged item? stolen item by other thread?
    %ifdef ErrHalt ;// this should not happen!
    jmp short $ ;// halt
    %endif ;ErrHalt
  xor  edx,edx
  lock cmpxchg [ecx],edx ;// if there is still this pointer, it is invalid... otherwise it was used...
  pop  eax
  pop  edx
  pop  esi
  cmp  eax,[ebx+owp_Free] ;// if owp_Free changed, it was allocated - retry, if still same, then no such free...
  je   short .go_new
  jmp  short .find_free
  ;//
.need_commit:
  push esi
  push edx
  mov  esi,[ebx+owp_TopPage] ;// top OwPage
.retry_com:
.this_page:
  mov  eax,[esi+owpg_CEnd]
  cmp  eax,[esi+owpg_VEnd]
  jae  .need_vpage
  mov  edx,1000h
  push edx
  ;//
  push edx
  push eax
  call MmVCommit
  test eax,eax
  pop  edx ;// 1000h
  jz   .need_vpage
  add  edx,eax
  lock cmpxchg [esi+owpg_CEnd],edx
  jne  .retry_com
  ;// now eax=new commit space, edx=CEnd
.use_space:
  ;//mov  [ebx+owp_CEnd],edx
  ;//mov  [ebx+owp_Cur],eax ;// not thread-safe... not much contention expected...?
  ;// if it's same vpage, keep owp_Cur
  mov  ecx,[ebx+owp_Cur]
  xor  ecx,eax
  shr  ecx,16 ;//and  ecx,-10000h
  jz   .com_ok
  mov  [ebx+owp_Cur],eax
.com_ok:
  mov  [ebx+owp_CEnd],edx
  pop  edx
  pop  esi
  jmp short .go_new
  ;//
.need_vpage:
  ;// add rest of Cur to free-list:
  mov  eax,[ebx+owp_Cur]
  mov  ecx,[ebx+owp_CEnd]
  sub  ecx,byte 10h ;// do not step Cur to next vpage...
  mov  edx,ecx
  sub  ecx,eax
  sub  ecx,byte 10h ;// discard last 16+16 bytes, prevent unstepping Cur in OwFree below...
  cmp  ecx,[ebx+owp_MinSize]
  jl   .no_end_cur
  lock cmpxchg [ebx+owp_Cur],edx ;// alloc from Cur all until almost CEnd
  jne  .no_end_cur
  mov  edx,eax
  mov  eax,ebx
  call OwFree ;// add previous Cur to free-list
.no_end_cur:
  ;// find if there is some page with reserve at the end: (probably never happens?)
.cy_rest_vpage:
  mov  eax,[esi+owpg_CEnd]
  cmp  eax,[esi+owpg_VEnd]
  jb   .this_page
  mov  esi,[esi+owpg_Next]
  test esi,esi
  jnz  .cy_rest_vpage ;//.need_vpage
  ;//
  ;// get new 64k page:
  ;//xor  eax,eax
  mov  eax,[ebx+owp_NextSpace] ;// hint new space address... may get another if that is not free...
  call OwReserve64
  test eax,eax
  jz   .out_of_mem
  call OwCommit2nd ;// returns eax,ecx,edx
  test eax,eax
  jz   .com_failed
  ;// here eax=new space, ecx=VBase, edx=VEnd,  ebx=pool
  mov  esi,eax
  mov  dword [eax],cMmOwPgSign
  mov  [eax+owpg_VBase],ecx
  mov  [eax+owpg_CStart],eax
  mov  [eax+owpg_VEnd],edx
  mov  [ebx+owp_NextSpace],edx
  mov  [eax+owpg_Pool],ebx
  lea  edx,[eax+1000h]
  mov  [eax+owpg_CEnd],edx
.retry_link:
  mov  eax,[ebx+owp_TopPage]
  mov  [esi+owpg_Next],eax
  lock cmpxchg [ebx+owp_TopPage],esi
  jne  .retry_link
  lea  eax,[esi+owpg__sizeOf] ;// eax=new space, edx=CEnd
  jmp  near .use_space
.com_failed:
  mov  eax,ecx
  call MmVRelease
.out_of_mem:
    %ifdef ErrHalt
    jmp short $ ;// halt
    %endif ;ErrHalt
  pop  edx
  pop  esi
  ;//jmp near .fail
.fail2:
  xor  eax,eax
  pop  ebx
  ret

;// function OwShutdown(OwPool)
OwShutdown:
  test eax,eax
  jz   .out
  cmp  dword [eax],cMmOwPoolSign
  jne  .out
  xor  edx,edx
  push edx
  push edx
  mov  eax,[eax+owp_TopPage]
  jmp short .cy1in
.cy1:
  mov  [eax],edx ;// clear owpg_Signature
  mov  edx,[eax+owpg_VBase]
  mov  ecx,[eax+owpg_CEnd]
  sub  ecx,edx
  push ecx
  push edx
  xor  edx,edx
  mov  eax,[eax+owpg_Next]
.cy1in:
  test eax,eax
  jz   .cy1break
  cmp  dword [eax],cMmOwPgSign
  je   .cy1
.cy1break:
.cy2:
  pop  eax
  pop  edx
  test eax,eax
  jz   .cy2break
  call MmVDecomRelease
  jmp short .cy2
.cy2break:
.out:
  ;//xor  eax,eax
  ret

;//--------------------------------------------------------------------
%ifdef HugeVPool

;// function MmCreateHugeVPool(MPool) - returns ^TMmVirtPager
MmCreateHugeVPool:
  push  ebx
  push  edi
  mov   ebx,eax   ;// MPool
  push  byte hvp__sizeOf
  pop   edx
  call  [eax+mpool_AllocProc]
  test  eax,eax
  mov   edi,eax
  jz    .out
  mov   dword [edi],cMmHugeVPoolSign
  mov   [edi+hvp_MPool],ebx
  lea   eax,[ebx+mpool_MidLock]
  mov   [edi+hvp_Lock],eax
  xor   eax,eax
  mov   [edi+hvp_BlockList],eax
  mov   [edi+hvp_BlockCount],eax
  mov   [edi+hvp_BlockCapa],eax
  mov   [edi+hvp_VirtPager+vp_ReInit],eax
  ;// build VirtPager vmt:
  call  MmGetHvpVmt_edx
  lea   eax,[edi+hvp_VirtPager]
  mov   [eax+vp_Arg],edi
  call  MmExpandVmt
.out:
  pop   edi
  pop   ebx

MmGetHvpVmt_edx: ;// returns PackedVmt for HugeVPool in EDX
  call retpop_Edx
.hvp_vmt:
  dw (MmHugeVPoolAlloc-$),    vp_AllocRawPage
  dw (MmHugeVPoolFree-$),     vp_ReleaseRawPage
  dw (MmHugeVPoolShutdown-$), vp_Shutdown
  dd 0

align 4
;// function MmHugeVPoolAlloc(VPool,Size): Pointer
MmHugeVPoolAlloc:
  push ebp
  mov  ebp,esp
  push ebx
  push edi
  push esi    ;// [ebp-12..0] = saved registers...
  push eax    ;// [ebp-16]=VPool
  mov  ebx,eax
  xor  eax,eax
  test edx,edx
  jle  .out
  add  edx,0FFFh
  and  edx,-1000h
  push edx    ;// [ebp-20]=Size
  push eax    ;// [ebp-24]=Ptr = NULL
  ;//
  add  edx,0FFFFh
  and  edx,-10000h
  mov  edi,edx
  ;//
  push edx
  push eax ;//byte 0
  call MmVReserve
  test eax,eax
  mov  [ebp-24],eax
  jz   .out_of_address
  ;//
  push dword [ebp-20]
  push eax
  call MmVCommit
  test eax,eax
  jz   .commit_failed
  ;//
  lea  edx,[ebp-24]  ;// ^ Ptr,Size,VPool
  mov  eax,[ebx+hvp_MPool]
  xor  ecx,ecx
  call .go_try
  ;//
  test eax,eax
  jz   .out
  ;//
  add  [ebx+hvp_TotalReserve],edi
  mov  ecx,[ebp-20]
  add  [ebx+hvp_TotalCommit],ecx
  ;//
.out_of_address:
.out:
      ;// Well, this happens, when nearly out of address space and Palemoon tries to show a large image:
      ;//%ifdef ErrHalt
      ;//test eax,eax
      ;//jz   .out_of_address
      ;//%endif ;ErrHalt
  lea  esp,[ebp-12]
  pop  esi
  pop  edi
  pop  ebx
  pop  ebp
  ret
  ;//
.commit_failed:
  mov  eax,[ebp-24]
  call MmVRelease
  xor  eax,eax
  jmp short .out
  ;//
.grow_list:
  add  ecx,ecx
  or   ecx,byte 4
  push ecx ;// new Capa
  shl  ecx,3
  lea  edx,[ebx+hvp_BlockList]
  mov  eax,[ebx+hvp_MPool]
  call MmReAlloc
  pop  ecx
  test al,al
  jz   .grow_failed
  mov  [ebx+hvp_BlockCapa],ecx
  mov  ecx,[ebx+hvp_BlockCount]
  mov  edx,[esp]
  mov  edx,[edx] ;// Ptr
  jmp  short .capa_ok
.grow_failed:
  mov  eax,[esp]
    ;//push MEM_DECOMMIT
    ;//push dword [eax+4]
    ;//push dword [eax]
    ;//call VirtualFree
    ;//mov  eax,[esp]
    ;//mov  eax,[eax]
    ;//call MmVRelease
  mov  edx,[eax+4]
  mov  eax,[eax]
      %ifdef LogAlloc
      pushad
      push byte 0
      push edx
      push eax
      push 'HE! '
      push byte 16
      call LogWrite
      popad
      %endif ;LogAlloc
  call MmVDecomRelease
  ;//
  xor  eax,eax
  jmp  short .leave_try
  ;//
.go_try:
  call MmMiddle_GrowShrink
.in_try_locked: ;// eax = ^ Ptr,Size,VPool , returns Ptr
  push ebx
  push edi
  push esi
  push eax  ;// [esp] = ^ Ptr,Size,VPool
  mov  ebx,[eax+8] ;// VPool
  mov  edx,[eax]   ;// Ptr
  ;//
  mov  ecx,[ebx+hvp_BlockCount]
  cmp  ecx,[ebx+hvp_BlockCapa]
  jae  .grow_list
.capa_ok:
  mov  edi,[ebx+hvp_BlockList]
  xor  esi,esi    ;// l:=0
  sub  ecx,byte 1 ;// h:=Count-1
  jl   .append
  cmp  edx,[edi+8*ecx]
  ja   .append
  ;// sorted find:
.socy:
  lea  eax,[esi+ecx]
  shr  eax,1
  cmp  edx,[edi+8*eax]
  jb   .below
  lea  esi,[eax+1]
.sonext:
  cmp  esi,ecx
  jle  .socy
.insert:
  mov  eax,esi ;// Index:=l
  mov  ecx,[ebx+hvp_BlockCount]
  lea  esi,[edi+8*ecx-4]
  sub  ecx,eax ;// Count-Index
  jle  .append
  lea  edi,[esi+8]
  add  ecx,ecx
  std
  rep  movsd
  cld
  mov  edi,[ebx+hvp_BlockList]
  mov  ecx,eax
  jmp  short .put
.below:
  lea  ecx,[eax-1]
  jmp  short .sonext
.append:
  mov  ecx,[ebx+hvp_BlockCount]
.put:
  mov  [edi+8*ecx],edx
  mov  eax,edx     ;// Result
  mov  edx,[esp]
  mov  edx,[edx+4] ;// Size
  mov  [edi+8*ecx+4],edx
  inc  dword [ebx+hvp_BlockCount]
      %ifdef LogAlloc
      pushad
      push byte 0
      push edx
      push eax
      push 'Ha: '
      push byte 16
      call LogWrite
      popad
      %endif ;LogAlloc
.leave_try:
  pop  edx
  pop  esi
  pop  edi
  pop  ebx
  ret

;// function MmHugeVPoolFree(VPool,Ptr): Boolean
MmHugeVPoolFree:
  push ebp
  mov  ebp,esp
  mov  ecx,edx ;// Ptr
  mov  edx,eax ;// VPool
  mov  eax,[eax+hvp_MPool]
  call .go_try
  mov  esp,ebp
  pop  ebp
  ret
  ;//
.go_try:
  call MmMiddle_GrowShrink
.in_try_locked: ;// eax = VPool, edx=Ptr, returns Boolean
  push ebx
  push edi
  push esi
  mov  ebx,eax ;// VPool
  ;// find in list:
  xor  esi,esi  ;// l:=0
  mov  ecx,[ebx+hvp_BlockCount]
  mov  edi,[ebx+hvp_BlockList]
  dec  ecx ;// h:=Count-1
  jmp  short .sonext
.socy:
  lea  eax,[esi+ecx]
  shr  eax,1
  cmp  edx,[edi+8*eax]
  jbe  .below
  lea  esi,[eax+1]
.sonext:
  cmp  esi,ecx
  jle  .socy
.not_found:
  xor  eax,eax
  jmp  short .out
.below:
  jz   .found
  lea  ecx,[eax-1]
  jmp  short .sonext
.found:
  mov  esi,eax  ;// index
  mov  ecx,[edi+8*eax+4]
  sub  [ebx+hvp_TotalCommit],ecx
  lea  eax,[ecx+0FFFFh]
  and  eax,-10000h
  sub  [ebx+hvp_TotalReserve],eax
  ;//
        ;//push MEM_RELEASE
        ;//push byte 0
        ;//push edx
        ;//push MEM_DECOMMIT
        ;//push ecx
        ;//push edx
        ;//call VirtualFree
        ;//call VirtualFree
      %ifdef LogAlloc
      pushad
      push byte 0
      push ecx
      push edx
      push 'Hf: '
      push byte 16
      call LogWrite
      popad
      %endif ;LogAlloc
  mov  eax,edx
  mov  edx,ecx
  call MmVDecomRelease
  ;//
  ;// delete from list:
  mov  ecx,[ebx+hvp_BlockCount]
  sub  ecx,esi ;// Count-Index
  lea  esi,[edi+8*esi+8]
  lea  edi,[esi-8]
  add  ecx,ecx
  jle  .skip_move
  cld
  rep  movsd
.skip_move:
  ;//dec  dword [ebx+hvp_BlockCount]
  mov  ecx,[ebx+hvp_BlockCount]
  mov  edi,[ebx+hvp_BlockList]
  xor  eax,eax
  mov  [edi+8*ecx],eax
  mov  [edi+8*ecx+4],eax
  dec  ecx
  mov  [ebx+hvp_BlockCount],ecx
  ;//
  mov  al,1
.out:
  pop  esi
  pop  edi
  pop  ebx
  ret

;// function MmHugeVPoolShutdown(VPool,MPool): Boolean
MmHugeVPoolShutdown:
  push ebp
  mov  ebp,esp
  cmp  edx,[eax+hvp_MPool]
  jne  .invalid
  mov  edx,[eax+hvp_BlockList]
  xor  ecx,ecx
  xchg [eax+hvp_BlockCount],ecx
  test ecx,ecx
  jle  .done
  ;//
  xor  eax,eax
  push eax
  push eax  ;// terminator
  ;//
.cy1:
  cmp  dword [edx],byte 0
  jz   .skip1
  push dword [edx+4]   ;// size
  push dword [edx]     ;// ptr
.skip1:
  add  edx,byte 8
  dec  ecx
  jnz  .cy1
  ;//
.cy2:
  pop  eax  ;// ptr
  pop  edx  ;// size
  test eax,eax
  jz   .done
  ;//
        ;//push MEM_RELEASE
        ;//push byte 0
        ;//push eax
        ;//push MEM_DECOMMIT
        ;//push edx
        ;//push eax
        ;//call VirtualFree
        ;//call VirtualFree
  call MmVDecomRelease
  ;//
  jmp short .cy2
  ;//
.invalid:
  xor  eax,eax
  jmp short .out
.done:
  mov  al,1
.out:
  mov  esp,ebp
  pop  ebp
  ret

%define EXP_VMT
%endif ;HugeVPool

;//----------------------------------------------------------------
%ifdef ArenaPool
;//function MmA8k_CreatePool(Lock): TMmVirtPager vmt inside TMmArena8kPool
MmA8k_CreatePool:
  push ebx
  push eax          ;// [esp] = Lock
  ;//
  mov  eax,def_ArenaPoolBase
  push byte m8x__sizeOf
  pop  edx
  call OwCreate
  ;//
  mov  ebx,eax
  mov  edx,(m8k__sizeOf+31) & -20h  ;// now 128...
  ;//
  cmp  dword [esp],byte 0
  jnz  .size1Ok
  add  edx,byte 20h ;//18h = SizeOf(TRtlCriticalSection)
  ;//
.size1Ok:
  call OwAlloc0
  ;//
  mov  dword [eax+m8k_Signature],cMmA8kSign
  mov  [eax+m8k_OwPool],ebx
  mov  ebx,eax
  ;//
  ;// take Lock, clear from stack...
  xor  edx,edx
  pop  eax
  push edx
  ;//
  mov  [ebx+m8k_Lock],eax
  test eax,eax
  jnz  .lock_ok
  lea  eax,[ebx+m8k__sizeOf]
  mov  [ebx+m8k_Lock],eax
  push eax
  call InitializeCriticalSection
.lock_ok:
  ;//
  ;// MmInitializeListHead inline:
  lea  eax,[ebx+m8k_SpaceList]
  mov  [eax],eax
  mov  [eax+4],eax
  ;//
  lea  eax,[ebx+m8k_Vmt]
  mov  [eax+vp_Arg],ebx
  call .pushed_Vmt
    dw (MmA8k_Alloc8k-$),     vp_AllocRawPage
    dw (MmA8k_Free8k-$),      vp_ReleaseRawPage
    dw (MmA8k_DestroyPool-$), vp_Shutdown
    dd 0
.pushed_Vmt:
  pop  edx
  call MmExpandVmt
  ;//lea  eax,[ebx+m8k_Vmt] ;// return TMmVirtPager vmt... -- already from MmExpandVmt above...
  ;//
  pop  edx
  pop  ebx
  ret

;// function MmA8k_DestroyPool(A8kPool,Lock)
MmA8k_DestroyPool:
  cmp  [eax+m8k_Lock],edx
  jne  .invalid
  push ebx
  push edi
  mov  ebx,eax
  ;// free spaces:
  lea  ecx,[eax+m8k_SpaceList]
  mov  eax,ecx
.spcy:
  mov  edi,[eax]
  test edi,edi
  jz   .spbreak
  cmp  edi,ecx
  jz   .spbreak
  cmp  [edi+4],eax
  jne  .spbreak
  ;//cmp  word [edi+m8x_wSign],cM8xSign
  ;//jne  .spbreak
  ;//
  xor  eax,eax
  lock xchg [edi+m8x_Base],eax
  call MmVRelease
  ;//
  mov  eax,edi ;//lea  eax,[edi+m8x_Entry]
  lea  ecx,[ebx+m8k_SpaceList]
  jmp  short .spcy
.spbreak:
  ;// free descriptors:
  mov  eax,[ebx+m8k_OwPool]
  call OwShutdown
.done:
  pop  edi
  pop  ebx
.invalid:
  ret

;// function MmA8k_Alloc8k(A8kPool,Size): Pointer;
MmA8k_Alloc8k:
  push ebx
  push edi
  mov  ebx,eax
  ;//
  xor  eax,eax
  cmp  edx,8192
  ja   .done
  ;// allocating 8kb arena... outer pool already locked in MmAllocPageAligned...
  jmp  short .try_cache
  ;//
.invalid_count:
  jnl  .try_cache
  ;// can there be negative count?! would not cycle 4G to get to a valid number...
  xor  edx,edx
  cmpxchg [ebx+m8k_CacheCount],edx
  ;// try allocating from Cache
.try_cache:
  xor  eax,eax
  cmp  [ebx+m8k_CacheCount],eax
  jle  .no_cache
  dec  eax
  lock xadd [ebx+m8k_CacheCount],eax ;// take former Count, decrement it
  dec  eax ;// Index=Count-1
  cmp  eax,byte m8k_CacheCapa
  jae  .invalid_count ;//.try_cache
  xor  edx,edx
  lock xchg [ebx+m8k_CacheList+4*eax],edx
  test edx,edx
  jz   .try_cache
  mov  eax,edx
  ;// done...
.done:
  ;//;// dbg check?
  ;//test eax,1fffh
  ;//jnz .done
  pop  edi
  pop  ebx
  ret
  ;//
.no_cache:
  ;//
  lea  ecx,[ebx+m8k_SpaceList]
  mov  eax,ecx
.fcy:
  mov  edi,[eax]
  cmp  edi,ecx
  je   .fbreak
  test edi,edi
  jle  .fListBad
  cmp  [edi+4],eax
  jne  .fListBad
  cmp  word [edi+m8x_wSign],cM8xSign
  jne  .fListBad
  cmp  word [edi+m8x_FreeArenaCount],byte 0
  jle  .fnext
  ;// try allocating from this space:
.this_space:
  call .alloc_from_space_edi
  test eax,eax
  jnz  .done
  lea  ecx,[ebx+m8k_SpaceList]
.fnext:
  mov  eax,edi ;// entry at start
  jmp  short .fcy
  ;//
.fListBad:
  mov  eax,ebx
  call MmA8k_RepairList
  jmp  short .no_cache ;// retry...
.fbreak:
  ;// need a new space:
  push byte m8x__sizeOf
  pop  edx
  mov  eax,[ebx+m8k_OwPool]
  call OwAlloc0
  mov  edi,eax
  mov  word [eax+m8x_wSign],cM8xSign
  ;//
  mov  eax,def_ArenaPoolSize
  mov  [edi+m8x_Capacity],eax
  ;//
  push eax
  push byte 0
  call MmVReserve
  ;//
  test eax,eax
  jz   .out_of_mem
  ;//
  mov  [edi+m8x_Base],eax
  mov  eax,[edi+m8x_Capacity]
  add  dword [ebx+m8k_TotalReserve],eax
  shr  eax,13
  ;//mov  ax,(def_ArenaPoolSize/8192)
  mov  word [edi+m8x_ArenaCount],ax
  mov  word [edi+m8x_FreeArenaCount],ax
  ;//
  mov  edx,edi ;// entry at start
  lea  eax,[ebx+m8k_SpaceList]
  call MmInsertTailList
  ;//
  jmp  short .this_space
  ;//
.out_of_mem:
  mov  eax,[ebx+m8k_OwPool]
  mov  edx,edi
  push byte m8x__sizeOf
  pop  ecx
  call OwFree
  ;//
  mov  edx,8192
  xor  eax,eax
  call MmOutOfMemoryError
  ;//jmp  near .done
.done2:
  pop  edi
  pop  ebx
  ret
  ;//
.alloc_from_space_edi: ;// edi=TMmArena8kSpace
  ;// find free bit:
.retry:
.commit_failed:
  mov  eax,edi
  movzx edx,word [eax+m8x_wMinFree]
  dec  edx
.as_cy:
  inc  edx
  cmp  dx,[eax+m8x_ArenaCount]
  jae  .as_break
  bt   [eax+m8x_Bitmap],edx
  jc  .as_cy
  ;// allocate bit:
  lock bts [eax+m8x_Bitmap],edx
  jc   .as_cy ;// stolen?
  ;// update wMinFree:
  inc  edx
  mov  [eax+m8x_wMinFree],dx
  dec  edx
  ;// update FreePageCount
  dec  word [eax+m8x_FreeArenaCount]
  ;// done...
  shl  edx,13
  add  edx,[eax+m8x_Base]
  ;// commit:
  push edx ;// Result
  ;//
  mov  eax,8192
  push eax ;// Size
  ;//
  push eax
  push edx
  call MmVCommit
  test eax,eax
  ;//
  pop  edx ;// Size
  pop  eax ;// Result
  jz   .commit_failed
  ;//
  add  dword [ebx+m8k_TotalCommit],edx ;// 8192
  ;//
  ret
  ;//
.as_break:
  xor  eax,eax
  ret

;// function MmA8k_Free8k(A8kPool,Ptr): Boolean
MmA8k_Free8k:
  ;// item to free must be 8k-aligned...
  test edx,1fffh
  jnz  .invalid
  ;//
  push ebx
  push edi
  push esi
  ;//
  mov  ebx,eax ;// A8kPool
  mov  edi,edx ;// Ptr
  ;//
  ;// if the cache is full, drop all cached arenas...
  cmp  dword [ebx+m8k_CacheCount],byte m8k_CacheCapa
  jae  .drop_cache
  ;// will add this to cache...
  mov  eax,edi
  call Clear8k
  ;// allocate index:
.retry_cache:
  push byte 1
  pop  edx
  lock xadd [ebx+m8k_CacheCount],edx
  cmp  edx,byte m8k_CacheCapa
  jae  .undo_add
  ;//
  xor  eax,eax
  lock cmpxchg [ebx+m8k_CacheList+4*edx],edi
  jnz  .retry_cache
  ;//
.done:
  mov  al,1
  pop  esi
  pop  edi
  pop  ebx
  ret
  ;//
.invalid:
  mov  eax,edx
  call Dbg_BadPtr
  xor  eax,eax
  ret
  ;//
.undo_add:
  ;//or   edx,byte -1
  ;//lock xadd [ebx+m8k_CacheCount],edx
.drop_cache:
  ;// when too much cached, drop all:
  xor  eax,eax
  mov  [ebx+m8k_CacheCount],eax
.drop_cy:
  xor  edx,edx
  lock xchg [ebx+m8k_CacheList+4*eax],edx
  inc  eax
  test edx,edx
  jz   .drop_next
  push eax ;//mov  esi,eax
  call .free_arena_edx
  pop  eax ;//mov  eax,esi
.drop_next:
  cmp  eax,byte m8k_CacheCapa
  jb   .drop_cy
  ;// also free this arena:
  mov  edx,edi
  call .free_arena_edx
  ;//
  jmp  short .done
  ;//
.free_arena_edx: ;// in ebx=A8kPool, edx=Ptr, uses esi
  ;// find space:
  lea  ecx,[ebx+m8k_SpaceList]
  mov  eax,ecx
.frcy:
  mov  esi,[eax] ;// Space
  cmp  esi,ecx
  je   .frbreak
  test esi,esi
  jle  .frListBad
  cmp  [esi+4],eax
  jne  .frListBad
  cmp  word [esi+m8x_wSign],cM8xSign
  jne  .frListBad
  mov  eax,edx
  sub  eax,[esi+m8x_Base]
  cmp  eax,[esi+m8x_Capacity] ;//cmp  eax,def_ArenaPoolSize
  jb   .frfound
  mov  eax,esi ;// Entry at start
  jmp  short .frcy
  ;//
.frListBad:
  push edx
  mov  eax,ebx
  call MmA8k_RepairList
  pop  edx
  jmp  short .free_arena_edx
.frbreak:
  mov  eax,edx
  call Dbg_BadPtr
  ret
  ;//
.frfound:
  shr  eax,13 ;// bit-index...
  lock btr [esi+m8x_Bitmap],eax
  jnc  .frout ;// was not allocated?
.frrelease:
  inc  word [esi+m8x_FreeArenaCount]
  cmp  ax,[esi+m8x_wMinFree]
  ja   .no_move_wmf
  mov  [esi+m8x_wMinFree],ax
.no_move_wmf:
  shl  eax,13
  add  eax,[esi+m8x_Base]
  ;// VirtualFree(Ptr,8192,MEM_DECOMMIT)
  push MEM_DECOMMIT
  mov  edx,8192
  push edx
  sub  [ebx+m8k_TotalCommit],edx
  push eax
  call VirtualFree
  ;//
  mov  ax,[esi+m8x_FreeArenaCount]
  cmp  ax,[esi+m8x_ArenaCount]
  jae  .drop_space
  ;//
.frout:
  ret ;// ret from free_arena_edx
  ;//
.drop_space: ;// ebx=TMmArena8kPool, esi=TMmArena8kSpace, should be all free...
  push edi
  movzx ecx,word [esi+m8x_ArenaCount]
  shr  ecx,3
  lea  edi,[esi+m8x_Bitmap]
  xor  eax,eax
  repe scasb
  pop  edi
  jne  .space_not_empty
  ;//
  cmp  word [esi+m8x_wSign],cM8xSign
  jne  .drop_invalid2
  ;//
  mov  eax,esi ;// Entry at start...
  call MmRemoveEntryListAndClear
  test eax,eax
  jz   .drop_invalid2
  ;//
  xor  eax,eax
  mov  [esi+m8x_wSign],ax
  lock xchg [esi+m8x_Base],eax
  ;//
  mov  edx,[esi+m8x_Capacity] ;//def_ArenaPoolSize
  sub  [ebx+m8k_TotalReserve],edx
  call MmVDecomRelease
  ;//
  mov  edx,esi
  mov  eax,[ebx+m8k_OwPool]
  push byte m8x__sizeOf
  pop  ecx
  call OwFree
  ;//
  ret ;// ret from free_arena_edx
.space_not_empty:
  ;// update FreeArenaCount instead...
  xor  ecx,ecx
  xor  edx,edx
  xor  eax,eax
.upd_cy:
  bt   [esi+m8x_Bitmap],eax
  adc  ecx,edx
  inc  eax
  cmp  ax,[esi+m8x_ArenaCount]
  jb   .upd_cy
  cmp  word [esi+m8x_wSign],cM8xSign
  jne  .drop_invalid2
  mov  [esi+m8x_FreeArenaCount],cx
.drop_invalid2:
  ret ;// ret from free_arena_edx

;// function Clear8k(Ptr): Pointer -- clear 8kb
Clear8k:
  mov  edx,eax
  pxor xmm0,xmm0
  push byte 8192/128  ;// = 64
  pop  ecx
.c8k_cy:
  movaps [edx],xmm0
  movaps [edx+16],xmm0
  movaps [edx+2*16],xmm0
  movaps [edx+3*16],xmm0
  movaps [edx+4*16],xmm0
  movaps [edx+5*16],xmm0
  movaps [edx+6*16],xmm0
  movaps [edx+7*16],xmm0
  add   edx,128
  dec   ecx
  jnz   .c8k_cy
  ret

;// function MmA8k_RepairList(A8kPool)
;// in case the list is damaged, every item would allocate new space, append space at end of broken list, and never free it...
MmA8k_RepairList:
  ;//cmp  dword [eax+m8k_Signature],cMmA8kSign
  ;//jne  .invalid
  call .pushed_CheckFunc
.CheckFunc: ;// in eax=TMmArena8kSpace, out al=1 if valid...
  cmp  word [eax+m8x_wSign],cM8xSign
  sete al
  ret
.pushed_CheckFunc:
  add  eax,byte m8k_SpaceList
  call MmRepairEntryList
.invalid:
  ret
;//

;// function MmRepairEntryList(eax=Base, [esp+4]=[ebp+8]=CheckFunc)
MmRepairEntryList:
  push ebp
  mov  ebp,esp
  push ebx
  push edi
  push esi
  mov  ebx,eax ;// Base
  ;//mov  eax,ebx ;// Prev
  xor  esi,esi ;// last valid item
  ;//
  cmp  [ebx],ebx
  jne  .check_list
  ;// list is empty...
  mov  [ebx+4],ebx
  jmp  short .fdone
.check_list:
  ;//
  push esi ;//push byte 0  ;// [ebp-16] list top, [ebp-20] first item
  ;//
.fcy:
  mov  edi,[eax] ;// Item
  cmp  edi,ebx
  je   .fdone
  ;//%ifndef AllocTag ;//x: needed here also!
  ;//  cmp  edi,10000h ;//test edi,edi
  ;//  jle  .invalid
  ;//%else ;//safe
    push eax
    mov  eax,edi
    call MmIsBadWrite
    test eax,eax
    pop  eax
    jnz  .invalid
  ;//%endif ;//safe
  ;//
  cmp  [edi+4],eax
  jne  .blink_bad
  ;//
  mov  eax,edi
  call dword [ebp+8]
  test al,al
  jz   .invalid
  ;// valid item...
.fnext:
  push edi
  mov  esi,edi
  ;//
  mov  eax,edi
  jmp  short .fcy
  ;//
.blink_bad: ;// item in edi.blink does not point to previous eax,esi -- possible circular link, or blink damaged...
  mov  eax,edi
  mov  edi,esp ;// list of previous items...
  lea  ecx,[ebp-16]
  sub  ecx,edi
  shr  ecx,2 ;// count of items on stack
  repne scasd
  mov  edi,eax
  je   .circular
  ;//
  ;//mov eax,edi
  call dword [ebp+8]
  test al,al
  jz   .invalid
  ;// item is valid, just blink is bad...
  mov  [edi+4],eax
  jmp  short .fnext
  ;//
.binvalid: ;// item in edi walking back is invalid, eax.blink pointed to that...
  ;// reconnect:
  mov  [esi],eax
  mov  [eax+4],esi
  ;//
.bdone:
.fdone:
  lea  esp,[ebp-12]
  pop  esi
  pop  edi
  pop  ebx
  pop  ebp
  retn 4
  ;//
.circular:
.invalid: ;// item in edi is not valid, item in eax~esi points to that...
  test esi,esi
  jz   .first_invalid
  xor  eax,eax
  mov  [esi],eax
.first_invalid:
  ;// walk chain back from end:
  mov  eax,ebx
.bcy:
  mov  edi,[eax+4]
  ;//%ifndef AllocTag ;//x: need here also!
  ;//  cmp  edi,10000h ;//test edi,edi
  ;//  jle  .binvalid
  ;//%else ;//safe
    push eax
    mov  eax,edi
    call MmIsBadWrite
    test eax,eax
    pop  eax
    jnz  .binvalid
  ;//%endif ;//safe
  ;//
  cmp  [edi],eax
  jne  .bflink_bad
  cmp  edi,ebx
  je   .bdone ;// not probable, that back-link leads to base, verifying flinks...
  ;//
.bcheck:
  mov  eax,edi
  call dword [ebp+8]
  test al,al
  jz   .binvalid
  ;//
  mov  eax,edi
  jmp  short .bcy
  ;//
.bflink_bad:
  cmp  esi,edi
  jne  .binvalid
  ;// reconnect...
  mov  [edi],eax
  jmp  short .bcheck
  ;//

;// function OwAlloc0(OwPool,Size) -- zero-init...
OwAlloc0:
  push edi
  push edx
  call OwAlloc
  test eax,eax
  pop  ecx
  jz   .skip_clear
  mov  edi,eax
  mov  edx,eax
  shr  ecx,2
  xor  eax,eax
  rep  stosd
  mov  eax,edx
.skip_clear:
  pop  edi
  ret

%define EXP_VMT
%endif ;ArenaPool
;//----------------------------------------------------------------

%ifdef EXP_VMT
;// function MmExpandVmt(Where,PackedVmt): Where
;// packed vmt is array(offsCode,offsVmt: Word), terminated by offsCode=0
MmExpandVmt:
  push  edi
.cy:
  mov   ecx,[edx]
  test  cx,cx
  jz    .break
  movzx edi,cx
  shr   ecx,16
  add   edi,edx     ;// Code
  add   edx,byte 4
  mov   [eax+ecx],edi
  jmp   short .cy
.break:
  pop   edi
  ret

%endif ;EXP_VMT

;// function MmClearStack(Ptr): Pointer -- clear some dwords below stack, returns EAX, uses ECX
MmClearStack:
  push ebp
  mov  ebp,esp
  push byte 12
  pop  ecx
.cy1r:
  push ecx
  dec  ecx
  jnz  .cy1r
  mov  esp,ebp
  pop  ebp
  push ecx
  pop  ecx
  ret

;//--------------------------------------------------------------------
%ifdef MINIMM_PAGEALIGNED

;//align 4
;// function MmAllocPageAligned(Pool,Size): Pointer
MmAllocPageAligned:
  ;// try-entrance is fixed for MmTry_Bailout (just ebx above ebp)
  push ebx
  push ebp
  mov  ebp,esp
  ;//
  ;// Pool and Size already checked...
  mov  ebx,eax
  xor  ecx,ecx
  push edx ;// [ebp-4]=Size
  push ecx ;//push byte 0  ;// [ebp-8]=Result
  push edi ;// [ebp-12]=SaveEdi
  push esi ;// [ebp-16]=SaveEsi
  push ecx ;// [ebp-20]=VPool
  ;//
  call edxoffs_MmAllocAligned_Bailout ;//mov  edx,offset MmAllocAligned_Bailout
  xor  ecx,ecx
  call MmPoolMidLock_Try
  ;//
  %ifndef HugeVPool  ;//zmena240221 - different VPools... here old simple way...
      ;// Original:
      ;// Result:=Pool.VirtPool.AllocRawPage(Pool.VirtPool.Arg,Size);
      mov  eax,[ebx+mpool_VirtPool+vp_Arg] ;//mov  eax,[ebx].TMmPool.VirtPool.Arg
      mov  edx,[ebp-4]
      call dword [ebx+mpool_VirtPool+vp_AllocRawPage] ;//call [ebx].TMmPool.VirtPool.AllocRawPage
      
  %else ;HugeVPool ;//New240221
  
    mov  edx,[ebp-4]
    ;//New240314 - page-aligned size...
    add  edx,0FFFh
    and  edx,-1000h
      ;//
      %ifdef ArenaPool ;//New240314
      cmp  edx,8192
      jne  .not_a8k
      mov  eax,[ebx+mpool_Arena8kPool]
      test eax,eax
      jnz  .use_vpool
    .not_a8k:
      %endif ;ArenaPool
      ;//
    ;//
    cmp  edx,cMinHugeSize
    jae  .huge_vpool
    lea  eax,[ebx+mpool_VirtPool]
    jmp short .use_vpool
  .huge_vpool:
    mov  eax,[ebx+mpool_HugeVPool]
  .use_vpool:
    mov  [ebp-20],eax
    mov  ecx,eax
    mov  eax,[eax+vp_Arg]
    call dword [ecx] ;//[ecx+vp_AllocRawPage]
  %endif
  ;// if Result=nil then exit;
  test eax,eax
  mov  [ebp-8],eax
  jz   .fail1
  ;//
    %ifdef LogAlloc
    push byte 0
    push dword [ebp-4]
    push eax
    push 'Aa:'
    push byte 16
    call LogWrite
    %endif ;LogAlloc
  ;//
    ;//
    ;//New240304 - put to PageMap:
    mov  eax,[ebx+mpool_AlignedMap]
    mov  edx,[ebp-8]
    call PgMapPut
    test eax,eax
    jz   .pgmap_error ;// we know the pointer is new, and if PageMap thinks otherwise, then PageMap was wrong... should not happen...
    ;// fill ma_ desc:
  .pgmap_fill:
    mov  ecx,[ebp-8] ;// Ptr
    mov  edx,[ebp-4] ;// Size
    mov  [eax],ecx  ;// ma_Mem
    mov  [eax+ma_Size],edx
    mov  edx,[ebp-20] ;// VPool or nil without HugeVPool defined
    mov  [eax+ma_VPool],edx
    %ifdef AllocTag
      push eax
      call MmGetAllocTag
      pop  edx
      mov  [edx+ma_ATag],eax
    %else ;//!AllocTag
      and  dword [eax+ma_ATag],byte 0
    %endif ;//!AllocTag
    ;//
    jmp short .pgmap_ok
    ;//
  .pgmap_error:
    ;// here ^slot in edx
        %ifdef ErrHalt
        jmp short $
        %endif ;ErrHalt
    mov  eax,[edx]
    test eax,eax
    jnz  .pgmap_fill
  .pgmap_ok:
  ;//
  ;// inc(Count);
  inc  dword [ebx+mpool_AlignedCount] ;//inc  [ebx].TMmPool.AlignedCount
  ;//
.fail1:
.out1:
  lea  eax,[ebx+mpool_MidLock] ;//lea  eax,[ebx].TMmPool.MidLock
  push eax
  call LeaveCriticalSection
  ;//
  xor  edx,edx
  db 64h,8bh,22h ;//mov  esp,fs:[edx]
  db 64h,8Fh,02h ;//pop  dword ptr fs:[edx]
  ;//
  %ifdef AllocTag
  pxor xmm7,xmm7
  %endif ;AllocTag
  ;//
  lea  esp,[ebp-16]
  pop  esi
  pop  edi
  pop  eax ;// result at [ebp-8]
  pop  edx
  pop  ebp
  pop  ebx
  call MmClearStack
  ret

;// function MmAllocAligned_Bailout(ExcFrame)
edxoffs_MmAllocAligned_Bailout:
  call retpop_Edx
MmAllocAligned_Bailout:
  ;// exception handler for MmAllocPageAligned
  %ifdef Halt_Except
    jmp short $ ;//halt
  %endif
  push eax
  ;//
  ;// Free Result:
  xor  edx,edx
  xchg [ebp-8],edx
  test edx,edx
  jz   .no_res
  test edx,0FFFh
  jnz  .no_res
  ;//x240221: mov  ecx,[ebp-4]
  %ifndef HugeVPool
      ;// Original:
      mov  eax,[ebx+mpool_VirtPool+vp_Arg] ;//mov  eax,[ebx].TMmPool.VirtPool.Arg
      call dword [ebx+mpool_VirtPool+vp_ReleaseRawPage] ;//call [ebx].TMmPool.VirtPool.ReleaseRawPage
  %else ;HugeVPool //New240221
    mov  ecx,[ebp-20]
    mov  eax,[ecx+vp_Arg]
    call dword [ecx+vp_ReleaseRawPage]
  %endif
  ;//
.no_res:
  pop  eax
  ;//
  jmp  MmAllocMiddle_Bailout

;// function MmFreePageAligned(Pool,Page,Item=Page): Boolean
MmFreePageAligned:
  ;//if (Pool=nil) then Pool:=g_MainMmPool; if (Pool=nil) then return False;
  test eax,eax
  jnz  .have_pool
  ;//mov  eax,[g_MainMmPool]
  push ecx
  call MmGetMainPool
  pop  ecx
  ;//
  test eax,eax
  jz short .no_pool ;//jz  near .no_pool
.have_pool:
  ;//
  push ebx
  push ebp
  mov  ebp,esp
  mov  ebx,eax
  ;//
  push ecx ;// [ebp-4]=Item
  ;//
  call edxoffs_MmAllocMiddle_Bailout ;//mov  edx,offset MmAllocMiddle_Bailout
  xor  ecx,ecx
  call MmPoolMidLock_Try
  ;//
  mov  eax,[ebx+mpool_AlignedMap]
  mov  edx,[ebp-4]
  call PgMapRemove
  test eax,eax
  jz   .unknown_item
  ;// here eax=TMmAlignedDesc
  xor  edx,edx
  xchg [eax],edx ;// [eax+ma_Mem]
  mov  ecx,[eax+ma_Size]
  %ifdef HugeVPool
    push dword [eax+ma_VPool]
  %endif
  push edx
  push ecx
  mov  edx,eax
  mov  eax,[ebx+mpool_AlignedMap]
  call PgMapFreeDesc
  ;//
    %ifdef LogAlloc
    pop  ecx
    pop  edx
    push edx
    push ecx
    ;//
    push byte 0
    push ecx
    push edx
    push 'Fa:'
    push byte 16
    call LogWrite
    ;//
    %endif ;LogAlloc
  ;//
  pop  ecx
  pop  edx
  ;//
  %ifdef HugeVPool
    pop  eax ;// VPool
    push ebx
    mov  ebx,eax
    mov  eax,[eax+vp_Arg]
    call [ebx+vp_ReleaseRawPage]
    pop  ebx
  %else ;!HugeVPool
    mov  eax,[ebx+mpool_VirtPool+vp_Arg]
    call dword [ebx+mpool_VirtPool+vp_ReleaseRawPage]
  %endif ;!HugeVPool
  ;//
  dec  dword [ebx+mpool_AlignedCount]
  mov  al,1
    ;//%ifdef ErrHalt
    ;//  jmp short .done
    ;//.unknown_item:
    ;//  jmp short $ ;// halt on error... --> for ex. freebl3.dll calls free() in middle of some block?!
    ;//%else ;//Release - return NULL/false
  .unknown_item:
    ;//%endif
.done:
  push eax
  lea  eax,[ebx+mpool_MidLock] ;//lea  eax,[ebx].TMmPool.MidLock
  push eax
  call LeaveCriticalSection
  pop  eax
  ;//
  xor  edx,edx
  db 64h,8Bh,22h ;//mov  esp,fs:[edx]
  db 64h,8Fh,02h ;//pop  dword ptr fs:[edx]
  ;//
.out0:
  mov  esp,ebp
  pop  ebp
  pop  ebx
.no_pool:
  call MmClearStack
  ret

;// function MmQueryPageAligned(Pool,Item): Longint
MmQueryPageAligned:
  mov  eax,[eax+mpool_AlignedMap]
  call PgMapGet ;// PgMapGet is thread-safe without locking... app should not free that pointer in one thread while other thread asks its size... it would return 0 here... (with original locking, we could return size which other thread frees before app can use it)
  test eax,eax
  jz   .none
  mov  eax,[eax+ma_Size]
.none:
.out:
  ret

align 4
;// function MmReAllocPageAligned(Pool,var P,NewSize): Boolean
;//                               EAX  [EDX] ECX     ->EAX
MmReAllocPageAligned:
  push ebx
  push byte 0   ;// [esp+8]=OldSize
  ;//
  add  ecx,byte 3
  and  ecx,byte -4
  ;//
  push ecx ;// [esp+4]=NewSize
  push edx ;// [esp]=^P
  mov  ebx,eax
  ;//
  ;//OldSize:=MmQueryPageAligned(Pool,P);
  mov  edx,[edx]
  call MmQueryPageAligned
  mov  [esp+8],eax
  ;// if (OldSize=0) then return False;
  test eax,eax
  jz   .out
    %ifdef LogAlloc
    pushad
    mov edx,[esp+32]
    mov edx,[edx]
    push dword [esp+4+32] ;// NewSize
    push eax ;// OldSize
    push edx ;// Ptr
    push 'RP:'
    push byte 16
    call LogWrite
    popad
    %endif ;LogAlloc
  ;// if (NewSize=0) then MmFree(Extract(P)); return True;
  ;// New:=MmAlloc(Pool,NewSize);
  mov  eax,ebx
  mov  edx,[esp+4]
  test edx,edx
  jz   .free
  call MmAlloc
  ;// if (New=nil) then return False;
  test eax,eax
  jz   .out
  ;// MoveSize:=OldSize;
  mov  ecx,[esp+8]
  ;// if (MoveSize>NewSize) then MoveSize:=NewSize;
  cmp  ecx,[esp+4]
  jb   .size_ok
  mov  ecx,[esp+4]
.size_ok:
  ;// Move(P^,New^,MoveSize);
  mov  edx,[esp]
  push edi
  push esi
  mov  esi,[edx]
  mov  edi,eax
  ;//??? add  ecx,byte 3 -- already above...
  shr  ecx,2
  %ifdef PA_LargeMove  ;// re-allocating page-aligned is rather seldom...
  ;//New240314 - large move... source is page-aligned...
  test al,0Fh
  jnz  .not_aligned
  cmp  ecx,byte 64
  jae  .large_move
.not_aligned:
  %endif ;seldom
  ;//
  cld
  rep  movsd
.after_move:
  pop  esi
  pop  edi
  ;//
  ;// OldP:=P; P:=New; MmFree(nil,P);
  mov  ecx,[esp]
  mov  edx,eax
  xchg [ecx],edx
  xor  eax,eax
  call MmFree
  ;//
  ;//mov  eax,1
  ;//jmp short .out
  jmp short .ok1
  ;//
.free:
  mov  eax,[esp]
  xor  edx,edx
  xchg [eax],edx
  xor  eax,eax
  call MmFree
.ok1:
  ;//mov  eax,1
  push byte 1
  pop  eax
  ;//jmp short .out
  ;//
.out:
  add  esp,byte 12
  pop  ebx
  ret
  ;//New240314
  %ifdef PA_LargeMove
.large_move: ;// esi=src, edi=dst, ecx=dword-count...
  sub  ecx,byte 32
  jl   .afterlm1
.cylm1:
  movaps xmm0,[esi]
  movaps xmm1,[esi+16]
  movaps xmm2,[esi+2*16]
  movaps xmm3,[esi+3*16]
  movaps xmm4,[esi+4*16]
  movaps xmm5,[esi+5*16]
  movaps xmm6,[esi+6*16]
  movaps xmm7,[esi+7*16]
  add   esi,128
  movaps [edi],xmm0
  movaps [edi+16],xmm1
  movaps [edi+2*16],xmm2
  movaps [edi+3*16],xmm3
  movaps [edi+4*16],xmm4
  movaps [edi+5*16],xmm5
  movaps [edi+6*16],xmm6
  movaps [edi+7*16],xmm7
  add   edi,128
  sub   ecx,byte 32
  jge   .cylm1
.afterlm1:
  add   ecx,byte 32-4
  jl    .lastlm
.cylm2:
  movaps xmm0,[esi]
  add   esi,byte 16
  movaps [edi],xmm0
  add   edi,byte 16
  sub   ecx,4
  jge   .cylm2
.lastlm:
  add   ecx,4
  ;//jz .after_move
  rep   movsd
  jmp  near .after_move
  %endif ;seldom
  ;//

;//------------------------------------------
;// PageMap - quick list of large blocks
;// (from 4Gb level to 4kb level, 16 bytes per leaf, 5 tree levels 64 bytes per level)
;// (since original AlignedList had >6000 items *16 bytes and quite a lot of insertions and deletions)
;// (PageMap should be thread-safe even without locking, uses lock cmpxchg)
;// (but PgMapRemove needs outer locking for tree-level cleanup!)

cPgMap_nLevels   equ 5  ;// 5 tree levels
cPgMap_Shift     equ 4  ;// 4 bits of address per level
cPgMap_LevelSize equ (1<<cPgMap_Shift)*4  ;// 16 pointers, 64 bytes per tree level
cPgMap_DescSize  equ 16 ;// 16 bytes per leaf descriptor (size also hard-coded in PgMapFreeDesc below)

;// function PgMapCreate(defBase): ^TPageMap
PgMapCreate:
  push edi
  push byte cPgMap_DescSize
  pop  edx ;// MinSize=16 ?
  call OwCreate
  mov  edi,eax ;// OwPool
  push byte pgm__sizeOf
  pop  edx
  call OwAlloc ;// eax=PageMap
  mov  dword [eax],cPgMapSign
  mov  [eax+pgm_OwPool],edi
  and  dword [eax+pgm_Root],byte 0
  pop  edi
  ret

;// function __IsPgMap(PgMap): PgMap -- in case of error, returns to outer caller
;// preserves all registers...
__IsPgMap:
  test eax,eax
  jz   .bad
  cmp  dword [eax],cPgMapSign
  jne  .bad
  ret
.bad:
  pop  eax ;// do not return to our caller
  xor  eax,eax
  ret      ;// return nil/false to outer caller...

;// function PgMapDestroy(PgMap)
PgMapDestroy:
  mov  edx,eax
  mov  eax,cPgMapSign
  xor  ecx,ecx
  lock cmpxchg [edx],ecx ;// check&reset pgm_Signature at offset 0
  jne  .invalid
  mov  eax,[edx+pgm_OwPool]
  call OwShutdown
  mov  al,1
  ret
.invalid:
  xor  eax,eax
  ret

;// function PgMapGet(PgMap,Ptr): Desc16 - find pointer in map, return Pointer to 16-byte descriptor, or nil...
;// pointers in map with 4k granularity (low 12 bits), tree has 5 levels (high 20 bits, 4 bits per level)...
;// lookup is faster than sorted list, no moves during insert/delete...
PgMapGet:
  call __IsPgMap
  push ebx
  mov  eax,[eax+pgm_Root]
  mov  cl,cPgMap_nLevels
  test eax,eax
  jz   .out
.cy:
  rol  edx,cPgMap_Shift ;// =4
  mov  ebx,edx
  and  ebx,byte 0Fh
  mov  eax,[eax+4*ebx]
  test eax,eax
  jz   .out
  dec  cl
  jnz  .cy
.out:
  pop  ebx
  ret

;// function PgMapPut(PgMap,Ptr): Desc16 - store pointer in map, return Pointer to new 16-byte descriptor...
;// if there already is some descriptor, returns NULL
;// in either case returns Slot in edx where this descriptor is/shouldbe linked
;// descriptor is initialized with Ptr at offset 0
PgMapPut:
  call __IsPgMap
  push ebx
  push edi
  push esi
  push edx ;// [esp]=Ptr
  mov  ebx,eax ;// PgMap
  add  eax,byte pgm_Root ;//lea  eax,[eax+pgm_Root]
  push byte cPgMap_nLevels
  pop  esi
.cy:
  mov  ecx,[eax]
  test ecx,ecx
  jnz  .has_level
  ;// need another sub-level...
  push edx
  mov  edx,ebx
  call PgMapMakeLevel
  mov  ecx,eax
  pop  edx
  ;//
.has_level:
  rol  edx,cPgMap_Shift ;// =4
  mov  edi,edx
  and  edi,byte 0Fh
  lea  eax,[ecx+4*edi] ;// ^Slot
  dec  esi
  jnz  .cy
  ;//
  mov  esi,eax ;// ^ leaf slot
  ;// be optimistic, assume there is no leaf descriptor yet...
  ;// alloc from free-desc first...
.retry_free:
  mov  eax,[ebx+pgm_FreeDesc]
  test eax,eax
  jz   .alloc_desc
  cmp  [eax+pgfd_Sign],byte cbPgmFreeDescSign
  jne  .bad_free_desc
  mov  edx,[eax+pgfd_Next]
  lock cmpxchg [ebx+pgm_FreeDesc],edx
  jne  .retry_free
  mov  edx,eax
  xor  ecx,ecx
  mov  [edx+pgfd_Next],ecx
  ;//lea  eax,[ecx+cbPgmFreeDescSign]
  ;//lock cmpxchg [edx+pgfd_Sign],ecx
  ;//jne  .retry_free
  mov  [edx+pgfd_Sign],ecx
  jmp  short .has_desc
.bad_free_desc:
    %ifdef ErrHalt
    jmp short $ ;// halt
    %endif ;ErrHalt
  xor  edx,edx
  lock cmpxchg [ebx+pgm_FreeDesc],edx ;// if there is still this pointer, it was invalid...
  ;// alloc from OwPool otherwise:
.alloc_desc:
  mov  eax,[ebx+pgm_OwPool]
  push byte cPgMap_DescSize ;// =16
  pop  edx
  call OwAlloc
  mov  edx,eax
.has_desc:
  pop  eax ;// Ptr at [esp]
  mov  [edx],eax
  xor  eax,eax
  mov  [edx+4],eax
  mov  [edx+8],eax
  mov  [edx+12],eax
  lock cmpxchg [esi],edx ;// put new leaf if there is nil...
  jne  .fail
  mov  eax,edx ;// return leaf descriptor
.out:
  mov  edx,esi ;// return ^ leaf Slot in edx
  pop  esi
  pop  edi
  pop  ebx
  ret
.fail: ;// there already is some descriptor in this slot... free new and return nil (not much probable...)
  ;// free descriptor in edx
    %ifdef ErrHalt
    jmp short $ ;// halt...
    %endif ;ErrHalt
      ;//mov  eax,[ebx+pgm_OwPool]
      ;//push byte cPgMap_DescSize ;// =16
      ;//pop  ecx
      ;//call OwFree
  add  [edx+pgfd_Sign],byte cbPgmFreeDescSign ;// there was 0 from above, put sign...
.retry_link_free_desc:
  mov  eax,[ebx+pgm_FreeDesc]
  mov  [edx+pgfd_Next],eax
  lock cmpxchg [ebx+pgm_FreeDesc],edx
  jne  .retry_link_free_desc
  ;//
  xor  eax,eax
  jmp short .out

;// function PgMapMakeLevel(var Slot,PgMap), returns Level in ^Slot
PgMapMakeLevel:
  push ebx
  push edi
  push esi
  mov  ebx,edx ;// PgMap
  mov  esi,eax ;// ^Slot
  ;//
  mov  eax,[edx+pgm_OwPool]
  push byte cPgMap_LevelSize ;// =64
  pop  edx
  call OwAlloc
  mov  edx,eax ;// level
  ;// zero-init:
  mov  edi,eax
  push byte cPgMap_LevelSize/4 ;// =64/4 =16 dwords
  xor  eax,eax
  pop  ecx
  rep  stosd
  ;//
  lock cmpxchg [esi],edx
  jne  .another
  mov  eax,edx
.out:
  pop  esi
  pop  edi
  pop  ebx
  ret
.another:
  ;// if there already is sub-level, free new (in edx) and return existing:
  mov  edi,eax ;// existing level (loaded by cmpxchg from slot)
  mov  eax,[ebx+pgm_OwPool]
  push byte cPgMap_LevelSize ;// =64
  pop  ecx
  call OwFree
  mov  eax,edi
  jmp  short .out

;// function PgMapRemove(PgMap,Ptr): Desc16 - remove pointer from PgMap, return Desc16
PgMapRemove:
  call __IsPgMap
  push ebx
  push edi
  push esi
  push ebp
  mov  ebp,esp
  push byte 0 ;// [ebp-4] = Result
  push eax    ;// [ebp-8] = PgMap
  ;//
  push byte 0
  ;//
  add  eax,byte pgm_Root ;//lea  eax,[eax+pgm_Root]
  mov  cl,cPgMap_nLevels  ;//??? or cPgMap_nLevels-1 ?
.cy:
  push eax ;// Slot ^Level
  mov  eax,[eax]
  test eax,eax
  jz   .not_found
  rol  edx,cPgMap_Shift ;// =4
  mov  ebx,edx
  and  ebx,byte 0Fh
  lea  eax,[eax+4*ebx]
  dec  cl
  jnz  .cy
  ;// now going to leaf level:
  rol  edx,cPgMap_Shift ;// =4
  and  edx,byte 0Fh
  lea  edx,[eax+4*edx]
  mov  eax,[edx]
  ;//test eax,eax
  ;//jz   .not_found
  xor  ecx,ecx
  lock cmpxchg [edx],ecx ;// extract Desc16, store nil
  jne  .stolen
  ;//
  mov  [ebp-4],eax
  ;//
  ;// now cleanup unused tree levels... (this needs outer locking for thread safety)
  cld
.cy2:
  pop  edx ;// ^Level
  test edx,edx
  jz   .break2
  mov  eax,[edx]
  mov  esi,eax
  test eax,eax
  jz   .cy2
  ;// check 16 zero dwords:
  push byte cPgMap_LevelSize/4 ;// =16 = 64/4
  pop  ecx
.ecy:
  cmp  dword [esi],byte 0
  jne  .cy2
  add  esi,4
  dec  ecx
  jnz  .ecy
  ;// this level is completely empty...
  ;//sub  esi,cPgMap_LevelSize
  ;//mov  eax,esi
  xor  ecx,ecx
  lock cmpxchg [edx],ecx ;// extract level, store nil
  jne  .cy2
  ;// now we could check the level is still empty, but we cannot simply return non-empty level here in case of double race condition... needs outer locking...
  mov  edx,eax
  mov  eax,[ebp-8]
  mov  eax,[eax+pgm_OwPool]
  push byte cPgMap_LevelSize
  pop  ecx
  call OwFree
  jmp short .cy2
.break2:
.stolen:
.not_found:
  mov  eax,[ebp-4] ;// Result
  ;//
  mov  esp,ebp
  pop  ebp
  pop  esi
  pop  edi
  pop  ebx
  ret

;// function PgMapFreeDesc(PgMap,Desc16) - free descriptor unlinked by PgMapRemove
PgMapFreeDesc:
        ;// this causes OwPool fragmentation, since new Desc16 will eat from 64-byte free levels, which then acquire new and new space...
        ;//mov  eax,[eax+pgm_OwPool]
        ;//push byte cPgMap_DescSize ;// =16
        ;//pop  ecx
        ;//jmp  OwFree
  ;// instead reuse Desc16 separately:
  cmp  [edx+pgfd_Sign],byte cbPgmFreeDescSign
  je   .fail
  xor  ecx,ecx
  mov  [edx+8],ecx
  mov  [edx+12],ecx
  add  ecx,byte cbPgmFreeDescSign
  mov  [edx+pgfd_Sign],ecx
  lea  ecx,[eax+pgm_FreeDesc]
.retry_link:
  mov  eax,[ecx]
  mov  [edx+pgfd_Next],eax
  lock cmpxchg [ecx],edx
  jne  .retry_link
.fail:
  ret

;//

%endif ;MINIMM_PAGEALIGNED

;//--------------------------------------------------------------------

align 4
;// function MmCreatePool(VirtPool,Owner): PMmPool
MmCreatePool:
  push  ebx
  push  esi
  push  edi
  push  ebp
  mov   ebp,esp
  ;//
  push  edx ;// [ebp-4] = MidPage (later)
  push  edx ;// [ebp-8] = [esp] = Owner
  mov   ebx,eax ;// VirtPool
  ;//
  push  10000h
  push  0AB0000h  ;// signature byte/dword, when used as address, points to inaccessible page...
  call  MmVReserve
  ;//
  %ifdef AllocTag
  mov   eax,6F50h
  movd  xmm7,eax
  %endif ;AllocTag
  ;//
  ;//
  ;// Page:=AllocRawPage(VirtPool.Arg,1000h)
  mov   eax,[ebx+vp_Arg]
  mov   edx,1000h
  call  dword [ebx+vp_AllocRawPage]
  mov   esi,eax  ;// Page 
  ;//
  test  eax,eax
  jz  near .out
  ;//
  ;// Space:=MmFormatMidPage(Page,Page+8)
  ;//mov   eax,esi
  lea  edx,[eax+mid_Data] ;// future Pool address...
  ;//
  call  MmFormatMidPage
  mov   [ebp-4],eax       ;// Space (MidPage)
  ;// Pool:=MmMidPageAlloc(Space,SizeOf(TMmPool))
  lea   eax,[ebp-4]
  mov   edx,mpool__sizeOf
  call  MmMidPageAlloc
  ;//
  %ifdef MidLinear
  mov   al,8 ;// unstep back from 10h...
  %endif ;MidLinear
  ;//
  mov   edi,eax           ;// Pool
  ;//
  mov   [esi+cMmMidPageTailOffset+mpt_Pool],edi
  ;//
  mov   dword [edi],cMmPoolSign ;//0A970AAB5h
  ;// copy VirtPool record:
  push  edi
  mov   esi,ebx
  add   edi,byte mpool_VirtPool
  ;//mov   ecx,vp__sizeOf / 4
  push  byte (vp__sizeOf / 4) ;// =5
  pop   ecx
  ;//
  cld
  rep   movsd
  pop   edi
  ;//
  lea   eax,[edi+mpool_MidLock]
  push  eax
  call  InitializeCriticalSection
  ;//
  mov   eax,[ebp-4]
  mov   [edi+mpool_MidPage],eax
  ;//mov   dword [edi+mpool_AllocProc],offset MmAllocStartup
  call .here6
  .here6:
  pop   eax
  add   eax,(MmAllocStartup - .here6)
  mov   [edi+mpool_AllocProc],eax
  ;//
  lea   esi,[edi+120] ;// spare code bytes below...
  mov   eax,[esp]
  mov   [esi+mpool_Owner-120],eax
  ;// Pool.SmallTypes[0]:=nil
  xor   eax,eax
  mov   [edi+mpool_SmallTypes],eax
  ;//
  lea   eax,[esi+mpool_FreePageList-120]
  ;//call   MmInitializeListHead
  mov   [eax],eax
  mov   [eax+4],eax
  ;//
  lea   eax,[esi+mpool_SmallPageList-120]
  ;//call   MmInitializeListHead
  mov   [eax],eax
  mov   [eax+4],eax
  ;//
  lea   eax,[edi+mpool_MidPage]
  mov   edx,16*mt__sizeOf  ;//140h = 320
  call  MmMidPageAlloc
  ;//
  mov   ebx,eax
  ;// prevent freeing types: PLongint(Longint(Typ)-8)^:=-1;
  ;//x! or dword [eax-8],byte -1
  ;//
  %ifdef Align_v1 ;// old:
      mov   eax,g_Div3Table ;//offset unk_004214F8
      cmp   dword [eax],byte 0
      jnz   .skip_init_align
      call  InitAlignTables
    .skip_init_align:
      ;//
  %else ;Align_v2
    ;//
    lea   eax,[edi+mpool_MidPage]
    mov   edx,sizeof_DivTables   ;// = 0E0h
    call  MmMidPageAlloc
    mov   [esi+mpool_DivTables-120],eax
    call  InitAlignTables_v2
    ;//
  %endif ;Align_v2
  ;//
  ;//mov   esi,1
  push  byte 1
  pop   esi
  ;//
.small_type_loop:
  mov   [edi+4*esi+mpool_SmallTypes],ebx
  mov   dword [ebx],cMmTypeSign   ;//0A970DEB5h
  ;//
  xor   eax,eax
  mov   [ebx+mt_FreePages],eax
  mov   [ebx+mt_Pool],edi
  ;//
  mov   eax,esi
  call  GetAlignCheckCode
  mov   [ebx+mt_CheckAligned],eax
  ;//
  mov   eax,esi
  mov   byte [ebx+mt_ItemSize],al
  ;//
  cmp   esi,byte 1
  jle   .type_1
  ;//
  mov   byte [ebx+mt_DefFreeList],al
  ;//
  mov   ecx,esi
  shl   ecx,4
  mov   eax,1000h
  sub   eax,ecx
  cdq
  idiv  ecx
  mov   byte [ebx+mt_DefFreeCount],al
  jmp   short .smtypes_any
.type_1:
  mov   byte [ebx+mt_DefFreeList],2
  mov   al,0FEh
  mov   byte [ebx+mt_DefFreeCount],al
.smtypes_any:
  ;//mov   al,[ebx+mt_DefFreeCount]
  mov   [ebx+mt_MaxFreeCount],al
  ;//
  add   ebx,byte mt__sizeOf
  ;//
  inc   esi
  cmp   esi,byte 17
  jb    .small_type_loop
  ;//
    %ifdef MicroAlloc ;//New240318 since v21
    mov   eax,edi
    call  MmiCreate
    mov   [edi+mpool_MicroPool],eax
    %endif ;MicroAlloc
  ;//
  mov   eax,edi
  %ifdef MidLinear
    call  MmInitMidFreeList
  %else ;old x20
    call  MmInitMidTypes
  %endif ;old x20
  ;//
  cmp   dword [edi+mpool_VirtPool+vp_ReInit],byte 0
  jz    .skip_reinit
  ;//
  lea   eax,[edi+mpool_MidLock]
  push  eax
  mov   edx,[edi+mpool_AllocProc]
  lea   eax,[edi+mpool_VirtPool]
  mov   ecx,edi
  call  dword [edi+mpool_VirtPool+vp_ReInit]
.skip_reinit:
  ;// prevent freeing pool:
  ;//x!: or  dword [edi-8],byte -1
  ;//
  ;//
  lea   esi,[edi+120] ;// spare code bytes below...
  ;// since v17 - PageMap AlignedMap
  %ifdef MINIMM_PAGEALIGNED
  mov   eax,def_PgMap
  call  PgMapCreate
  mov   [esi+mpool_AlignedMap-120],eax
  %endif ;MINIMM_PAGEALIGNED
  ;//
  ;//mov   dword [edi+mpool_RefCount],1
  push  byte 1
  pop   dword [esi+mpool_RefCount-120]
  ;//
  %ifdef USE_IMemPool
    call  Mm_IMemPool_Vmt
  %else ;//normal:
    xor   eax,eax
  %endif
  mov   [esi+mpool_Vmt-120],eax
  ;//
  %ifdef USE_IMalloc
    call  Mm_IMalloc_Vmt
  %endif
  mov   [esi+mpool_Vmt_IMalloc-120],eax
  ;//
  ;//New240221
  %ifdef HugeVPool
    mov   eax,edi
    call  MmCreateHugeVPool
    mov   [esi+mpool_HugeVPool-120],eax
  %endif ;HugeVPool
  ;//
  ;//New240314
  %ifdef Poison_Free
  lea   eax,[edi+mpool_MidPage]
  mov   edx,128
  call  MmMidPageAlloc
  call  BuildSmallClears
  mov   [edi+mpool_SmallClears],eax
  %endif ;Poison_Free
  ;//
  %ifdef ArenaPool
  lea   eax,[edi+mpool_MidLock]
  call  MmA8k_CreatePool
  mov   [edi+mpool_Arena8kPool],eax
  %endif ;ArenaPool
  ;//
  %ifdef AllocTag
  pxor  xmm7,xmm7
  %endif ;AllocTag
  ;//
  mov   eax,edi
.out:
  mov   esp,ebp
  pop   ebp
  pop   edi
  pop   esi
  pop   ebx
  ret

;//--------------------------------------------------------------------

align 4
;// function Mm_IMemPool_Vmt(): Pointer // Mm_Middle_IMemPool_Vmt
%ifdef USE_IMemPool
Mm_IMemPool_Vmt:
  ;//!!!todo
xor eax,eax
ret
%endif ;USE_IMemPool

;//align 4
;// function Mm_IMalloc_Vmt(): Pointer
%ifdef USE_IMalloc
Mm_IMalloc_Vmt:
  ;//mov eax,offset @Vmt
  call .here11
  .here11
  pop  eax
  add  eax,byte (.Vmt - .here11)
  ret
align 4
  ;//
  dd  0 ;//New200825
.Vmt:
  ;// IUnknown:
  dd .QueryInterface     ;//!!!todo - offsets ?! (relocs)
  dd .AddRef
  dd .Release
  ;// IMalloc:
  dd .Im_Alloc
  dd .Im_Realloc
  dd .Im_Free
  dd .Im_GetSize
  dd .Im_DidAlloc
  dd .Im_HeapMinimize
  dd 0
  ;//
.QueryInterface:
  push ebp
  mov  ebp,esp
  ;//
  push byte 0
  call pushguid_IUnknown ;//push offset guid_IUnknown
  call pushguid_IMalloc ;//push offset guid_IMalloc
  mov  eax,[ebp+12]
  mov  edx,esp
  call MmIsGuidInList
  test al,al
  mov  esp,ebp
  jz   .qi_2
  ;//
.qi_this:
  mov  eax,[ebp+8]
  push eax
  mov  eax,[eax]
  call dword [eax+4] ;// _AddRef()
  ;//
  mov  eax,[ebp+8]
.qi_retEax:
  mov  ecx,[ebp+16]
  mov  [ecx],eax
  xor  eax,eax
.qi_out:
  mov  esp,ebp
  pop  ebp
  retn 12
  ;//
.qi_2:
  ;// could we query back IMemPool from IMalloc ?
  ;//
  mov  eax,E_NOINTERFACE
  jmp  .qi_out
  ;//
.AddRef: ;// [esp+4]=Self
  mov  eax,[esp+4]
  sub  eax,mpool_Vmt_IMalloc ;//offset TMmPool.Vmt_IMalloc
  cmp  dword [eax],cMmPoolSign ;//cmp  [eax].TMmPool.Signature,cMmPoolSign
  jne  .bad_ref
  add  eax,mpool_RefCount ;//lea  eax,[eax].TMmPool.RefCount
  call LAddRef
.BoolRef:
  and  eax,byte 1
  retn 4
  ;//
.Release:
  mov  eax,[esp+4]
  sub  eax,mpool_Vmt_IMalloc ;//offset TMmPool.Vmt_IMalloc
  cmp  dword [eax],cMmPoolSign ;//cmp  [eax].TMmPool.Signature,cMmPoolSign
  jne  .bad_ref
  add  eax,mpool_RefCount ;//lea  eax,[eax].TMmPool.RefCount
  call LRelease
  test al,al
  mov  al,1
  jz   .BoolRef
  ;// IMalloc released... do nothing...
.bad_ref:
  xor  eax,eax
  retn 4
  ;//
.Im_Alloc: ;// [esp+4]=^Vmt_IMalloc, [esp+8]=cb
  mov  eax,[esp+4]
  sub  eax,mpool_Vmt_IMalloc ;//offset TMmPool.Vmt_IMalloc
  mov  edx,[esp+8]
  pop  dword [esp+4] ;// pop caller, store where needed... pop uses esp after popping...
  pop  ecx ;// discard...
  jmp  MmAlloc
  ;//
.Im_Free: ;// [esp+4]=^Vmt_IMalloc, [esp+8]=pv
  mov  eax,[esp+4]
  sub  eax,mpool_Vmt_IMalloc ;//offset TMmPool.Vmt_IMalloc
  mov  edx,[esp+8]
  pop  dword [esp+4] ;// pop caller, store where needed... pop uses esp after popping...
  pop  ecx ;// discard...
  jmp  MmFree
  ;//
.Im_Realloc: ;// [esp+4]=^Vmt_IMalloc, [esp+8]=pv, [esp+12]=cb
  mov  eax,[esp+4]
  sub  eax,mpool_Vmt_IMalloc ;//offset TMmPool.Vmt_IMalloc
  mov  edx,[esp+8]
  mov  ecx,[esp+12]
  pop  dword [esp+8] ;// pop caller, store where needed... pop uses esp after popping...
  add  esp,byte 8
  jmp  MmReAlloc
  ;//
.Im_GetSize: ;// [esp+4]=^Vmt_IMalloc, [esp+8]=pv
  mov  eax,[esp+8]
  call MmQuerySizeCheck
  retn 8
  ;//
.Im_DidAlloc: ;// [esp+4]=^Vmt_IMalloc, [esp+8]=pv
  mov  eax,[esp+8]
  call MmQuerySizeCheck
  test eax,eax
  setnz al ;// 1 = our pointer, 0 = other pointer
  and  eax,byte 1
  retn 8
  ;//
.Im_HeapMinimize: ;// [esp+4]=^Vmt_IMalloc
  mov  eax,[esp+4]
  sub  eax,mpool_Vmt_IMalloc ;//offset TMmPool.Vmt_IMalloc
  call MmCollectFree
  retn 8
pushguid_IMalloc:
  pop edx
  call .gr_IMalloc
  dd  2,0,0,0,0,0,0,0,0C0h,0,0,0,0,0,0,46h
  .gr_IMalloc:
  jmp edx
//%else ;!USE_IMalloc
//  xor eax,eax
//  ret
%endif ;!USE_IMalloc

%ifdef USE_Interface
;// function LAddRef(var Slot): Boolean; ;// returns true if ok (initial Slot > 0 ! )
LAddRef:
  mov  edx,eax
.retry:
  mov  eax,[edx]
  test eax,eax
  jle  .fail
  lea  ecx,[eax+1]
  cmpxchg [edx],ecx
  jnz  .retry_f
  mov  al,1
  ret
.retry_f:
  nop
  jmp short .retry
.fail:
  xor  eax,eax
  ret

;// function LRelease(var Slot): Boolean; ;// returns True if Slot released to 0...
LRelease:
  mov  edx,eax
.retry:
  mov  eax,[edx]
  test eax,eax
  jle  .fail
  lea  ecx,[eax-1]
  cmpxchg [edx],ecx
  jnz  .retry_f
  test ecx,ecx
  setz al
  ret
.retry_f:
  nop
  jmp  .retry
.fail:
  xor  eax,eax
  ret

;// function MmSameGuid(const G1,G2: TGuid): Boolean
MmSameGuid:
  push ebx
  xor ebx,ebx
  mov ecx,[eax]
  xor ecx,[edx]
  or  ebx,ecx
  mov ecx,[eax+4]
  xor ecx,[edx+4]
  or  ebx,ecx
  jnz .diff
  mov ecx,[eax+8]
  xor ecx,[edx+8]
  or  ebx,ecx
  mov ecx,[eax+12]
  xor ecx,[edx+12]
  or  ebx,ecx
.diff:
  setz al
  pop ebx
  ret

pushguid_IUnknown:
  pop edx
  call .gr_IUnknown
  dd  0,0,0,0,0,0,0,0,0C0h,0,0,0,0,0,0,46h
  .gr_IUnknown:
  jmp edx

;// function MmIsGuidInList(const G: TGuid; GuidList: Pointer{PPointerList}): Boolean
MmIsGuidInList:
  push eax
  test edx,edx
  jz   .none
.cy:
  push edx
  mov  edx,[edx]
  test edx,edx
  jz   .none
  mov  eax,[esp+4]
  call MmSameGuid
  test al,al
  pop  edx
  jnz  .res
  add  edx,byte 4
  jmp  .cy
.none:
  xor  eax,eax
.res:
  pop  edx
  ret

%endif ;USE_Interface

;//--------------------------------------------------------------------
;// malloc etc handlers for mozglue.dll
%ifdef C_MEM_Handlers

align 4
;// function C_malloc(size): Pointer; cdecl;  - handler for malloc, _aligned_malloc
;// [esp+4] = Size
C_malloc:
  ;//
  %ifdef AllocTag
  call MmSetAllocTag
  %endif ;AllocTag
    ;//
    %ifdef LogAlloc
    mov  eax,[esp+4]
    push dword [esp]
    and  eax,0FFFFFFFh
    or   eax,0A0000000h
    push eax
    push byte 8
    call LogWrite
    %endif ;LogAlloc
    ;//
  ;//
  ;//mov  eax,[g_MainMmPool]  ;// fixed pointer
  call MmGetMainPool
  mov  edx,[esp+4]
_C_any_alloc:
  test edx,edx
  jg   .go_alloc
  jnz  c_ret0a
  ;// with size==0 allocate 1 (16 bytes)
  push byte 16
  pop  edx
.go_alloc:
  add  edx,byte 3  ;// dword-round...
  and  edx,byte -4
  jmp near MmAlloc0

;// function C_free(ptr); cdecl;   - handler for free()
;// [esp+4] = Pointer
C_free:
  mov  edx,[esp+4]
  xor  eax,eax
  jmp  MmFree

;// function C_calloc(num,size): Pointer; cdecl;  - handler for calloc
;// [esp+4] = num, [esp+8] = Size
C_calloc:
  ;//
  %ifdef AllocTag
  call MmSetAllocTag
  %endif ;AllocTag
  ;//
    %ifdef LogAlloc
    mov eax,[esp+4]
    mov edx,[esp+8]
    push dword [esp] ;// caller
    push eax         ;// num
    push edx         ;// size
    push 'Ca:'
    push byte 16
    call LogWrite
    %endif ;LogAlloc
  ;//
  call MmGetMainPool
  mov  edx,[esp+4]
  ;//
  test edx,edx
  jz   .bad_num
.num_ok:
  imul edx,dword [esp+8]
  jmp  short _C_any_alloc
.bad_num:
  push byte 1
  pop  edx
  jmp  short .num_ok
c_ret0a:
  ;//
  %ifdef AllocTag
  pxor xmm7,xmm7
  %endif ;AllocTag
  ;//
  xor  eax,eax
  ret

c_rea_no_ptr:
  mov  [esp+4],ecx
  jmp short C_malloc

;// function C_expand(ptr,newsize): Pointer; - handler for _expand
;// [esp+4]=ptr, [esp+8]=newsize
C_expand:
  ;// same as C_realloc below...
;// function C_realloc(ptr,size): Pointer; cdecl;  - handler for realloc
;// [esp+4] = Pointer, [esp+8] = NewSize
C_realloc:
  ;//mov  eax,[g_MainMmPool]  ;// fixed pointer
  ;//
  %ifdef AllocTag
  call MmSetAllocTag
  %endif ;AllocTag
  ;//
  call MmGetMainPool
  mov  ecx,[esp+8]
  ;//_C_realloc_ac:
  lea  edx,[esp+4]
  cmp  dword [edx],byte 0
  jz short c_rea_no_ptr
  ;//
  test ecx,ecx
  jle  .size_ok
  add  ecx,byte 3
  and  ecx,byte -4
.size_ok:
  ;//
  call MmReAlloc
  ;//
  %ifdef AllocTag
  pxor xmm7,xmm7
  %endif ;AllocTag
  ;//
  test al,al
  jz   c_ret0 ;//.fail
  mov  eax,[esp+4]
  ret
;//.no_ptr:
;//  mov  [esp+4],ecx
;//  jmp short C_malloc
;//.fail:
;//  xor  eax,eax
;//  ret

;// function C_reCalloc(ptr,count,size): Pointer; - handler for _recalloc
;// [esp+4]=ptr, [esp+8]=count, [esp+12]=size
C_reCalloc:
  ;//
  %ifdef AllocTag
  call MmSetAllocTag
  %endif ;AllocTag
  ;//
  call MmGetMainPool
  mov  ecx,[esp+8]
  imul ecx,[esp+12]
  test ecx,ecx
  jle  .free_calloc
  ;//
  add  ecx,byte 3
  and  ecx,byte -4
  ;//
  mov  edx,[esp+4]
  test edx,edx
  jz   .no_ptr
  ;//
  lea  edx,[esp+4]
  call MmReAlloc0
  ;//
  %ifdef AllocTag
  pxor xmm7,xmm7
  %endif ;AllocTag
  ;//
  mov  eax,[esp+4]
  ret
.no_ptr:
  mov  edx,ecx
  jmp  MmAlloc0
.free_calloc:
  mov  edx,[esp+4]
  test edx,edx
  jz   c_ret0
  call MmFree
c_ret0:
  xor  eax,eax
  ret

;// function C_query(ptr): integer; cdecl; - handler for malloc_usable_size
C_query:
  mov  eax,[esp+4]
  jmp  MmQuerySizeCheck

;// function C_aligned_malloc(size,alignment): Pointer; cdecl;
;// corrected in v17... jemalloc.c has the arguments swapped, while mozmemory_wrap.c swaps the arguments...
;// (our small-blocks are aligned, large are page-aligned, just middle-sized blocks are only 8-byte aligned)
C_aligned_malloc:
  ;//
  %ifdef AllocTag
  call MmSetAllocTag
  %endif ;AllocTag
    %ifdef LogAlloc
    mov  eax,[esp+4]
    mov  edx,[esp+8]
    push dword [esp]  ;// caller
    push edx
    push eax
    push 'aliM'
    push byte 16
    call LogWrite
    %endif ;LogAlloc
  ;//
C_aligned_malloc2:
  call MmGetMainPool
  mov  edx,[esp+4] ;// size
  ;//New240305 - use bigger of (alignment,size) as size, in case they are swapped...?! better safe than sorry...
  mov   ecx,[esp+8]
  cmp   ecx,edx
  cmovg edx,ecx
  ;//
  cmp  edx,cMmMaxSmallSize
  jb   near MmAlloc0
  cmp  edx,cMmMaxMiddleSize
  jae  near MmAllocPageAligned
  ;// align middle block on 32-byte boundary...
  add  edx,byte 40h
  call MmAllocMiddle
  ;//
  %ifdef AllocTag
  pxor xmm7,xmm7
  %endif ;AllocTag
  ;//
  test eax,eax
  jz   .mid_failed
  test al,1Fh ;//test eax,1Fh
  jnz  .align_mid
.align_ok:
  ret
.mid_failed:
  call MmGetMainPool
  ;//mov  edx,[esp+8]
  mov  edx,[esp+4]
  mov  ecx,[esp+8]
  cmp  ecx,edx
  cmovg edx,ecx
  ;//
  jmp  MmAllocPageAligned
.align_mid:
  ;// if requested 10h alignment, now this is most common everywhere...
  mov  ecx,[esp+8]
  dec  ecx
  test eax,ecx
  jz   .align_ok
  ;//
  push edi
  push esi
  ;//
  %ifdef MidLinear
    ;//  mov  edx,eax
    ;//  and  edx,0FFFh
    ;//  cmp  dx,byte 10h
    ;//  jne  .mid_ok
    ;//  mov  al,8
    ;//.mid_ok:
    call MmMidLin_Unstep10_08
  %endif
  ;//
  mov  edi,eax  ;// allocated place
  add  eax,byte 30h
  and  eax,byte -20h  ;// aligned on 32-byte boundary...
  mov  esi,eax  ;// new aligned place
  movzx edx,word [edi-8+mid_NextSizeFlags]
  shl  edx,3
  add  edx,edi
  sub  edx,esi  ;// esi+edx is next prefix
  mov  ecx,edx
  shr  ecx,3    ;// new size this tiles
  mov  eax,esi
  sub  eax,edi
  sub  eax,byte 8
  shr  eax,3    ;// size prior tiles
  or   ax,8000h
  mov  [esi-8+mid_NextSizeFlags],cx ;// prior small space wasted for alignment will be merged with this place when it is freed and is not worth for re-allocating anything...
  mov  [esi-8+mid_PriorSizeFlags],ax
  mov  [edi-8+mid_NextSizeFlags],ax
  mov  [esi+edx+mid_PriorSizeFlags],cx
  ;//
  %ifdef AllocTag
  xor  edx,edx
  xchg [edi-8+mid_dwTag],edx
  mov  [esi-8+mid_dwTag],edx
  %endif ;AllocTag
  ;//
  mov  edi,esi
  add  ecx,ecx
  xor  eax,eax
  rep  stosd
  mov  eax,esi
  pop  esi
  pop  edi
  ret

;// function C_posix_memalign(var ptr,alignment,size): integer; cdecl;
;// [esp+4]=^ptr, [esp+8]=alignment, [esp+12]=size, return 0 ok, 12 out-of-mem, 22 invalid alignment
C_posix_memalign:
  ;//
  %ifdef AllocTag
  call MmSetAllocTag
  %endif ;AllocTag
  ;//
  ;//push dword [esp+12]
  ;//push dword [esp+12]
  push dword [esp+8]
  push dword [esp+12+4]
  call C_aligned_malloc2
  add  esp,byte 8
  test eax,eax
  jz   .out_of_mem
  mov  edx,[esp+4]
  mov  [edx],eax
  xor  eax,eax
  ret
.out_of_mem:
  push byte 12
  pop  eax
  ret

;// function C_jemalloc_stats(stats) cdecl
;// puts TotalCommit at stats+28h, TotalReserve at stats+24h, according to mozglue disasm...
;// actual allocated size is not available and would be very expensive to collect...
C_jemalloc_stats:
  push ebp
  mov  ebp,esp
  xor  edx,edx
  push edx   ;// [ebp-4] = TotalReserve
  push edx   ;// [ebp-8] = TotalCommit
  call MmGetMainPool
  ;//
  mov  edx,[eax+mpool_VirtPool+vp_Arg]
  cmp  dword [edx],cMmVirtPoolSign
  jne  .skip1
  mov  ecx,[edx+mvp_TotalReserve]
  add  [ebp-4],ecx
  mov  ecx,[edx+mvp_TotalCommit]
  add  [ebp-8],ecx
.skip1:
  ;//
  %ifdef HugeVPool
  mov  edx,[eax+mpool_HugeVPool]
  test edx,edx
  jz   .skip2
  mov  edx,[edx+vp_Arg]
  cmp  dword [edx],cMmHugeVPoolSign
  jne  .skip2
  mov  ecx,[edx+hvp_TotalReserve]
  add  [ebp-4],ecx
  mov  ecx,[edx+hvp_TotalCommit]
  add  [ebp-8],ecx
.skip2:
  %endif ;HugeVPool
  ;//
  %ifdef ArenaPool
  mov  edx,[eax+mpool_Arena8kPool]
  test edx,edx
  jz   .skip3
  mov  edx,[edx+vp_Arg]
  cmp  dword [edx+m8k_Signature],cMmA8kSign
  jne  .skip3
  mov  ecx,[edx+m8k_TotalReserve]
  add  [ebp-4],ecx
  mov  ecx,[edx+m8k_TotalCommit]
  add  [ebp-8],ecx
.skip3:
  %endif ;//ArenaPool
  ;//
  %ifdef MicroAlloc
  mov  edx,[eax+mpool_MicroPool]
  test edx,edx
  jz   .skip4
  cmp  dword [edx+mmi_Signature],cMmiSignature
  jne  .skip4
  mov  ecx,[edx+mmi_TotalReserve]
  add  [ebp-4],ecx
  mov  ecx,[edx+mmi_TotalCommit]
  add  [ebp-8],ecx
.skip4:
  %endif ;Micro
  ;//
  mov  eax,[ebp+8] ;// Stats
  ;//
  mov  ecx,38h ;// max dword filled by mozglue in Palemoon 32
  xor  edx,edx
.clr:
  mov  [eax+ecx],edx
  sub  ecx,byte 4
  jnl  .clr
  ;//
  mov  edx,[ebp-8]
  mov  [eax+28h],edx ;// TotalCommit
  mov  edx,[ebp-4]
  mov  [eax+24h],edx ;// TotalReserve
  ;//
  mov  esp,ebp
  pop  ebp
  ret
  

%endif ;C_MEM_Handlers
;//--------------------------------------------------------------------

%ifdef AllocTag
;// function MmSetAllocTag() - tag by caller of caller address...
MmSetAllocTag:
  ;// try using [ebp+4] instead, if it also points to stack...
  ;// this way it gets caller of moz_xmalloc instead of caller of malloc:
  mov  eax,ebp
  sub  eax,esp
  cmp  eax,1000h
  jae .default
  mov  eax,[ebp+4]
  jmp short .thisTag
  ;// or use our caller at [esp+4] ...
.default:
  mov  eax,[esp+4]
.thisTag:
  movd xmm7,eax
  ret
%endif ;AllocTag
;//

;// System.pas externals: (Delphi code)
HandleFinally:
       mov    eax,dword [esp+4]                ; 004030E4      8B 44 24 04
       mov    edx,dword [esp+8]                ; 004030E8      8B 54 24 08
       ;//test   dword [eax+4],6                  ; 004030EC      F7 40 04 06 00 00 00
       test   byte [eax+4],6
       jz     .loc_00403114                    ; 004030F3      74 1F
       mov    ecx,dword [edx+4]                ; 004030F5      8B 4A 04
       ;//mov    dword ptr [edx+4],offset .loc_00403114        ; 004030F8      C7 42 04 14 31 40 00
       call .here0
       .here0:
       pop  eax
       add  eax,byte (.loc_00403114 - .here0)
       mov  [edx+4],eax
       ;//
       push   ebx                              ; 004030FF      53
       push   esi                              ; 00403100      56
       push   edi                              ; 00403101      57
       push   ebp                              ; 00403102      55
       mov    ebp,dword [edx+8]                ; 00403103      8B 6A 08
       add    ecx,byte 5                       ; 00403106      83 C1 05
       ;//call   NotifyExceptFinally           ; 00403109      E8 12 FD FF FF
       call   ecx                              ; 0040310E      FF D1
       pop    ebp                              ; 00403110      5D
       pop    edi                              ; 00403111      5F
       pop    esi                              ; 00403112      5E
       pop    ebx                              ; 00403113      5B
.loc_00403114:         ; j< 004030F3           ; 00403114
                       ; ?< 004030F8                           ; 00403114
       mov    eax,1                            ; 00403114      B8 01 00 00 00
       ret                                     ; 00403119      C3

HandleAnyException:            ; j> 00404DB3   ; 00402E84
  %ifdef Halt_Except
  jmp short $
  %endif ;Halt_Except
       mov    eax,dword [esp+4]                ; 00402E84      8B 44 24 04
       ;//test   dword [eax+4],6                  ; 00402E88      F7 40 04 06 00 00 00
       test   byte [eax+4],6
       jnz    .loc_00402F7B_out                     ; 00402E8F      0F 85 E6 00 00 00
       ;//cmp    dword [eax],0EEDFADEh        ; 00402E95      81 38 DE FA ED 0E
       ;//mov    edx,dword [eax+18h]          ; 00402E9B      8B 50 18
       ;//mov    ecx,dword [eax+14h]          ; 00402E9E      8B 48 14
       ;//jz     .loc_00402EFC                     ; 00402EA1      74 59
       cld                                     ; 00402EA3      FC
       call   @FpuInit                         ; 00402EA4      E8 17 FB FF FF
       ;//
       ;//mov    edx,dword_0042100C               ; 00402EA9      8B 15 0C 10 42 00
       ;//test   edx,edx                          ; 00402EAF      85 D2
       ;//jz     .loc_00402EEF                     ; 00402EB1      74 3C
       jmp short .loc_00402EEF
       ;//call   edx                              ; 00402EB3      FF D2
       ;//test   eax,eax                          ; 00402EB5      85 C0
       ;//jz     .loc_00402F7B_out                     ; 00402EB7      0F 84 BE 00 00 00
       ;//mov    edx,dword [esp+0Ch]          ; 00402EBD      8B 54 24 0C
       ;//mov    ecx,dword [esp+4]            ; 00402EC1      8B 4C 24 04
       ;//cmp    dword [ecx],0EEFFACEh        ; 00402EC5      81 39 CE FA EF 0E
       ;//jz     .loc_00402EF3                     ; 00402ECB      74 26
       ;//call   NotifyNonDelphiException         ; 00402ECD      E8 D2 FE FF FF
       ;//cmp    byte [JITEnable],0           ; 00402ED2      80 3D 08 00 42 00 00
       ;//jbe    .loc_00402EF3                     ; 00402ED9      76 18
       ;//cmp    byte [DebugHook],0           ; 00402EDB      80 3D 04 00 42 00 00
       ;//ja     .loc_00402EF3                     ; 00402EE2      77 0F
.loc_00402EE4:          ; j> 00402EF1           ; 00402EE4
       mov    edx,eax                          ; 00402EE4      89 C2
       mov    eax,dword [esp+4]            ; 00402EE6      8B 44 24 04
       mov    ecx,dword [eax+0Ch]          ; 00402EEA      8B 48 0C
       jmp  short  .loc_00402F0C                     ; 00402EED      EB 1D
;-----------------------------------------------------------   ; 00402EED
.loc_00402EEF:          ; j< 00402EB1           ; 00402EEF
       xor    eax,eax                          ; 00402EEF      31 C0
       jmp    .loc_00402EE4                     ; 00402EF1      EB F1
;-----------------------------------------------------------   ; 00402EF1
.loc_00402EF3:          ; j< 00402ECB           ; 00402EF3
                       ; j< 00402ED9                           ; 00402EF3
                       ; j< 00402EE2                           ; 00402EF3
       ;//mov    edx,eax                          ; 00402EF3      89 C2
       ;//mov    eax,dword [esp+4]            ; 00402EF5      8B 44 24 04
       ;//mov    ecx,dword [eax+0Ch]          ; 00402EF9      8B 48 0C
.loc_00402EFC:          ; j< 00402EA1           ; 00402EFC
       ;//cmp    byte [JITEnable],1           ; 00402EFC      80 3D 08 00 42 00 01
       ;//jbe    .loc_00402F0C                     ; 00402F03      76 07
       ;//cmp    byte [DebugHook],0           ; 00402F05      80 3D 04 00 42 00 00
.loc_00402F0C:          ; j< 00402EED           ; 00402F0C
                       ; j< 00402F03                           ; 00402F0C
       or     dword [eax+4],byte 2             ; 00402F0C      83 48 04 02
       push   ebx                              ; 00402F10      53
       xor    ebx,ebx                          ; 00402F11      31 DB
       push   esi                              ; 00402F13      56
       push   edi                              ; 00402F14      57
       push   ebp                              ; 00402F15      55
       db 64h,8Bh,1Bh ;//mov    ebx,dword fs:[ebx]           ; 00402F16      64 8B 1B
       push   ebx                              ; 00402F19      53
       push   eax                              ; 00402F1A      50
       push   edx                              ; 00402F1B      52
       push   ecx                              ; 00402F1C      51
       mov    edx,dword [esp+28h]              ; 00402F1D      8B 54 24 28
       push byte 0                             ; 00402F21      6A 00
       push   eax                              ; 00402F23      50
       ;//push   offset .loc_00402F2F              ; 00402F24      68 2F 2F 40 00
       call .here19
       .here19:
       add dword [esp],byte (.loc_00402F2F - .here19)
       ;//
       push   edx                              ; 00402F29      52
       call   RtlUnwind                        ; 00402F2A      E8 B5 E1 FF FF
.loc_00402F2F:          ; o< 00402F24           ; 00402F2F
       mov    edi,dword [esp+28h]          ; 00402F2F      8B 7C 24 28
       ;//call   @GetTls                          ; 00402F33      E8 F0 2B 00 00
       ;//push   [eax+0h]                         ; 00402F38      FF B0 00 00 00 00
       ;//mov    dword [eax+0h],esp           ; 00402F3E      89 A0 00 00 00 00
       mov    ebp,dword [edi+8]            ; 00402F44      8B 6F 08
       mov    ebx,dword [edi+4]            ; 00402F47      8B 5F 04
       ;//mov    dword [edi+4],offset .loc_00402F5B    ; 00402F4A      C7 47 04 5B 2F 40 00
       call .here20
       .here20:
       pop  eax
       add  eax,byte (.loc_00402F5B - .here20)
       mov  [edi+4],eax
       ;//
       add    ebx,byte 5                            ; 00402F51      83 C3 05
       ;//call   NotifyAnyExcept                  ; 00402F54      E8 93 FE FF FF
       jmp    ebx                              ; 00402F59      FF E3
;-----------------------------------------------------------   ; 00402F59
.loc_00402F5B:          ; o< 00402F4A           ; 00402F5B
       jmp    HandleFinally                   ; 00402F5B      E9 84 01 00 00
;-----------------------------------------------------------   ; 00402F5B
       ;//call   @GetTls                          ; 00402F60      E8 C3 2B 00 00
       ;//mov    ecx,dword [eax+0h]           ; 00402F65      8B 88 00 00 00 00
       ;//mov    edx,dword [ecx]              ; 00402F6B      8B 11
       ;//mov    dword [eax+0h],edx           ; 00402F6D      89 90 00 00 00 00
       ;//mov    eax,dword [ecx+8]            ; 00402F73      8B 41 08
       ;//jmp    TObject.Free                     ; 00402F76      E9 FD FA FF FF
       ret
;-----------------------------------------------------------   ; 00402F76
.loc_00402F7B_out:          ; j< 00402E8F           ; 00402F7B
                       ; j< 00402EB7                           ; 00402F7B
       mov    eax,1                            ; 00402F7B      B8 01 00 00 00
       ret                                     ; 00402F80      C3

@FpuInit:              ; c> 00402EA4                   ; 004029C0
                       ; c> 00402F9E                           ; 004029C0
                       ; c> 004037AB                           ; 004029C0
       fninit                                  ; 004029C0      DB E3
       wait                                    ; 004029C2      9B
       ;//fldcw  Default8087CW                 ; 004029C3      D9 2D 00 00 42 00
       push 1332h
       fldcw [esp]
       pop edx ;//add esp,byte 4
       ;//
       ret                                     ; 004029C9      C3


DoneExcept:            ; c> 00404DB8           ; 004031F8
       ;//call   @GetTls                          ; 004031F8      E8 2B 29 00 00
       ;//mov    edx,dword [eax+0h]       ; 004031FD      8B 90 00 00 00 00
       ;//mov    ecx,dword [edx]          ; 00403203      8B 0A
       ;//mov    dword [eax+0h],ecx       ; 00403205      89 88 00 00 00 00
       ;//mov    eax,dword [edx+8]        ; 0040320B      8B 42 08
       ;//call   TObject.Free                  ; 0040320E      E8 65 F8 FF FF
       pop    edx                              ; 00403213      5A
       mov    esp,dword [esp+2Ch]      ; 00403214      8B 64 24 2C
       xor    eax,eax                          ; 00403218      31 C0
       pop    ecx                              ; 0040321A      59
       db 64h,89h,08h ;//mov    dword fs:[eax],ecx       ; 0040321B      64 89 08
       pop    eax                              ; 0040321E      58
       pop    ebp                              ; 0040321F      5D
       ;//call   NotifyTerminate               ; 00403220      E8 23 FC FF FF
       jmp    edx                              ; 00403225      FF E2


;// DsGuard3.inc - silent try handler, depends only on RtlUnwind
%if 0

align 4
;// function TryCall(Proc,Param,ErrorHandler): Longint; stdcall;
;// [EBP]=SaveEbp,[EBP+4]=Caller,[EBP+8]=Proc, [EBP+12]=Param, [EBP+16]=ErrorHandler
;// depends on RtlUnwind !
TryCall:
       push   ebp                              ; 00403434      55
       mov    ebp,esp                          ; 00403435      8B EC
       mov    eax,[ebp+12]                     ; 00403437      8B 45 0C
       push   eax                              ; 0040343A      50
       push   dword [ebp+16]                   ; 0040343B      FF 75 10
       mov    edx,[ebp+8]                      ; 0040343E      8B 55 08
       push   byte 0                           ; 00403441      6A 00
       push   ebx                              ; 00403443      53
       push   esi                              ; 00403444      56
       push   edi                              ; 00403445      57
       ;//push   offset .loc_0040346D             ; 00403446      68 6D 34 40 00
       call .here21
       .here21:
       add dword [esp],byte (.loc_0040346D - .here21)
       ;//
       ;//push   offset Guard3ExcHandler          ; 0040344B      68 CC 33 40 00
       call .here22
       .here22:
       add dword [esp],(Guard3ExcHandler - .here22)
       ;//
       xor    ecx,ecx                          ; 00403450      31 C9
       db 64h,0FFh,31h ;//push   fs:[ecx]               ; 00403452      64 FF 31
       db 64h,89h,21h  ;//mov    fs:[ecx],esp           ; 00403455      64 89 21
       ;//
       push   ebp                              ; 00403458      55
       mov    ebp,esp                          ; 00403459      89 E5
       push   eax                              ; 0040345B      50
       call   edx                              ; 0040345C      FF D2
       mov    esp,ebp                          ; 0040345E      89 EC
       pop    ebp                              ; 00403460      5D
       mov    dword [esp+18h],eax              ; 00403461      89 44 24 18
       ;//
       xor    eax,eax                          ; 00403465      31 C0
       db 64h,8Fh,00h ;//pop    fs:[eax]                         ; 00403467      64 8F 00
       add    esp,byte 8                       ; 0040346A      83 C4 08
.loc_0040346D:         ; o< 00403446           ; 0040346D
       pop    edi                              ; 0040346D      5F
       pop    esi                              ; 0040346E      5E
       pop    ebx                              ; 0040346F      5B
       pop    eax                              ; 00403470      58
       add    esp,byte 8                       ; 00403471      83 C4 08
       pop    ebp                              ; 00403474      5D
       retn   0Ch                              ; 00403475      C2 0C 00

Guard3ExcHandler:              ; o> 0040344B           ; 004033CC
       mov    eax,[esp+4]                      ; 004033CC      8B 44 24 04
       test   dword [eax+4],6                  ; 004033D0      F7 40 04 06 00 00 00
       jnz    .loc_0040342D                    ; 004033D7      75 54
       cld                                     ; 004033D9      FC
       or     dword [eax+4],byte 2             ; 004033DA      83 48 04 02
       mov    edx,[esp+8]                      ; 004033DE      8B 54 24 08
       push   byte 0                           ; 004033E2      6A 00
       push   eax                              ; 004033E4      50
       ;//push   offset .loc_004033F0             ; 004033E5      68 F0 33 40 00
       call .here23
       .here23:
       add dword [esp],byte (.loc_004033F0 - .here23)
       ;//
       push   edx                              ; 004033EA      52
       call   RtlUnwind                        ; 004033EB      E8 F4 DC FF FF
.loc_004033F0:          ; o< 004033E5          ; 004033F0
       mov    edx,[esp+8]                      ; 004033F0      8B 54 24 08
       mov    ecx,[edx+1Ch]                    ; 004033F4      8B 4A 1C
       test   ecx,ecx                          ; 004033F7      85 C9
       jz     .loc_00403422                    ; 004033F9      74 27
       ;//push   edx                              ; 004033FB      52
       ;//push   ecx                              ; 004033FC      51
       ;//call   IsBadCodePtr                     ; 004033FD      E8 C2 FF FF FF
       ;//test   eax,eax                          ; 00403402      85 C0
       ;//pop    edx                              ; 00403404      5A
       ;//jnz    .loc_00403422                    ; 00403405      75 1B
       ;//
       push   ebp                              ; 00403407      55
       mov    ebp,esp                          ; 00403408      89 E5
       mov    eax,[esp+8]    ;// // EAX=^ExceptionRecord, EDX=^ExcFrame                  ; 0040340A      8B 44 24 08
       mov    ecx,[edx+1Ch]                    ; 0040340E      8B 4A 1C
       push   byte 0                           ; 00403411      6A 00
       pop    dword [edx+1Ch]                  ; 00403413      8F 42 1C
       call   ecx                              ; 00403416      FF D1
       mov    esp,ebp                          ; 00403418      89 EC
       pop    ebp                              ; 0040341A      5D
       mov    edx,[esp+8]                      ; 0040341B      8B 54 24 08
       mov    dword [edx+18h],eax              ; 0040341F      89 42 18
.loc_00403422:          ; j< 004033F9          ; 00403422
                       ; j< 00403405                           ; 00403422
       mov    esp,[esp+8]                      ; 00403422      8B 64 24 08
       xor    eax,eax                          ; 00403426      31 C0
       db 64h,8Fh,00h ;//pop    fs:[eax]                         ; 00403428      64 8F 00
       pop    eax                              ; 0040342B      58
       ret                                     ; 0040342C      C3
.loc_0040342D:          ; j< 004033D7           ; 0040342D
       push   1                                ; 0040342D      6A 01
       pop    eax                              ; 0040342F      58
       ret                                     ; 00403430      C3

%endif ;0

;//------------------
align 4
;// function ZeroTry(Proc,Param,ErrorHandler): Longint; stdcall;
;// silent dirty try-handler without unwinding any try-finally inside...
;// (used only during Startup to find kernel32.dll and during tests...)
;// in [esp+4]=[ebp+8]=Proc, [esp+8]=[ebp+12]=Param, [esp+12]=[ebp+16]=ErrorHandler
ZeroTry:
  push ebp
  mov  ebp,esp
  mov  eax,[ebp+12] ;//Param
  push eax
  push dword [ebp+16] ;// user ErrorHandler
  mov  edx,[ebp+8] ;// Proc
  push byte 0 ;// Result
  push ebx
  push esi
  push edi
  ;//
  call .2 ;//= push offset .continue
.continue:
  ;//??? lea  esp,[ebp-24]
  pop  edi
  pop  esi
  pop  ebx
  pop  eax
  ;//add  esp,byte 8 ;// skip internals ErrorHandler,Param
  pop  edx
  pop  edx
  ;//
  pop  ebp
  retn 12
  ;//
.2:
  call .3 ;//= push offset ExcHandler
.ExcHandler:
  ;//      { ->    [ESP+ 4] excPtr: PExceptionRecord       }
  ;//      {       [ESP+ 8] errPtr: PExcFrame              }
  ;//      {       [ESP+12] ctxPtr: Pointer                }
  ;//      {       [ESP+16] dspPtr: Pointer                }
  ;//      { <-    EAX return value - always one   }
  mov  edx,[esp+8]
  mov  ecx,[edx+1Ch] ;// ErrorHandler
  test ecx,ecx
  jz   .DoneExc
  ;//
  push ebp
  mov  ebp,esp
  ;//
  mov  eax,[esp+4+4] ;// EAX=^ExceptionRecord, EDX=^ExcFrame
  ;//
  push byte 0
  pop  dword [edx+1Ch]
  ;//
  call ecx
  ;//
  mov  esp,ebp
  pop  ebp
  ;//
  mov  edx,[esp+8]
  mov  [edx+18h],eax ;// change Result
  ;//
.DoneExc:
  mov  esp,[esp+8]
  xor  eax,eax
  db 64h,8Fh,00h ;//pop    fs:[eax]                         ; 00403428      64 8F 00
  pop  eax
  ret ;// -> pContinue... popa ...
  ;//
.3:
  xor  ecx,ecx
  db 64h,0FFh,31h ;//push   fs:[ecx]               ; 00403452      64 FF 31
  db 64h,89h,21h  ;//mov    fs:[ecx],esp           ; 00403455      64 89 21
  ;//
  push ebp
  mov  ebp,esp
  ;//
  push eax
  call edx
  ;//
  mov  esp,ebp
  pop  ebp
  ;//
  mov  [esp+18h],eax  ;// Result
  ;//
  xor  eax,eax
  db 64h,8Fh,00h ;//pop    fs:[eax]                         ; 00403467      64 8F 00
  add  esp,byte 8
  jmp short .continue

;//%ifdef AllocTag
;// function MmIsBadWrite(Ptr) - checks write access to one dword at [eax]
MmIsBadWrite:
  push ebp
  mov  ebp,esp
  push byte 1 ;// [ebp-4] = Result = bad unless changed...
  push ebx
  push esi
  push edi
  call .pushed_ehandler ;// = push offset ExcHandler
.ExcHandler:
  ;//      { ->    [ESP+ 4] excPtr: PExceptionRecord       }
  ;//      {       [ESP+ 8] errPtr: PExcFrame              }
  ;//      {       [ESP+12] ctxPtr: Pointer                }
  ;//      {       [ESP+16] dspPtr: Pointer                }
  ;//      { <-    EAX return value - always one   }
  mov  esp,[esp+8]
  jmp short .go_out
  ;//
.pushed_ehandler:
  xor  ecx,ecx
  db 64h,0FFh,31h ;//push   fs:[ecx]               ; 00403452      64 FF 31
  db 64h,89h,21h  ;//mov    fs:[ecx],esp           ; 00403455      64 89 21
  ;//
  or   [eax],ecx   ;// or 0, no change but check write access...
  mov  [ebp-4],ecx ;// return 0 if ok...
  ;//
.go_out:
  xor  eax,eax
  db 64h,8Fh,00h ;//pop    fs:[eax]                         ; 00403467      64 8F 00
  pop  edx ;// pop ExcHandler
  ;//jmp short .continue
.continue:
  pop  edi
  pop  esi
  pop  ebx
  pop  eax
  pop  ebp
  ret
;//%endif ;AllocTag

;//--------------------------------------------------------------------
align 4

MmGetMainPool:
  mov  edx,g_MainMmPool ;//!!!todo seg_Data ?!
  mov  eax,[edx]
  test eax,eax
  jz   .init
  ret
.init:
  push edx ;// ^g_MainMmPool
  ;//
  push ebp
  mov  ebp,esp
  ;// make VirtPool:
  sub  esp,byte vp__sizeOf
  mov  eax,esp
  call MmGetDefVirtPager
  ;//
  xor  edx,edx ;// no Owner
  call MmCreatePool
  ;//
  mov  byte [eax+mpool_IsMain],1
  ;//
  ;//%ifdef xulDebug
  ;//mov  byte [eax+mpool_DbgPending],1
  ;//%endif ;xulDebug
  ;//
  mov  esp,ebp
  pop  ebp
  ;//
  pop  edx ;// ^g_MainMmPool
  mov  [edx],eax
  ;//
    %ifdef LogAlloc
    push eax
    call InitLog
      push 't: >'
      push 'Star'
      push byte 8
      call LogWrite
    pop  eax
    %endif ;LogAlloc
  ;//
  ret

;// function MmEntryMainPool(hKernel32): PMmPool; stdcall;
;// [esp+4] = hKernel32 (optional)
MmEntryMainPool:
  mov  eax,[esp+4]
  call init_Kernel
  call MmGetMainPool
  retn 4

;//--------------------------------------------------------------------
%ifdef LogAlloc

g_LogSpace  equ 0F000000h
;//c_LogSize   equ 100000h  ;// 1Mb buffer
c_LogSize   equ 800000h  ;// 8Mb buffer

;// function InitLog() -- allocate cyclic logging buffer...
InitLog:
  push ebx
  push edi
  ;//
  mov  ebx,g_LogInfo  ;// fixed pointer to BSS segment
  mov  edi,c_LogSize
  ;//
  cmp  dword [ebx+off_LogBase],byte 0
  jne  .fail ;// already...
  ;//
  push edi
  push g_LogSpace
  call MmVReserve
  push edi
  push eax
  call MmVCommit
  test eax,eax
  jz   .fail
  mov  [ebx+off_LogBase],eax
  mov  [ebx+off_LogWrite],eax
  add  eax,edi
  mov  [ebx+off_LogEnd],eax
  mov  byte [ebx],1 ;// off_LogEnabled g_LogEnabled
  ;//
.fail:
  pop  edi
  pop  ebx
  ret

;// function LogWrite(Size,...) stdcall
;// [esp+4]=Size, [esp+8]=WriteData
;// preserves eax, pops params...
LogWrite:
  mov  ecx,g_LogEnabled
  cmp  byte [ecx],0
  jz .skipLog
.dolog:
  mov  ecx,[esp+4]
  lea  edx,[esp+8]
  push edi
  push esi
  push ebx
  push eax
  ;//
  mov  esi,edx
  mov  ebx,g_LogInfo  ;// fixed pointer
.retry:
  mov  edi,[ebx+off_LogWrite]
  test edi,edi
  jz   .out
  mov  eax,edi
  lea  edx,[edi+ecx]
  cmp  edx,[ebx+off_LogEnd]
  ja   .restart_log
.get_space:
  lock cmpxchg [ebx+off_LogWrite],edx
  jnz  .retry_f
  ;// copy data:
  push ecx
  shr  ecx,2
  rep  movsd
  pop  ecx
  and  ecx,byte 3
  rep  movsb
  ;//
.out:
  pop  eax
  pop  ebx
  pop  esi
  pop  edi
  ;// variable retn
.skipLog:
  pop  edx ;// ret-address
  pop  ecx ;// size
  add  esp,ecx
  jmp  edx
  ;//
.restart_log:
  ;// clear buffer to end:
  mov  edx,[ebx+off_LogEnd]
  lock cmpxchg [ebx+off_LogWrite],edx
  jne  .retry_f
  push ecx
  mov  ecx,edx
  sub  ecx,edi
  jle  .no_rest
  mov  al,'.'
  rep  stosb
.no_rest:
  pop  ecx
  mov  eax,edx
  mov  edi,[ebx+off_LogBase]
  lea  edx,[edi+ecx]
  inc  dword [ebx+off_LogWrap] ;// count buffer wraps
  ;//
  cmp  edx,[ebx+off_LogEnd]
  jb  .get_space
  ;// writing too much... instead write 4 bytes:
  call .ovr
  db 90h,90h,90h,90h
  .ovr:
  pop  esi
  push byte 4
  pop  ecx
  lea  edx,[edi+ecx]
  jmp short .get_space
  ;//
.retry_f:
  db 0F3h
  nop
  jmp short .retry

%endif ;LogAlloc

;//--------------------------------------------------------------------
;// hook mozglue.dll malloc,realloc,free,...
;// now there are two possible DLLs for revectoring malloc calls
;// depending on ifdef it hooks mozglue.dll and/or msvcrt.dll
%ifdef C_MEM_Handlers
  _name_malloc:          db 'malloc',0
  _name_calloc:          db 'calloc',0
  _name_free:            db 'free',0
  _name_realloc:         db 'realloc',0
  _name__recalloc:       db '_recalloc',0
  _name__expand:         db '_expand',0
  _name__aligned_malloc: db '_aligned_malloc',0
  _name__aligned_free:   db '_aligned_free',0
  ;//
  %ifdef Link_MOZGLUE ;// mozglue-specific:
  _name_malloc_u_s:      db 'malloc_usable_size',0
  _name_posix_memalign:  db 'posix_memalign',0
  _name_jemalloc_stats:  db 'jemalloc_stats',0
  %endif ;mozglue
  ;//
  %ifdef Link_MSVCRT ;// msvcrt-specific:
  _name__msize:          db '_msize',0
  %endif ;msvcrt
  ;//
%endif

%ifdef Link_MOZGLUE
%define Link_Revector

;// function InitMozGlue()
InitMozGlue:
  call .pushed_funcTable
  dw (C_malloc-$),(_name_malloc-$)
  dw (C_calloc-$),(_name_calloc-$)
  dw (C_free-$),(_name_free-$)
  dw (C_realloc-$),(_name_realloc-$)
  dw (C_reCalloc-$),(_name__recalloc-$)
  dw (C_expand-$),(_name__expand-$)
  dw (C_query-$),(_name_malloc_u_s-$) ;// 'malloc_usable_size'
  dw (C_aligned_malloc-$),(_name__aligned_malloc-$) ;// _aligned_free is same as free in mozglue.dll , not in msvcrt.dll
  dw (C_posix_memalign-$),(_name_posix_memalign-$)
  dw (C_jemalloc_stats-$),(_name_jemalloc_stats-$)
  dw 0
.pushed_funcTable:
  call .pushed_dllName
  db 'mozglue.dll',0
.pushed_dllName:
  call RevectorEntries
  ret
%endif ;Link_MOZGLUE


%ifdef Link_MSVCRT
%define Link_Revector

;// function InitMsvcrt()
InitMsvcrt:
  call .pushed_funcTable
  dw (C_malloc-$),(_name_malloc-$)
  dw (C_calloc-$),(_name_calloc-$)
  dw (C_free-$),(_name_free-$)
  dw (C_realloc-$),(_name_realloc-$)
  dw (C_aligned_malloc-$),(_name__aligned_malloc-$)
  dw (C_free-$),(_name__aligned_free-$) ;// _aligned_free is different in msvcrt.dll
  dw (C_query-$),(_name__msize-$)
  ;// hoping _aligned_realloc and various *_dbg are not actually used...?!
  dw 0
.pushed_funcTable:
  call .pushed_dllName
  db 'msvcrt.dll',0
.pushed_dllName:
  call RevectorEntries
  ret
%endif ;Link_MSVCRT


%ifdef Link_Revector
;// function RevectorEntries(DllName,EntryTable) stdcall;  EntryTable is array (offsFunc,offsName words),0
;// [esp+4]=[ebp+8] = DllName, [esp+8]=[ebp+12]=EntryTable
RevectorEntries:
  push ebp
  mov  ebp,esp
  push esi ;// [ebp-4] = save esi
  cld
  ;//
  push dword [ebp+8]
  call GetModuleHandle
  test eax,eax
  push eax ;// [ebp-8] = hDll
  jz   .out
  ;//
  xor  eax,eax
  push eax
  push eax
  push eax
  ;//
  mov  esi,[ebp+12]
.cy1:
  movsx eax,word [esi]
  test eax,eax
  jz   .break1
  push byte PAGE_EXECUTE_READWRITE ;// Protect
  add  eax,esi ;// Handler
  push eax
  movsx eax,word [esi+2]
  add  eax,esi ;// ProcName
  add  esi,byte 4
  ;//
  push eax
  push dword [ebp-8]
  call GetProcAddress
  test eax,eax
  push eax ;// Target
  jz   .out ;// if cannot patch all, do nothing...
  ;// handler and target cannot be same:
  cmp  eax,[esp+4]
  jnz  .cy1
.out:
  lea  esp,[ebp-4]
  pop  esi
  pop  ebp
  retn 8
  ;//
.break1:
  ;// VirtualProtect all or cancel:
  ;// esp = array (Target,Handler,Protect),0
  mov  eax,esp
  call VProtect_Multi3
  test al,al
  jz   .out
  ;//
  mov  esi,esp  ;// array (Target,Handler,unused),0
.cy2:
  lodsd
  mov  edx,eax  ;// Target
  test eax,eax
  jz   .break2
  lodsd         ;// Handler
  ;//
  sub  eax,edx
  sub  eax,byte 5 ;// relative (Handler-Target-5)
  mov  byte [edx],0E9h ;// jmp
  inc  edx
  mov  [edx],eax
  lodsd ;// skip unused
  jmp short .cy2
.break2:
  ;// restore PAGE_EXECUTE (readonly) protection:
  mov  eax,esp
  call VProtect_Multi3
  jmp  short .out

;// function VProtect_Multi3(Table) - Table is array(Target,unused,Protection byte in/out),0
VProtect_Multi3:
  push esi
  mov  esi,eax
  ;//cld
.cy:
  lea  ecx,[esi+8] ;// in/out Protection
  lodsd ;// load Target, move esi=esi+4
  test eax,eax
  jz   .done
  movzx edx,byte [ecx]  ;// Protection low byte
  add  esi,byte 8 ;// 4 already skipped above...
  ;//
  push ecx
  push edx
  push byte 5
  push eax
  call VirtualProtect
  test eax,eax
  jnz  .cy
  ;// failed...
  or   eax,esi
.done:
  setz al ;// return 1 if ok
.out:
  pop  esi
  ret

%endif ;Link_Revector

          %ifdef Link_MOZGLUE__v1
          InitMozGlue_v1:
            push ebp
            mov  ebp,esp
            push esi  ;// [ebp-4] save esi
            ;//
            call .dllName
            db 'mozglue.dll',0
            .dllName:
            call GetModuleHandle
            test eax,eax
            push eax   ;// [ebp-8] hDll
            jz   .out
            ;//
            xor  eax,eax
            push eax   ;// [ebp-12] temp
            push eax
            push eax
            push eax
            call GetMozGlueHandlers ;// returns in EDX
            mov  esi,edx
          .cy1:
            movsx eax,word [esi]
            test eax,eax
            jz  .break1
            add  eax,esi  ;// handler
            push eax
            movzx eax,byte [esi+2]
            add  esi,byte 3
            push esi ;// procname param
            add  esi,eax
            inc  esi
            push dword [ebp-8]  ;// dll
            call GetProcAddress
            test eax,eax
            push eax      ;// target
            jz   .out  ;// if cannot patch all, do nothing...
            ;// handler and target cannot be same:
            cmp  eax,[esp+4]
            je   .out
            ;//
            ;// VirtualProtect(ptr,size,newprot,var oldprot)
            lea  edx,[ebp-12]
            push edx
            push byte PAGE_EXECUTE_READWRITE
            push byte 5
            push eax
            call VirtualProtect
            test eax,eax
            jnz  .cy1
            ;//
          .break2:
          .out:
            lea  esp,[ebp-4]
            pop  esi
            pop  ebp
            ret
            ;//
          .break1:
          .cy2:
            pop  edx  ;// target
            pop  eax  ;// handler
            test eax,eax
            jz   .break2
            sub  eax,edx
            sub  eax,byte 5  ;// relative...
            mov  byte [edx],0E9h ;// jmp
            inc  edx
            mov  [edx],eax
            jmp  short .cy2
          
          GetMozGlueHandlers: ;// returns Handlers in EDX
            call retpop_Edx
          dw (C_malloc-$)
          db 6,'malloc',0
          dw (C_calloc-$)
          db 6,'calloc',0
          dw (C_free-$)
          db 4,'free',0
          dw (C_realloc-$)
          db 7,'realloc',0
          dw (C_reCalloc-$)
          db 9,'_recalloc',0
          dw (C_expand-$)
          db 7,'_expand',0
          dw (C_query-$)
          db 18,'malloc_usable_size',0
          dw (C_aligned_malloc-$)
          db 15,'_aligned_malloc',0  ;// _aligned_free is same as free
          dw (C_posix_memalign-$)
          db 14,'posix_memalign',0
          dw (C_jemalloc_stats-$)
          db 14,'jemalloc_stats',0
          dw 0
          
          %endif ;Link_MOZGLUE__v1 (old)

;//--------------------------------------------------------------------
%ifdef Link_AltD5
;// function InitAltD5(): Boolean
InitAltD5:
  call .push_DllName
  db 'AltD5.bpl',0
.push_DllName:
  call GetModuleHandle
  test eax,eax
  jz   .skip
  ;//
  call .push_ProcName
  db '@System@SetMemoryManager$qqrrx21System@TMemoryManager',0
.push_ProcName:
  push eax
  call GetProcAddress
  test eax,eax
  jz   .skip
  ;//
  call Init_Delphi
  ;//
.skip:
  ret

;// function Init_Delphi(SetMemoryManager): Boolean
Init_Delphi:
  push ebp
  mov  ebp,esp
  push byte 0 ;// [ebp-4] = Result
  push edi    ;// [ebp-8] = save edi
  ;//
  push eax    ;// [ebp-12] = SetMemoryManager
  ;//
  call MmGetMainPool
  test eax,eax
  jz   .out
  ;//
  sub  esp,byte 40
  mov  edi,esp
  xor  eax,eax
  push byte (40/4)
  pop  ecx
  cld
  rep  stosd
  ;//
  mov  edi,esp
  ;//
  call .here24
  .here24:
  pop  edx
  lea  eax,[edx+(DelphiGetMem-.here24)]
  mov  [edi],eax
  lea  eax,[edx+(DelphiFreeMem-.here24)]
  mov  [edi+4],eax
  lea  eax,[edx+(DelphiReallocMem-.here24)]
  mov  [edi+8],eax
  ;//
  mov  eax,edi
  call dword [ebp-12]
  mov  byte [ebp-4],1
  ;//
.out:
  lea  esp,[ebp-8]
  pop  edi
  pop  eax
  pop  ebp
  ret
  ;//

;// function DelphiGetMem(Size): Pointer
align 4
DelphiGetMem:
  mov  edx,eax
  mov  eax,[g_MainMmPool]
  ;//x240316: Use AllocProc instead of MmAlloc directly
  ;//jmp  MmAlloc
  jmp  dword [eax+mpool_AllocProc]
;// function DelphiFreeMem(Ptr): integer
align 4
DelphiFreeMem:
  mov  edx,eax
  mov  eax,[g_MainMmPool]
  call MmFree
  xor  eax,eax
  ret
;// function DelphiReallocMem(Ptr,NewSize): Pointer
align 4
DelphiReallocMem:
  push eax
  mov  ecx,edx
  mov  edx,esp
  mov  eax,[g_MainMmPool]
  call MmReAlloc
  pop  eax
  ret
%endif ;Link_AltD5

;//--------------------------------------------------------------------
%ifdef Start_TEST
StartupTests:
  push ebp
  mov  ebp,esp
  ;//
  call .push_err
.ErrorHandler:
  jmp short $ ;// permanent stop-point...
  xor eax,eax
  ret
.push_err:
  xor  eax,eax
  call .go_Test  ;// = push offset .Test_Inner
  ;//
.Test_Inner:
  push ebx
  call MmGetMainPool
  mov  ebx,eax
  ;//
  push byte 0
  ;//
  ;//mov  edx,64
  push byte 64
  pop  edx
  ;//
  call MmAlloc
  push eax
  ;//
  mov  edx,1000h
  mov  eax,ebx
  call MmAlloc
  push eax
  ;//
  mov  edx,10000h
  mov  eax,ebx
  call MmAlloc
  push eax
  ;//
      %if 0
        %ifdef C_MEM_Handlers
        mov  edx,200h
        push edx
        push edx
        call C_aligned_malloc
        pop  edx
        pop  edx
        push eax
        jmp short $
        %endif
      %endif
  ;//
.fcy:
  pop  edx
  test edx,edx
  jz   .fbreak
  mov  eax,ebx
  call MmFree
  jmp short .fcy
.fbreak:
  pop  ebx
  ;//
  ret
  ;//
.go_Test:
  call ZeroTry
  ;//
  mov  esp,ebp
  pop  ebp
  ret
%endif ;Start_TEST

;//--------------------------------------------------------------------
%ifdef DLL
dll_Entry:
  ;// when called second time, just skip it...
  mov  eax,g_MainMmPool  ;// fixed pointer
  cmp  dword [eax],byte 0
  jnz  .leaveEntry
  ;//
  ;// get kernel32.dll functions...
  call get_Kernel
  ;//
  ;// MmCreatePool g_MainMmPool
  call MmGetMainPool
  ;//
  %ifdef Start_TEST
  call StartupTests
  %endif ;Start_TEST
  ;//
  ;// hook mozglue.dll malloc,realloc,free
  %ifdef Link_MOZGLUE
  call InitMozGlue
  %endif ;Link_MOZGLUE
  ;//
  %ifdef Link_MSVCRT
  call InitMsvcrt
  %endif ;Link_MSVCRT
  ;//
  ;// hook AltD5.bpl for testing...
  %ifdef Link_AltD5
  call InitAltD5
  %endif ;Link_AltD5
  ;//
.leaveEntry:
  ;//mov  eax,1
  push byte 1
  pop  eax
  ;//
  retn 12

%endif ;DLL

align 4
;// function GetProcAddress(hDll,ProcName): Pointer; stdcall;
;// in [ESP+4]=[EBP+8]=hDll , [ESP+8]=[EBP+12]=ProcName
GetProcAddress:
  push ebp
  mov  ebp,esp
  ;//
  push ebx
  push edi
  push esi
  ;//
  mov  ebx,[ebp+8]  ;// hDll
  test ebx,ebx
  jz   .out
  cmp  word [ebx],'MZ'
  jne  .fail
  mov  edx,[ebx+3Ch]
  add  edx,ebx
  cmp  dword [edx],4550h ;//'PE'
  jne  .fail
  mov  edx,[edx+78h] ;// RvaExports
  test edx,edx
  jz   .fail
  add  edx,ebx ;// TImageExportDirectory
  push edx ;// [esp] = ExportDir
  mov  ecx,[edx+18h] ;// NameCount
  test ecx,ecx
  jle  .fail
  mov  esi,[edx+20h]
  add  esi,ebx ;// NameTable
  xor  edi,edi
  cld
.ncy:
  lodsd
  test eax,eax
  jz   .nskip
  add  eax,ebx
  mov  edx,[ebp+12]
  push ecx
  ;//call .SameName
      ;// .SameName - inline...
        dec  eax
        dec  edx
      .sn_next:
        inc  eax
        inc  edx
      .sn_in:
        mov  cl,[eax]
        cmp  cl,[edx]
        jne .diffName
        test cl,cl
        jnz  .sn_next
        ;// same...
      .diffName:
      .sn_done:
  ;//      setz al
      ;//
  pop  ecx
  ;//test al,al
  ;//jnz  .nfound
        jz .nfound
  ;//
.nskip:
  inc  edi
  dec  ecx
  jnz  .ncy
  ;//jmp short .fail
.fail:
  xor  eax,eax
  jmp short .out
  ;//
.nfound:
  mov  eax,[esp] ;// ExportDir
  ;//
  mov  esi,[eax+24h] ;// rva NameOrdinalTable
  add  esi,ebx ;// NameOrdinalTable
  movzx edi,word [esi+2*edi]
  ;//
  mov  edx,[eax+1Ch] ;// rva FuncTable
  add  edx,ebx ;// FuncTable
  ;//x: add  edi,[eax+10h] ;// add ExportDir.OrdinalBase
  mov  edi,[edx+4*edi] ;// RVA
  add  edi,ebx ;// function
  cmp  edi,eax
  mov  eax,edi
  ;//ja   .forward
  jb   .out  ;// below ExportDir are normal functions...
  ;//mov  eax,edi
  ;//jmp short .out
.forward: ;// check if it is forwarded function 'NTDLL.RtlEnterCriticalSection'
  ;//mov  eax,edi
  call .isForward
  ;//jmp short .out
.out:
  lea  esp,[ebp-12]
  pop  esi
  pop  edi
  pop  ebx
  pop  ebp
  retn 8
  ;//
.isForward: ;// eax=func or name - check if it is forwarded function...
  mov  edx,eax
.cyfo1:
  mov cl,[eax]
  cmp cl,'.'
  je  .dotfo1
  sub cl,' '
  jl  .notfo1
  cmp cl,7Fh-' '
  jge .notfo1
  inc eax
  jmp .cyfo1
.notfo1:
  mov eax,edx ;// return original pointer...
  ret
.dotfo1:
  mov ecx,eax
  sub ecx,edx
  push ecx  ;// length of dllname without .dll
.cyfo2:
  inc eax
  mov cl,[eax]
  test cl,cl
  jz  .okfo2
  sub cl,' '
  jl  .notfo2
  cmp cl,7Fh-' '
  jl  .cyfo2
.notfo2:
  pop ecx
  jmp short .notfo1
.okfo2:
  mov  ecx,[esp]
  add  ecx,edx
  inc  ecx ;// start of funcname
  sub  eax,ecx ;// length of funcname
  jle  .notfo2
  ;// is forward name...
  ;// edx=DllName, ECX=FuncName, [esp]=[ebp+4]=length DllName
  push ebp
  mov  ebp,esp
  push edi
  push esi
  push edx ;// [ebp-12] = DllName - not terminated...
  push ecx ;// [ebp-16] = FuncName #0-terminated
  mov  eax,[ebp+4]
  add  eax,byte 4
  and  eax,byte -4
  sub  esp,eax
  mov  edi,esp
  push edi ;// param for GetModuleHandle
  mov  esi,edx
  mov  ecx,[ebp+4]
  rep  movsb
  xor  eax,eax
  stosb
  call GetModuleHandle
  ;//
  push dword [ebp-16]
  push eax
  call GetProcAddress
  ;//
  lea  esp,[ebp-8]
  pop  esi
  pop  edi
  pop  ebp
  pop  ecx
  ret
  ;//
  
;//  .SameName: ;// eax=name1, edx=name2
;//    dec  eax
;//    dec  edx
;//  .sn_next:
;//    inc  eax
;//    inc  edx
;//  .sn_in:
;//    mov  cl,[eax]
;//    cmp  cl,[edx]
;//    jne .diffName
;//    test cl,cl
;//    jnz  .sn_next
;//    ;// same...
;//    mov  al,1
;//    ret
;//  .diffName:
;//    xor  eax,eax
;//    ret

align 4
;// kernel32.dll externals:
EnterCriticalSection:
%ifdef DLL
  ;// optimize time-critical code... may not be first kernel call...
  jmp dword [g_Kernel+off_EnterCriticalSection]
%else
  call get_Kernel
  add  eax,byte off_EnterCriticalSection
  jmp  dword [eax]
%endif
  ;//
LeaveCriticalSection:
%ifdef DLL
  ;// optimize time-critical code... may not be first kernel call...
  jmp dword [g_Kernel+off_LeaveCriticalSection]
%else
  call get_Kernel
  add  eax,byte off_LeaveCriticalSection
  jmp  dword [eax]
%endif
  ;//
InitializeCriticalSection:
  call get_Kernel
  add  eax,byte off_InitializeCriticalSection
  jmp  dword [eax]
  ;//
DeleteCriticalSection:
  call get_Kernel
  add  eax,byte off_DeleteCriticalSection
  jmp  dword [eax]
  ;//
RtlUnwind:
  call get_Kernel
  add  eax,byte off_RtlUnwind
  jmp  dword [eax]
  ;//
VirtualAlloc:
  call get_Kernel
  add  eax,byte off_VirtualAlloc
  jmp  dword [eax]
  ;//
VirtualFree:
  call get_Kernel
  add  eax,byte off_VirtualFree
  jmp  dword [eax]
  ;//
;// for mozglue patching:
VirtualProtect:
  call get_Kernel
  add  eax,byte off_VirtualProtect
  jmp  dword [eax]
  ;//
;// for collect thread:
GetCurrentThreadId:
  call get_Kernel
  add  eax,byte off_GetCurrentThreadId
  jmp  dword [eax]
  ;//
GetExitCodeThread:
  call get_Kernel
  add  eax,byte off_GetExitCodeThread
  jmp  dword [eax]
  ;//
CloseHandle:
  call get_Kernel
  add  eax,byte off_CloseHandle
  jmp  dword [eax]
  ;//
CreateThread:
  call get_Kernel
  add  eax,byte off_CreateThread
  jmp  dword [eax]
  ;//
IsBadWritePtr:
  call get_Kernel
  add  eax,byte off_IsBadWritePtr
  jmp  dword [eax]
  ;//
Sleep:
  call get_Kernel
  add  eax,byte off_Sleep
  jmp  dword [eax]
  ;//
;// for GetProcAddress:
GetModuleHandle:
  call get_Kernel
  add  eax,byte off_GetModuleHandle
  jmp  dword [eax]
  ;//

align 4
;// function init_Kernel(hKernel32)
init_Kernel: ;// in EAX=hKernel32 or nil
  mov  edx,eax
  mov  eax,g_Kernel ;//!!! fixed pointer ?!
  jmp  init_Kernel2

align 4
;// function get_Kernel()
get_Kernel:
  mov  eax,g_Kernel  ;//!!! fixed pointer ?!
  xor  edx,edx
  ;// note: first need GetModuleHandle before forwarded EnterCriticalSection:
  cmp  dword [eax+off_GetModuleHandle],byte 0
  ;//no! cmp  dword [eax+off_EnterCriticalSection],byte 0
  jz   init_Kernel2
  ret
init_Kernel2: ;// in EAX=^g_Kernel, EDX=hKernel32 if available...
  push eax
  call GetHKernel
  pop  edx
  ;//
  test eax,eax
  jnz  InitKernel
  ret
  ;//
InitKernel: ;// in EAX=HKernel32, EDX=^g_Kernel
  push edx ;// returns g_Kernel ...
  push edi
  push esi
  push ebx
  cld
  mov  edi,edx
  mov  esi,edx
  stosd ;// [g_Kernel] = HKernel32
  ;//
  ;//mov ecx,n_Kernel_Funcs
  push byte n_Kernel_Funcs
  pop  ecx
  ;//
  call .InitFuncs
.FuncNames:
  ;// n_Kernel_Funcs names as in g_Kernel segment:
  dw .GetModuleHandle           - $  ;// must be first, required for forwarded functions...
  dw .EnterCriticalSection      - $
  dw .LeaveCriticalSection      - $
  dw .InitializeCriticalSection - $
  dw .DeleteCriticalSection     - $
  dw .RtlUnwind                 - $
  dw .VirtualAlloc              - $
  dw .VirtualFree               - $
  dw .VirtualProtect            - $
  dw .GetCurrentThreadId        - $
  dw .GetExitCodeThread         - $
  dw .CloseHandle               - $
  dw .CreateThread              - $
  dw .IsBadWritePtr             - $
  dw .Sleep                     - $
.GetModuleHandle: db 'GetModuleHandleA',0
.EnterCriticalSection: db 'EnterCriticalSection',0
.LeaveCriticalSection: db 'LeaveCriticalSection',0
.InitializeCriticalSection: db 'InitializeCriticalSection',0
.DeleteCriticalSection: db 'DeleteCriticalSection',0
.RtlUnwind: db 'RtlUnwind',0
.VirtualAlloc: db 'VirtualAlloc',0
.VirtualFree: db 'VirtualFree',0
.VirtualProtect: db 'VirtualProtect',0
.GetCurrentThreadId: db 'GetCurrentThreadId',0
.GetExitCodeThread: db 'GetExitCodeThread',0
.CloseHandle: db 'CloseHandle',0
.CreateThread: db 'CreateThread',0
.IsBadWritePtr: db 'IsBadWritePtr',0
.Sleep: db 'Sleep',0
  ;//
.InitFuncs:
  pop ebx ;// offset .FuncNames
  ;//
.fucy1:
  movzx eax,word [ebx]
  add eax,ebx
  push ecx
  ;//
  push eax
  push dword [esi]
  call GetProcAddress
  stosd
  ;//
  pop  ecx
  add  ebx,byte 2
  dec  ecx
  jnz  .fucy1
  ;//
  pop  ebx
  pop  esi
  pop  edi
  pop  eax ;// return g_Kernel
  ret
  ;//

;// function GetHKernel(^g_Kernel,hKernel32)
GetHKernel: ;// in EAX=^g_Kernel, EDX=hKernel32 if available, returns [g_Kernel] possibly hKernel32 ...
  mov  ecx,eax
  mov  eax,[eax]
  test eax,eax
  jz   .find_Kernel
  ret
.find_Kernel:
  mov  eax,ecx
  test edx,edx
  jz .find2
  ;//
  push eax ;// ^g_Kernel
  push edx ;// hKernel32
  ;//
  mov  eax,edx
  call IsKernel32_dll
  test al,al
  ;//
  pop  edx
  pop  eax
  ;//
  jz .find2
.found: ;// eax=^g_Kernel, edx=hKernel32, returns hKernel32
  mov  [eax],edx
  mov  eax,edx
  ret
  ;//
.find2:
  push eax
  ;// if we already have GetModuleHandle, use it:
  ;//!!!todo - no imports yet! (can remove following block)
  %ifdef DLL
    mov  eax,[imp_GetModuleHandle]   ;//!!! fixed pointer
    test eax,eax
    jz .skipGmh
    call .push_DllName
    db 'kernel32.dll',0
  .push_DllName:
    call eax
    test eax,eax
    jnz .found2
  .skipGmh:
  %endif
  ;//
  mov  eax,7F000000h  ;// start below this address...
.f2cy:
  sub  eax,10000h
  cmp  eax,esp
  jbe  .f2break
  ;//mov  [g_Mm_BadPtr],eax ;// for debuging...
  push eax
  call IsKernel32_dll
  test al,al
  pop  eax
  jz   .f2cy
.found2:
  mov  edx,eax
  pop  eax
  jmp short .found
.f2break:
  ;// not found ?!
  xor  edx,edx
  pop  eax
  jmp short .found

;// function IsKernel32_dll(ImageBase)
IsKernel32_dll: ;// in EAX=hKernel32, out AL=1 if ok...
  push byte 0 ;// no ErrorHandler
  push eax    ;// Param
  call .chk2  ;// push offset .CheckProc
.CheckProc:
  call GetDllName
  test eax,eax
  jz   .none
  call IsKernel32_Name
.none:
  ret
.chk2:
  call ZeroTry
  ret

;// function IsKernel32_Name(Str)
IsKernel32_Name: ;// in EAX=^'KERNEL32.dll',0  out AL=1 if ok
  cmp  byte [eax+8],'.'
  jne  .diff
  mov  edx,[eax]
  xor  edx,'KERN'
  and  edx,0DFDFDFDFh
  jnz  .diff
  mov  edx,[eax+4]
  xor  edx,'EL32'
  and  edx,0FFFFDFDFh
.diff:
  setz al
  ret
  
;// function GetDllName(ImageBase)
GetDllName: ;// in EAX=ImageBase, out EAX=0-terminated DllName 'KERNEL32.dll',0 or nil
  cmp  eax,10000h
  jb   .none
  cmp  word [eax],'MZ'
  jne  .none
  mov  edx,[eax+3Ch]
  add  edx,eax
  cmp  dword [edx],4550h ;// 'PE'
  jne  .none
  mov  edx,[edx+78h]
  test edx,edx
  jz   .none
  add  edx,eax ;// TImageExportDirectory
  mov  edx,[edx+12] ;// RvaName
  test edx,edx
  jz   .none
  add  eax,edx ;// ^Name
  ret
.none:
  xor  eax,eax
  ret

;//db 0CCh
align 16,db 0
db 'Code by P.A.Semi 2013-2024',0

align 16,db 0
db 'V.21c'
%ifdef AllocTag
  db ' a-tag'
%else
  %ifdef ErrHalt
    db ' debug'
  %endif
%endif
%ifdef LogAlloc
  db ' log'
%endif
db 0

__end_Code equ $

;//size_Code equ __end_Code - start_Code

%ifdef DLL

;//align 1000h,db 0
TIMES (end_Code + 400h - ($-$$)) db 0

%include "MozMem_exports.inc"

%endif ;DLL

